/* AutoCAD Definitions */

	/* AutoCAD colors--Display "chroma.dwg" in AutoCAD and
	select the colors you like.  Here is a sample for VGA. */
#define RED  	1
#define YELLOW  2
#define GREEN   3
#define CYAN    4
#define BLUE    5
#define MAGENTA 6
#define WHITE   7
#define BLACK   8

#define GREY 	11	
#define DARKRED	14
#define BROWN   19
#define DARKGRN 82
#define GREYGRN 112
#define BRIGHTBLUE 150
#define DARKBLUE 162
#define DARKMAG 192 






	/* AutoCAD DXF Group Codes */
#define G_START       0               /* start of item - text follows */
#define G_END         0               /* end of item - text follows */
#define G_PNAME       1               /* primary name string */
#define G_ATTRNAM     1               /* attribute name */
#define G_SECNAME     2               /* section name */
#define G_STNAME      2               /* symbol table name */
#define G_TAGNAME     2               /* tag name */
#define G_BLNAME      2               /* block name */
#define G_SHNAME      2               /* shape name */
#define G_LTTEXT      3               /* linetype prose text */
#define G_TSTEXT      3               /* text style text */
#define G_TSTEX2      4               /* text style second text string */
#define G_HANDLE      5               /* database handle */
#define G_LTNAME      6               /* linetype name */
#define G_TSNAME      7               /* text style name */
#define G_LYNAME      8               /* layer name */
#define G_VARNAM      9               /* header variable name */
#define G_XCOORD     10               /* x coordinate */
#define G_SXCOORD    10               /* start x coordinate */
#define G_EXCOORD    11               /* ending x coordinate */
#define G_YCOORD     20               /* y coordinate */
#define G_SYCOORD    20               /* start y coordinate */
#define G_EYCOORD    21               /* ending y coordinate */
#define G_ZCOORD     30               /* z coordinate */
#define G_SZCOORD    10               /* start z coordinate */
#define G_EZCOORD    11               /* ending z coordinate */
#define G_ZELEV      38               /* z elevation */
#define G_ZTHICK     39               /* z thickness */
#define G_REAL       40               /* real number */
#define G_TSXFAC     41               /* text style x factor */
#define G_TSSIZE     42               /* text style size */
#define G_LTDASHS    49               /* linetype dash size */
#define G_ANGLE      50               /* angle */
#define G_SANGLE     50               /* start angle */
#define G_EANGLE     51               /* ending angle */
#define G_LLTYPE     61               /* layer line type */
#define G_COLOR      62               /* color number */
#define G_TXTINX     64               /* text index */
#define G_BLKINX     65               /* block index */
#define G_ATFLAG     66               /* attribute flag */
#define G_INT        70               /* integer number */
#define G_SHORT      70               /* short number */
/* The 210-240 code range is to be used for vectors, with the
   parallel meaning to the 10-40 range used for points. WCA */
#define G_NXCOORD   210               /* normal vector x coordinate */
#define G_NYCOORD   220               /* normal vector y coordinate */
#define G_NZCOORD   230               /* normal vector z coordinate */

#define G_COMMENT   999               /* comment line follows */

/* Group class codes.  Group class = group code / 10 */
#define GC_STRING     0               /* string i/o */
#define GC_XVAL       1               /* x value follows */
#define GC_2POINT     1               /* two points x,y */
#define GC_YVAL       2               /* y value follows */
#define GC_3POINT     3               /* three points x,y,z */
#define GC_ZVAL       3               /* z value follows */
#define GC_REAL       4               /* real number output */
#define GC_ANGLE      5               /* angle specification */
#define GC_INTA       6               /* integer variables */
#define GC_INTB       7               /* more integer variables */
/* Class codes obtained from pseudo codes follow */
#define GC_CHAR      10               /* character variables */
#define GC_LONG      11               /* long variables */
#define GC_TDATE     12               /* times and dates--REAL externally */
/* Normal Vector Group Class Codes. Group class = (group code / 10) */
#define GC_NXVAL     21               /* x value follows */
#define GC_NYVAL     22               /* y value follows */
#define GC_NZVAL     23               /* z value follows */

