/*****************************************************************************
      CALERR.H
      (C) Copyright 1988-1993 by Autodesk, Inc.

      This program is copyrighted by Autodesk, Inc. and is  licensed
      to you under the following conditions.  You may not distribute
      or  publish the source code of this program in any form.   You
      may  incorporate this code in object form in derivative  works
      provided  such  derivative  works  are  (i.) are  designed and 
      intended  to  work  solely  with  Autodesk, Inc. products, and 
      (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright  
      1988-1993 by Autodesk, Inc."

      AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
      AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
      CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
      DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
      UNINTERRUPTED OR ERROR FREE.

  Description: Header file for calerr.c

*****************************************************************************/


/****************************************************************************/
/*  EXPORTED VARIABLES AND FUNCTIONS                                        */
/****************************************************************************/

extern int cal_err;                   /* Error number, 0 means O.K. */


/****************************************************************************/
/*.doc error(external)*/
/*+
  Error reporting function. 'n' is the error number, 'str' is an additional 
  string argument which is printed only in some error messages. 

  If the error number 'n' is 0, then the string 'str' is printed 
  instead of a message from the 'error_messages' array.

  The function does nothing if 'cal_err' is already non-zero, avoiding 
  chained error messages.
-*/
/****************************************************************************/

void error _((int n, char *str));



