/*****************************************************************************
      CALEXPR.H
      (C) Copyright 1988-1993 by Autodesk, Inc.

      This program is copyrighted by Autodesk, Inc. and is  licensed
      to you under the following conditions.  You may not distribute
      or  publish the source code of this program in any form.   You
      may  incorporate this code in object form in derivative  works
      provided  such  derivative  works  are  (i.) are  designed and 
      intended  to  work  solely  with  Autodesk, Inc. products, and 
      (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright  
      1988-1993 by Autodesk, Inc."

      AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
      AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
      CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
      DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
      UNINTERRUPTED OR ERROR FREE.

  Description: Header file for calexpr.c

*****************************************************************************/


/****************************************************************************/
/*  TYPEDEFS                                                                */
/****************************************************************************/

typedef enum { vector_type, real_type, int_type, no_type } value_type;

typedef struct                        /* The value of the expression */
{
   value_type type;                   /* Type of the value       */
   double     v[3];                   /* Used for vectors        */
   double     r;                      /* Used for reals/integers */
} vector_real_int;


/****************************************************************************/
/*  EXPORTED FUNCTIONS                                                      */
/****************************************************************************/

int cal_evaluate_expression _((char *line, vector_real_int *value));



