/*


                     General Purpose Functions

        Generic Link List, Text List, and File List.
        Bit Map, Timer, Message Box, Thread, Memory Allocation,
                    Copying Huge Objects.

*/


/* Ensure that C++ modules use the right linking conventions when calling
   functions contained in C. */
#ifdef __cplusplus
    extern /*MSG0*/"C" {
#endif





extern char RealScan[];
extern int FpPrecision;

extern char NullStr[];
extern char Lf[];
extern char CrLf[];
extern char TabStr[];
extern char DdeError[];

extern char FldSep[];
extern char *FldSepStr;
extern char FldSepChr;

extern char RecSep[];
extern char *RecSepStr;
extern char RecSepChr1;
extern char RecSepChr2;

#define NUMPAGES 10                   /* Allow 10 64k pages of heap space. */   

#define USEFCVT 1                     /* Use fcvt() instead of sprintf().*/
#define USEATOF 1                     /* Use atof() instead of
                                         sscanf(). */
#define USEFABS 0                     /* use fabs() instead of 
                                         if (x < 0) x = 0.0 - x; */

#define LF      0x0a
#define CR      0x0d
#define TAB     0x09
#define SP      0x20
#define COMMA   0x2c

#define MAXFNAM 12                    /* file name maximum */   
#define MAXPATH 144                   /* limit of path name length */


/* max decimal position of floating point value, before switching
   to e+ format. */
#define FPMAX 16

/* string storage length for callers to FloatToStr */
#define FPSTR 40         


#ifndef EOS
#define EOS '\0'
#endif

         /* Structure for table of AutoCAD function (or command) names
         and corresponding C function names */
struct _CMDTAB {  
        char *cmdname;
        void (*cmdfunc)();
        };
typedef struct _CMDTAB CMDTAB;

#define ELEMENTS(array) (sizeof(array)/sizeof((array)[0]))


#define SEGLEN 0x10000L             /* length of segment, for huge
                                        allocation */
#define SUCCESS 1
#define FAIL    0
#define STRFAIL -1

#define NUMERIC 1
#define STRING  2


        /* Bit map */
#define BITWORDLEN 16
#define BITMAPFULL 0xffff


struct tagTlink {
    struct tagTlink *next;
    char *text;
};
typedef struct tagTlink Tlink;
typedef Tlink *PLINK;



#define BITWORDLEN 16                   /* Bitmap word length */

typedef unsigned int uint;

/* All Function Prototypes for winutil.c */

void *AddText(void **TextList, char *Str);
void *InTextList(void *TextList, char *Str);
void *RemoveText(void **TextList, char *Str);
void *FreeText(void **TextList, void *TextLink);
void *AddLink(void **List, int LinkSize);
void *FreeLink(void **List, void *link, int LinkSize);
void *GetNextLink(void *List, void *LastLink);
void *RemoveLink(void **List, void *Target);
void FreeList(void **List, int NodeSize);
void *GetLastLink(void *ListStart);
int GetListLen(void *List);
int SetNextBit(USHORT *BitMap, UINT MapLen);
int CheckBit(USHORT *BitMap, UINT Number);
void ClearBit(USHORT *BitMap, UINT Number);
int SetBit(USHORT *BitMap, UINT Number);
int FindEmptyBit(USHORT *BitMap, UINT MapLen);
char *FieldSave(char *Word);
int strzcpy(char *dest, char *source, int maxstr);
char huge *AllocHuge(long DataLen, int ShareFlag);
void huge *AllocFlex(long Len, long *ActualLen);
char far *AllocFar(long DataLen, int ShareFlag);
int FreeFar(char *ptr);
void resource_msg(void);
int MsgBox(char *Msg1, char *Msg2);
BOOL CheckBreakKey(WORD wParam, DWORD lParam);
short StrToReals(PHDATA DataStrm, double *RealAry,
                 short nRow, short nCol);
PHDATA RealsToStr(double *RealAry, int nRow, int nCol,
                 ULONG *DataSize);
double StrToReal(char *stream);
void RealToStr(double fvalue, char *strbuff);
char *GetNextFld(PHDATA pData, short *Separator);
int store_string(char **poldstr, char *newstr);
void getpath(char *fullname, char *path, char *fname);
void delslash(char *filename);
int special_path(char *path);


#ifdef __cplusplus
    }
#endif


/** End of File **/
