/* Next available MSG number is   11 */

/*	WINADS.C

	Windows ADS: WinMain and DDE for ADS Developers

     ________________________________________________________________________

      (C) Copyright 1990-1994 by Autodesk, Inc.

      Permission to use, copy, modify, and distribute this software and its
      documentation for any purpose and without fee is hereby granted.

      THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
      ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF
      MERCHANTABILITY ARE HEREBY DISCLAIMED.
     ________________________________________________________________________

*/

#define MAIN
#define NOCOMM

#ifdef __WATCOMC__
#define INCLUDE_DDEML_H
#define WATADS
/* #define ADS_SHOW_WIN */		/*** DEBUG ***/
#endif

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#ifdef HCWIN
#include <dos.h>
#endif
#include "windde.h"
#include <stdarg.h>

#ifdef HCWIN
typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
#endif

#ifdef WATADS
#define EM_INEXACT EM_PRECISION
#endif


#if defined(WATADS) || defined(HCWIN)
extern int    _argc;
extern char **_argv;
#define vargc _argc
#define vargv _argv
#endif

#ifdef _MSC_VER
extern int    __argc;
extern char **__argv;
#define vargc __argc
#define vargv __argv
#endif

#define CSYSTEMITEMS	3
#define CADSITEMS	1
#define CTOPICS 	2
#define CFORMATS	2

#define iAdsTopic	1	      /* Index of ADS Topic in topic list */

/* Exported variables */
HANDLE adsw_hInstance;
char adsw_AppName[40];		      /* name normally supplied by rc file */
HWND adsw_hWnd;
HWND adsw_hwndAcad = (HWND)0;	      /* Set during communication with LISP */
ATOM adsw_AcadAtom;
HSZ adsw_hItemName = NULL;
WORD adsw_wm_Ads;		      /* Used by message sync to LISP */
char adsw_helpfile[MAXPATH];	      /* Windows help file name */

/* Local data */
static int adsw_brkflg = FALSE;       /* ^C pressed while this process
					 had focus (owned keyboard) */
static HSZ hszAdsTopic = (HSZ)0;


#ifdef WATADS
static HANDLE HdllDdeml;
#endif

/*
    Topic and Item tables supported by this application.
 */
static HDDEDATA TopicListXfer(PXFERINFO pXferInfo, WORD iFmt);
static HDDEDATA ItemListXfer(PXFERINFO pXferInfo, WORD iFmt);
static HDDEDATA sysFormatsXfer(PXFERINFO pXferInfo, WORD iFmt);

#ifdef HCWIN
static ITEMLIST SystemTopicItemList[CSYSTEMITEMS];
static ITEMLIST AdsTopicItemList[CADSITEMS];
static FORMATINFO aFormats[CFORMATS];
static TOPICLIST topicList[CTOPICS];
#else /* HCWIN */
/* Associate DDE topics with list building functions--only used
   if an application requests information from us using the topic
   "System" and the DDE REQUEST message.  Eg, for a DDE REQUEST on
   app "AutoCAD", topic "System", here is the list of items and
   returned lists:
     ITEM	 LIST
   "Topics"   "System"
   "SysItems" "Topics\tSysItems\tFormats"
   "Formats"  "CF_TEXT\tACADOL"
*/
static ITEMLIST SystemTopicItemList[CSYSTEMITEMS] = {
    /* "Topics" */
    { 0, TopicListXfer,  SZDDESYS_ITEM_TOPICS	},
    /* "SysItems" */
    { 0, ItemListXfer,	 SZDDESYS_ITEM_SYSITEMS },
    /* "Formats" */
    { 0, sysFormatsXfer, SZDDESYS_ITEM_FORMATS	},
};

/* Associate ADS/DDE "item" names with callback handler functions */
static ITEMLIST AdsTopicItemList[CADSITEMS] = {
    { 0, adsw_acadcb,	 ADSITEM },
};

/* Clipboard/DDE formats we support.  First slot will hold string handle. */
static FORMATINFO aFormats[CFORMATS] = {
    { 0, /*MSG0*/"CF_TEXT" },         /* exception!  predefined format */
    { 0, ACADOLFMT  },		      /* adsw_AcadAtom */
};

/* Associate topics with their item lists.  The system topic is
   always assumed to be first.	If the ADSTOPIC is moved to another
   slot in the array, change iAdsTopic.
    HSZ   PROCEDURE	       #ofITEMS        PSZ     */
static TOPICLIST topicList[CTOPICS] = {
    { 0, SystemTopicItemList,	CSYSTEMITEMS,	SZDDESYS_TOPIC },
    { 0, AdsTopicItemList,	CADSITEMS,	ADSTOPIC },
};
#endif /* HCWIN */



static HSZ hszAppName = NULL;
static int linkedAcad = FALSE;
static WORD LastDdeError;
static char classname[40];


/* Functions */
int ads_main (int argc, char **argv);	  /* would be main for
					     non-Windows ADS */
int PASCAL WinMain (HANDLE, HANDLE, LPSTR, int);
extern long FAR PASCAL adsw_win_proc (HWND, unsigned, WORD, LONG);

#if defined(WATADS) || defined(HCWIN)
HDDEDATA FAR PASCAL adsw_dde_callback(WORD wType, WORD wFmt, HCONV hConv,
		  HSZ hszTopic, HSZ hszItem, HDDEDATA hData,
		  DWORD lData1, DWORD lData2);
#else
HDDEDATA EXPENTRY adsw_dde_callback(WORD wType, WORD wFmt, HCONV hConv,
		  HSZ hszTopic, HSZ hszItem, HDDEDATA hData,
		  DWORD lData1, DWORD lData2);
#endif

#ifdef HCWIN
static void _fmemcpy(LPVOID dst, LPVOID src, unsigned len);
#endif

static void CreateAtoms(void);
static void FreeAtoms(void);

static HANDLE Hdlladi = NULL;

#ifdef WATADS
HINDIR swHandle, sdHandle;
typedef FARPROC ACADADIPROC;
#else  /* WATADS */
#ifdef HCWIN
LPFARPROC swHandle, sdHandle;
typedef LPFARPROC ACADADIPROC;
#define GetIndirectFunctionHandle(a,b,c) a
#else  /* HCWIN */
typedef void (FAR PASCAL*     ACADADIPROC)(HWND);
ACADADIPROC swHandle;
ACADADIPROC sdHandle;
#define GetIndirectFunctionHandle(a,b,c) a
#endif /* HCWIN */
#endif /* WATADS */

int PASCAL
WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine,
	 int nCmdShow)
{
    WNDCLASS wndclass;
    MSG msg;
    HANDLE PrevInst;
#ifndef _MSC_VER
    int arg_c;
    char **arg_v;
#endif
    ACADADIPROC addr;

#ifdef HCWIN
    SystemTopicItemList[0].hszItem = 0;
    SystemTopicItemList[0].npfnCallback = TopicListXfer;
    SystemTopicItemList[0].pszItem = SZDDESYS_ITEM_TOPICS;
    SystemTopicItemList[1].hszItem = 0;
    SystemTopicItemList[1].npfnCallback = ItemListXfer;
    SystemTopicItemList[1].pszItem = SZDDESYS_ITEM_SYSITEMS;
    SystemTopicItemList[2].hszItem = 0;
    SystemTopicItemList[2].npfnCallback = sysFormatsXfer;
    SystemTopicItemList[2].pszItem = SZDDESYS_ITEM_FORMATS;

    AdsTopicItemList[0].hszItem = 0;
    AdsTopicItemList[0].npfnCallback = adsw_acadcb;
    AdsTopicItemList[0].pszItem = ADSITEM;

    aFormats[0].atom = 0;
    aFormats[0].sz = "CF_TEXT";
    aFormats[1].atom = 0;
    aFormats[1].sz = ACADOLFMT;

    topicList[0].hszTopic = 0;
    topicList[0].pItemList = SystemTopicItemList;
    topicList[0].cItems = CSYSTEMITEMS;
    topicList[0].pszTopic = SZDDESYS_TOPIC;
    topicList[1].hszTopic = 0;
    topicList[1].pItemList = AdsTopicItemList;
    topicList[1].cItems =  CADSITEMS;
    topicList[1].pszTopic = ADSTOPIC;
#endif /* HCWIN */

    adsw_hInstance = hInstance;
    if (!LoadString(hInstance, 1, adsw_AppName, sizeof(adsw_AppName)))
        sprintf(adsw_AppName, "ADS App-%04x", hInstance);

    /* mask off floating-point overflow, i.e. make it return INF */
#define ALL (EM_INVALID|EM_DENORMAL|EM_ZERODIVIDE|EM_OVERFLOW|EM_UNDERFLOW|EM_INEXACT)
    _control87(ALL, MCW_EM);
#undef ALL


    PrevInst = hPrevInstance;

#if defined(WATADS) || defined(HCWIN)
    if (!hPrevInstance)
	strcpy(classname, adsw_AppName);
    else
        sprintf(classname,"%s%04x", adsw_AppName, hInstance);
    PrevInst = 0;				/* Always Register Class */
#else
	strcpy(classname, adsw_AppName);
#endif

    if (!PrevInst) {
	memset(&wndclass, 0x00, sizeof(WNDCLASS));
	wndclass.style = 0;
	wndclass.lpfnWndProc = (WNDPROC)adsw_win_proc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(hInstance, adsw_AppName);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = classname;

	if (!RegisterClass(&wndclass)) {
	    char *buf = malloc(80);
            sprintf(buf, /*MSG5*/"Error registering class %s", adsw_AppName);
	    adsw_msg_box(0, buf);
	    free(buf);
	    return 0;
	}
    }

    adsw_wm_Ads = RegisterWindowMessage(/*MSG0*/"WM_ACADADS");

    CreateWindow(
		classname,
		adsw_AppName,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, hInstance, NULL);

    /* adsw_hWnd set by WM_CREATE below */
    if (adsw_hWnd == (HWND)0) {
        adsw_msg_box(0, /*MSG6*/"Error creating window");
	return 0;
    }

    /* Communication to lisp and acad is done through acadadi.dll. */
    /* Load it and get entry points for the required functions. */

    if ((Hdlladi = LoadLibrary(/*MSG0*/"acadadi.dll")) < 32) {
        adsw_msg_box(0, /*MSG9*/"Cannot find ACADADI.DLL");
	return FALSE;
    }
    if ((addr = (ACADADIPROC)GetProcAddress(Hdlladi, /*MSG0*/"ServerWait")) == NULL) {
	FreeLibrary(Hdlladi);
        adsw_msg_box(0, /*MSG10*/"Incorrect ACADADI.DLL");
	return FALSE;
    }
    swHandle = GetIndirectFunctionHandle(addr, INDIR_WORD, INDIR_ENDLIST);

    if ((addr = (ACADADIPROC)GetProcAddress(Hdlladi, /*MSG0*/"ServerDone")) == NULL) {
	FreeLibrary(Hdlladi);
        adsw_msg_box(0, /*MSG10*/"Incorrect ACADADI.DLL");
	return FALSE;
    }
    sdHandle = GetIndirectFunctionHandle(addr, INDIR_WORD, INDIR_ENDLIST);


#if defined _MSC_VER || defined WATADS || defined(HCWIN)
    ads_main(vargc, vargv);	    /* Give control main program */
#else
    ads_main(arg_c, arg_v);
#endif	/* _MSC_VER || WATADS */

    adsw_win_exit(0);
    return msg.wParam;
}


long FAR PASCAL
adsw_win_proc (HWND hWnd, unsigned iMessage, WORD wParam, LONG lParam)
{
    WORD wStatus;
    DWORD afCmd;


    switch (iMessage) {

    case WM_CREATE:
	adsw_hWnd = hWnd;

	/* This is the DDE message filter.  This may be modified
	   to allow or disallow an ADS application to function as
	   a DDE server for Execute or Advise (hot link) messages. */
	afCmd = APPCLASS_STANDARD     |
	      /*  CBF_FAIL_ADVISES    |
	       *  CBF_FAIL_EXECUTES   |
	       */
	      CBF_SKIP_REGISTRATIONS  |
	      CBF_SKIP_UNREGISTRATIONS;


	DdeInitialize(&adsw_idInst, (PFNCALLBACK)MakeProcInstance
		      ((FARPROC)adsw_dde_callback, adsw_hInstance),
		      afCmd, NULL);

	if (adsw_idInst) {
	    CreateAtoms();
	    DdeNameService(adsw_idInst, hszAppName, NULL, DNS_REGISTER);
	}
	break;

    case WM_QUERYOPEN:                /* Don't open, stay iconic */
	return 0;

    case WM_CLOSE:
	adsw_win_exit(1);
	break;

    case WM_DESTROY:
	PostQuitMessage(0);
	break;

    case WM_CHAR:
	/* Check for ^C.  This only works
	   if the ADS program has an activated window. */
	if (wParam == 3)
	    adsw_brkflg = TRUE;
	break;

    default:
	if (iMessage == adsw_wm_Ads) {
	    adsw_handle_msg(lParam);
	    break;
	}
	return DefWindowProc(hWnd, iMessage, wParam, lParam);
    }				      /* switch iMessage */

    return 0L;
}				      /* function adsw_win_proc */

static HDDEDATA (*DdeSubFunc)(PXFERINFO pXferInfo) = NULL;

/* This function is called by the DDE manager DLL and passes control onto
   the apropriate function pointed to by the global topic and item arrays.
   It handles all DDE interaction generated by external events.
   Use adsi_subclass_dde to send these parameters to another function
   in order to make an ADS app a DDE server or recipient of hot or
   warm link info. */


HDDEDATA
#if defined(WATADS) || defined(HCWIN)
FAR PASCAL
#else
EXPENTRY
#endif
/*FCN*/adsw_dde_callback(WORD wType, WORD wFmt, HCONV hConv, HSZ hszTopic,
		   HSZ hszItem, HDDEDATA hData, DWORD lData1, DWORD lData2)
{
    WORD i, j;
    ITEMLIST *pItemList;
    WORD cItems, iFmt;
    HDDEDATA hDataRet;
    XFERINFO  CbParms;
    PXFERINFO lpCbParms = &CbParms;

    /* Make copy of dde callback parms, don't use
    machine dependent stack trick */
    lpCbParms->lData2 = lData2;
    lpCbParms->lData1 = lData1;
    lpCbParms->hData  = hData;
    lpCbParms->hszItem = hszItem;
    lpCbParms->hszTopic = hszTopic;
    lpCbParms->hConv = hConv;
    lpCbParms->wFmt = wFmt;
    lpCbParms->wType = wType;

    if (hszTopic != hszAdsTopic && DdeSubFunc != NULL)
	/* Pass it on to the ADS DDE Server app subclass function. */
	return DdeSubFunc(lpCbParms);

    if (wType == XTYP_WILDCONNECT)
	return 0;

    /* Keep a count of connections */
    else if (wType == XTYP_CONNECT_CONFIRM) {
	if (hszTopic == hszAdsTopic)
	    linkedAcad = TRUE;
	return 0;
    } else if (wType == XTYP_DISCONNECT) {
	return 0;
    }

    /* Only allow transactions on the formats we support */
    if (wFmt) {
	for (iFmt = 0; iFmt < CFORMATS; iFmt++) {
	    if (wFmt == aFormats[iFmt].atom)
		break;
	}
	if (iFmt == CFORMATS)
	    return 0;		      /* illegal format - ignore now. */
    }

    /* Check our hsz tables and send to the apropriate proc. to process.
       We use DdeCmpStringHandles() which is the portable case-insensitive
       method of comparing string handles.  (this is a macro on windows so
       there is no real speed hit.)  On WINDOWS, HSZs are case-insensitive
       anyway, but this may not be the case on other platforms. */
    for (i = 0; i < CTOPICS; i++) {
	if (DdeCmpStringHandles(topicList[i].hszTopic, hszTopic) == 0) {

	    if (wType == XTYP_CONNECT)
		return (linkedAcad ? FALSE : TRUE); /* Good topic */
	    pItemList = topicList[i].pItemList;
	    cItems = topicList[i].cItems;
	    for (j = 0; j < cItems; j++) {
		if (DdeCmpStringHandles(pItemList[j].hszItem, hszItem) == 0) {

		    /* Make call to worker function here... */
		    hDataRet = (*pItemList[j].npfnCallback)
			       (lpCbParms, iFmt);


/* ReturnSpot: */
		    /* The table functions return a boolean or data.
		       It gets translated here. */
		    switch (wType & XCLASS_MASK) {
		    case XCLASS_DATA:
			return hDataRet;
			break;
		    case XCLASS_FLAGS:
			return hDataRet ? DDE_FACK : DDE_FNOTPROCESSED;
			break;
		    case XCLASS_BOOL:
			return TRUE;
		    default:	      /* XCLASS_NOTIFICATION */
			return 0;
			break;
		    }
		    break;
		}
	    }
	    break;
	}
    }

    /* Anything else fails - DDEML is designed so that a 0 return is
       ALWAYS ok. */
    return 0;
}



/* Create atoms and string handles for DDE */

static void
/*FCN*/CreateAtoms()
{
    register ITEMLIST *pItemList;
    WORD iTopic, iItem;
    int i;

    aFormats[TEXTFMT].atom = CF_TEXT;	    /* exception - predefined. */
    for (i = 1; i < CFORMATS; i++)
	aFormats[i].atom = RegisterClipboardFormat(aFormats[i].sz);
    adsw_AcadAtom = aFormats[LISPFMT].atom;  /* LISP format */

    hszAppName = DdeCreateStringHandle(adsw_idInst, adsw_AppName, CP_WINANSI);
    adsw_hItemName = DdeCreateStringHandle(adsw_idInst, ADSITEM, CP_WINANSI);

    for (iTopic = 0; iTopic < CTOPICS; iTopic++) {
	topicList[iTopic].hszTopic = DdeCreateStringHandle(adsw_idInst,
				 topicList[iTopic].pszTopic, CP_WINANSI);
	if (iTopic == iAdsTopic)
	    hszAdsTopic = topicList[iTopic].hszTopic;
	pItemList = topicList[iTopic].pItemList;
	for (iItem = 0; iItem < topicList[iTopic].cItems; iItem++) {
	    pItemList[iItem].hszItem = DdeCreateStringHandle(adsw_idInst,
							     pItemList[iItem].pszItem, CP_WINANSI);
	}
    }
}

/*  This destroys often used global hszs from standard global strings. */

static void
/*FCN*/FreeAtoms()
{
    register ITEMLIST *pItemList;
    WORD iTopic, iItem;

    DdeFreeStringHandle(adsw_idInst, hszAppName);
    DdeFreeStringHandle(adsw_idInst, adsw_hItemName);

    for (iTopic = 0; iTopic < CTOPICS; iTopic++) {
	DdeFreeStringHandle(adsw_idInst, topicList[iTopic].hszTopic);
	pItemList = topicList[iTopic].pItemList;
	for (iItem = 0; iItem < topicList[iTopic].cItems; iItem++)
	    DdeFreeStringHandle(adsw_idInst, pItemList[iItem].hszItem);
    }
}





/* This passes out a standard tab-delimited list of topic names for this
   application.

   This support is required for other apps to be able to
   find out about us.  This kind of support should be in every DDE
   application.  */

static HDDEDATA
/*FCN*/TopicListXfer(PXFERINFO pXferInfo, WORD iFmt)
{
    WORD cbAlloc, i;
    unsigned len;
#ifdef WATADS
    char far *pszTopicList;
#else
    LPSTR pszTopicList;
#endif
    HDDEDATA hData;

    if (pXferInfo->wType == XTYP_ADVSTART)
	return TRUE;

    if (pXferInfo->wType != XTYP_REQUEST &&
	pXferInfo->wType != XTYP_ADVREQ)
	return 0;
    /*
       construct the list of topics we have
     */
    cbAlloc = 0;
    for (i = 0; i < CTOPICS; i++)
	cbAlloc += lstrlen(topicList[i].pszTopic) + 1;	/* 1 for tab */

    /* allocate a data handle big enough for the list. */
    hData = DdeCreateDataHandle(adsw_idInst, NULL, 0, cbAlloc, pXferInfo->hszItem,
				pXferInfo->wFmt, 0);
#ifdef HCWIN
    pszTopicList = BRK_FP(DdeAccessData(hData, NULL));
#else /* HCWIN */
#ifdef WATADS
    pszTopicList = MK_FP32((LPVOID)DdeAccessData(hData, NULL));
#else /* WATADS */
    pszTopicList = (LPSTR)DdeAccessData(hData, NULL);
#endif /* WATADS */
#endif /* HCWIN */
    if (pszTopicList) {
	for (i = 0; i < CTOPICS; i++) {
	    len = strlen(topicList[i].pszTopic);
	    _fmemcpy(pszTopicList, topicList[i].pszTopic, len);
	    pszTopicList += len;
            *pszTopicList++ = '\t';
	}
        *--pszTopicList = '\0';
	DdeUnaccessData(hData);
	return hData;
    }
    return 0;
}


/* This passes out a standard tab-delimited list of item names for the
   specified topic.

   This support is required for other apps to be able to
   find out about us.  This kind of support should be in every DDE
   application. */

static HDDEDATA
/*FCN*/ItemListXfer(PXFERINFO pXferInfo, WORD iFmt)
{
    WORD cbAlloc, i, iItem, cItems;
    unsigned len;
    ITEMLIST *pItemList = 0;
#ifdef WATADS
    char far *pszItemList;
#else
    LPSTR pszItemList;
#endif
    HDDEDATA hData;

    if (pXferInfo->wType == XTYP_ADVSTART)
	return TRUE;

    if (pXferInfo->wType != XTYP_REQUEST &&
	pXferInfo->wType != XTYP_ADVREQ)
	return 0;
    /*
       construct the list of items we support for this topic - this supports
       more than the minimum standard which would support SysItems only on
       the system topic.
     */

    /* locate the requested topic item table */
    for (i = 0; i < CTOPICS; i++) {
	if (pXferInfo->hszTopic == topicList[i].hszTopic) {
	    pItemList = topicList[i].pItemList;
	    cItems = topicList[i].cItems;
	    break;
	}
    }

    if (!pItemList)
	return 0;		      /* item not found */

    cbAlloc = 0;
    for (iItem = 0; iItem < cItems; iItem++)
	cbAlloc += lstrlen(pItemList[iItem].pszItem) + 1; /* 1 for tab */

    /* allocate a data handle big enough for the list. */
    hData = DdeCreateDataHandle(adsw_idInst, NULL, 0, cbAlloc,
				pXferInfo->hszItem, pXferInfo->wFmt, 0);
#ifdef HCWIN
    pszItemList = BRK_FP(DdeAccessData(hData, NULL));
#else /* HCWIN */
#ifdef WATADS
    pszItemList = MK_FP32((LPVOID)DdeAccessData(hData, NULL));
#else /* WATADS */
    pszItemList = (LPSTR)DdeAccessData(hData, NULL);
#endif /* WATADS */
#endif /* HCWIN */
    if (pszItemList) {
	for (i = 0; i < cItems; i++) {
	    len = strlen(pItemList[i].pszItem);
	    _fmemcpy(pszItemList, pItemList[i].pszItem, len);
	    pszItemList += len;
            *pszItemList++ = '\t';
	}
        *--pszItemList = '\0';
	DdeUnaccessData(hData);
	return hData;
    }
    return 0;
}


/* Gives out a 0 terminated array of dde format numbers supported
   by this app.

   This support is required for other apps to be able to
   find out about us.  This kind of support should be in every DDE
   application. */

static HDDEDATA sysFormatsXfer(PXFERINFO pXferInfo, WORD iFmt)
{
    int i, cb;
    unsigned len;
#ifdef WATADS
    char far *pszT;
#else
    LPSTR pszT;
#endif
    HDDEDATA hData;

    if (pXferInfo->wType == XTYP_ADVSTART)
	return TRUE;

    if (pXferInfo->wType != XTYP_REQUEST &&
	pXferInfo->wType != XTYP_ADVREQ)
	return 0;

    for (i = 0, cb = 0; i < CFORMATS; i++)
	cb += strlen(aFormats[i].sz) + 1;

    hData = DdeCreateDataHandle(adsw_idInst, NULL, (DWORD)cb,
				0L, pXferInfo->hszItem, pXferInfo->wFmt, 0);
#ifdef HCWIN
    pszT = BRK_FP(DdeAccessData(hData, NULL));
#else /* HCWIN */
#ifdef WATADS
    pszT = MK_FP32((LPVOID)DdeAccessData(hData, NULL));
#else /* WATADS */
    pszT = DdeAccessData(hData, NULL);
#endif /* WATADS */
#endif /* HCWIN */
    for (i = 0; i < CFORMATS; i++) {
	len = strlen(aFormats[i].sz);
	_fmemcpy(pszT, aFormats[i].sz, len);
	pszT += len;
        *pszT++ = '\t';
    }
    *(--pszT) = '\0';
    DdeUnaccessData(hData);
    return hData;
}


/* Machine initialization code */
void adsi_mach()
{
}


/* Clean up and exit */

void
/*FCN*/adsw_win_exit(int exitval)
{
    static int done = FALSE;
    if (done)
	return;
    else
	done = TRUE;

    if (adsw_idInst) {
	DdeNameService(adsw_idInst, NULL, NULL, DNS_UNREGISTER);
	FreeAtoms();
	DdeUninitialize(adsw_idInst);
    }
    PostQuitMessage(0);
    DestroyWindow(adsw_hWnd);
    UnregisterClass(classname, adsw_hInstance);
    if (Hdlladi) {
	FreeLibrary(Hdlladi);
	Hdlladi = NULL;
    }
#undef exit
    exit(exitval);
}




/* Is this conversation and partner app still alive?  */

int
adsw_check_conv(HCONV hConv)
{
    CONVINFO ci;
    WORD wError;

    if (hConv == NULL)
	return FALSE;
    if (DdeQueryConvInfo(hConv, QID_SYNC, &ci) == 0) {
	wError = DdeGetLastError(adsw_idInst);
	if (wError == DMLERR_NO_CONV_ESTABLISHED)
	    return FALSE;
	else
	    return TRUE;
    }
    if (ci.wStatus & ST_TERMINATED || !(ci.wStatus & ST_CONNECTED))
	return FALSE;
    return TRUE;
}



/* Put up a YES or NO message box with a msg and return TRUE if
   YES was the response */

int
adsw_yes_no_msg(char *msg)
{
    int mb_response;

    mb_response = adsw_msg_box(MB_YESNO | MB_ICONQUESTION, msg);
    return mb_response == IDYES;
}


/* Put up a message box with a message, msg.
   "msgtype" can be one of the list below.
   MB_OK is for a simple message.
   MB_ABORTRETRYIGNORE is to prompt user for Abort,
       Retry, or Ignore (returns IDABORT, IDRETRY, or IDIGNORE).
   Other returns are IDOK, IDCANCEL, IDYES.

   List of msgtypes:
	MB_OK
	MB_OKCANCEL
	MB_RETRYCANCEL
	MB_ABORTRETRYIGNORE
	MB_YESNO
	MB_YESNOCANCEL
	| MB_ICONQUESTION or MB_ICONHAND or MB_ICONEXCLAMATION
*/

int adsw_msg_box(int msgtype, char *msg)
{
    char msg_title[80];
    int ret;

    if (msgtype == 0)
	msgtype = MB_OK;
    if (!adsw_AppName[0])
        strcpy(adsw_AppName, /*MSG7*/"ADS Application");
    sprintf(msg_title, /*MSG8*/"%s Message", adsw_AppName);
    ret = MessageBox(adsw_hWnd, msg, msg_title, msgtype);
    return ret;
}


/* Abnormal exit from ADS side.  Disconnect from LISP and exit. */

void
/*FCN*/adsi_machexit(int exitval)
{
    adsw_win_exit(exitval);
}

/* Subclass the DDE callback function.	Use to add functions to handle
   incoming DDE data, such as that from a hot or warm link. */
void adsw_subclass_dde(HDDEDATA (*subfunc)(PXFERINFO lData))
{
    DdeSubFunc = subfunc;
}

/* ^C pressed while we had focus?  Resets flag during this call.
   This only works if the ADS app has a window that has focus
   (activated) */

int adsw_usrbrk(void)
{
    int stat = adsw_brkflg;
    adsw_brkflg = FALSE;
    return stat;
}

#ifdef HCWIN
static void
/*FCN*/_fmemcpy(LPVOID dst, LPVOID src, unsigned len)
{
    _movedata(_FP_SEG(src), _FP_OFF(src), _FP_SEG(dst), _FP_OFF(dst), len);
}
#endif /* HCWIN */

#if !defined(__TURBOC__) && !defined(HCWIN)
/* Windows version of printf--uses Windows message box. */
int printf(char *format, ...)
{
    va_list va;
    int stat;
    char buf[1024];

    va_start(va, format);
    vsprintf(buf, format, va);
    va_end(va);
#if 1
    return adsw_msg_box(0, buf);
#else
    /* Output to DBWIN program (from Windows SDK). */
    OutputDebugString(buf);
    return 1;
#endif
}
#endif


