/* Next available MSG number is   1 */

/*
      (C) Copyright 1988,89,90,93 by Autodesk, Inc.

******************************************************************************
*                                                                            *
* The information contained herein is confidential, proprietary to Autodesk, *
* Inc., and considered a trade secret as defined in section 499C of the      *
* penal code of the State of California.  Use of this information by anyone  *
* other than authorized employees of Autodesk, Inc. is granted only under a  *
* written non-disclosure agreement, expressly prescribing the scope and      *
* manner of such use.                                                        *
*                                                                            *
*                                                                            *
*        AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.         *
*        AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF             *
*        MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.    *
*        DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE          *
*        UNINTERRUPTED OR ERROR FREE.                                        *
*                                                                            *
*                                                                            *
**************************************************************************** *

*/
/*
    WINDDE.H
    Windows & DDE Definitions used by AutoCAD and ADS
    Uses Microsoft's ddeml.h.
*/

#if !defined(WINAPI) && !defined(HCWIN)   /* Windows 3.0 windows.h--provide
                                               3.1 defs (for QCWIN) */
typedef unsigned int UINT;
#define WINAPI _far _pascal
#define CALLBACK FAR PASCAL
typedef const char FAR* LPCSTR;
typedef UINT WPARAM;
typedef LONG LPARAM;
typedef LONG LRESULT;
typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
#endif  /* CALLBACK && HCWIN */

#ifndef WATWIN
#ifdef HCWIN
#include <ddeml.h>
#else
#include "ddeml.h"                    /* Microsoft DDE Library */
#endif
#endif

#define ACADGFX  0
#define ACADTEXT 1
#define ACADCLBD 2

#ifndef ACAD_LT 
#define acadgfxNAME /*MSG0*/"AutoCAD.gfx"
#define acadtextNAME /*MSG0*/"AutoCAD.text"
#define acadclbdNAME /*MSG0*/"AutoCAD.clbd"
#endif /* ACAD_LT */

#define TEXTFMT 0                     /* index in DDE format atom table */
#define LISPFMT 1
#define DDEWAIT 6000L                 /* wait x millisecs for DDE response */   


/* Data structure that is a mirror image of the parameters sent
   to a DDE callback function, defined in ddeml.h (FNCALLBACK).  
   The XTYP_ messages use these parameters in different ways.  
   For example, XTYP_CONNECT uses hszTopic (hsz1) for the topic name 
   and hszItem (hsz2) for the application (service) name.  This
   structure is used to pass the parameters along to another 
   DDE handler. */
typedef struct _XFERINFO {  
    DWORD lData2;
    DWORD lData1;
    HDDEDATA hData;
    HSZ hszItem;                      /* hsz2 */        
    HSZ hszTopic;                     /* hsz1 */        
    HCONV hConv;
    WORD wFmt;
    WORD wType;                            
} XFERINFO;
typedef XFERINFO *PXFERINFO;    /* DS==SS! */

typedef struct _ITEMLIST {
    HSZ hszItem;
    HDDEDATA (*npfnCallback)(PXFERINFO, WORD);
    LPSTR pszItem;
} ITEMLIST;

typedef struct {
    ATOM atom;
    LPSTR sz;
} FORMATINFO;

typedef struct _TOPICLIST {
    HSZ hszTopic;
    ITEMLIST *pItemList;
    WORD cItems;
    LPSTR pszTopic;
} TOPICLIST;

#define MAXPATH 144

typedef struct {
    char *farcro;
    char helpfile[MAXPATH];
} OL_DATA;

typedef struct {
    char xcmd[31];
    char helpfile[MAXPATH];
} DDE_DATA;

static HDDEDATA TopicListXfer(PXFERINFO pXferInfo, WORD iFmt);
static HDDEDATA ItemListXfer(PXFERINFO pXferInfo, WORD iFmt);
static HDDEDATA sysFormatsXfer(PXFERINFO pXferInfo, WORD iFmt);

#define ACADMSG /*MSG0*/"WM_ACAD"     /* Send commands to AutoCAD using
                                         RegisterWindowMessage and
                                         SendMessage */
#define ACADOLFMT /*MSG0*/"acadol"    /* Special DDE format for AutoCAD, 
                                         LISP, and ADS data transfers */        
#define UPDATEOLFMT /*MSG0*/"updateol" /* Special DDE format to update,
                data sent from AutoCAD to LISP, and ADS */

#define LISPAPP /*MSG0*/"acadl"
#define LISPTOPIC /*MSG0*/"lisptopic"
#define LISPITEM /*MSG0*/"lispitem"
#define ADSTOPIC /*MSG0*/"adstopic"
#define ADSITEM /*MSG0*/"adsitem"
#define UPDATETOPIC /*MSG0*/"updatetopic"
#define ACADAPP /*MSG0*/"acadapp"

extern char adsw_AppName[];           /* This ADS application name */
extern HWND adsw_hWnd;                /*     "                window handle */  
extern HWND adsw_hwndAcad;            /* AutoCAD graphics window handle */
extern HANDLE adsw_hInstance;         /*     "                instance */
extern DWORD adsw_idInst;             /* DDEML instance */      
extern int adsw_wait;                 /* ADS process wait flag */       

extern HDDEDATA adsw_acadcb(PXFERINFO pXferInfo, WORD iFmt);

/* Windows ADS General Convenience Functions */

void adsw_subclass_dde(HDDEDATA (*subfunc)(PXFERINFO lData));
int adsw_msg_box(int msgtype, char *msg);
void adsw_win_exit(int exitval);
int adsw_check_conv(HCONV hConv);
int adsw_yes_no_msg(char *msg);
void adsi_machexit(int exitval);
int adsw_usrbrk(void);
HWND adsw_GetAcadWin(int index);
void adsw_handle_msg(DWORD lParam);
