/******************************************************************************
Name: apcode.h, AME_HEAD_apcode.h

Description: AME2/API status and general data type definitions

Author: AME Group
        Autodesk, Inc.

(C) Copyright 1988-1993 by Autodesk, Inc.
*******************************************************************************
*                                                                             *
*    This program is copyrighted by Autodesk, Inc. and is  licensed           *
*    to you under the following conditions.  You may not distribute           *
*    or  publish the source code of this program in any form.   You           *
*    may  incorporate this code in object form in derivative  works           *
*    provided  such  derivative  works  are  (i.) are  designed and           *
*    intended  to  work  solely  with  Autodesk, Inc. products, and           *
*    (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright           *
*    1988-1992 by Autodesk, Inc."                                             *
*                                                                             *
*    AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.           *
*    AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-           *
*    CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.           *
*    DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE           *
*    UNINTERRUPTED OR ERROR FREE.                                             *
*                                                                             *
*******************************************************************************

Notes:


******************************************************************************/

#ifdef FALSE
#undef FALSE
#endif

#ifdef TRUE
#undef TRUE
#endif

#define FALSE        0
#define TRUE         1

#define AP_SINGULARITY       3
#define AP_OUT_BOUND         2
#define AP_NORMAL            1
#define AP_FAIL             -1
#define AP_BAD_INPUT        -2
#define AP_MEM_OUT          -3
#define AP_INVALID_ID       -4
#define AP_OBJTYPE_MISMATCH -5
#define AP_CANCEL           -6
#define AP_LAST_ERRCODE error_code
#define AP_LAST_ERRMSG  errmsg[error_code]

typedef int ap_Status;                /* Function Return Status */
typedef unsigned long ap_Objid;       /* Object Identifier */
typedef unsigned long ap_Featid;      /* Feature Identifier */
typedef int ap_Bool;                  /* Boolean Type */
typedef ads_real ap_Real;             /* Real Declaration */
typedef ap_Real ap_Trans3d[4][4];     /* Rigid Motion Matrix */

extern long  error_code;
extern char  *errmsg[];

/* EOF */
