; Copyright (C) 1993 by Autodesk, Inc.
     
; Permission to use, copy, modify, and distribute this software
; for any purpose and without fee is hereby granted, provided
; that the above copyright notice appears in all copies and that
; both that copyright notice and this permission notice appear in
; all supporting documentation.
 
; THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
; WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
; PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.

; AutoLISP API constants
; ----------------------


; Boolean values (you cannot use standard AutoLISP's NIL and T)

(setq FALSE 0)
(setq TRUE  1)

; Object may be either a solid or a region (ap_Objtype)

(setq AP_REGION 0)
(setq AP_SOLID  1)

; Type of primitive or composite object (ap_Primtype)

(setq AP_BX    0)       ; Box
(setq AP_CON   1)       ; Cone
(setq AP_CYL   2)       ; Cylinder
(setq AP_SPH   3)       ; Sphere
(setq AP_TOR   4)       ; Torus
(setq AP_FIL   5)       ; Fillet
(setq AP_CHA   6)       ; Chamfer
(setq AP_BOO   7)       ; Boolean operation
(setq AP_EXT   8)       ; Extrusion
(setq AP_REV   9)       ; Revolution
(setq AP_WED  10)       ; Wedge
(setq AP_CIR  11)       ; Circle
(setq AP_POLY 12)       ; Polyline

; Boolean operators (ap_Booltype)

(setq AP_SUB 0)         ; Subtraction
(setq AP_INT 1)         ; Intersection
(setq AP_UNI 2)         ; Union

; Type of polyline vertex (ap_Pointtype)

(setq AP_PT_LINE   0)   ; End of line
(setq AP_PT_ARCEND 1)   ; End of arc

; Fillet type (ap_Filcha)

(setq AP_STRAIGHT 0)    ; Straight fillet/chamfer between two planar faces
(setq AP_CIRCULAR 1)    ; Circular fillet/chamfer between cyl, con, pln

; Object representation (ap_Posttype)

(setq AP_POSTMESH 0)    ; Mesh representation
(setq AP_POSTWIRE 1)    ; Wire representation
(setq AP_UNPOST   2)    ; Makes the object invisible

; Ray direction for mass properties calculation (ap_Rayproj)

(setq AP_X_DIR 0)
(setq AP_Y_DIR 1)
(setq AP_Z_DIR 2)

; Surface types (ap_Surftype)

(setq AP_PLANAR      0) 
(setq AP_CYLINDRICAL 1) 
(setq AP_CONICAL     2) 
(setq AP_SPHERICAL   3) 
(setq AP_TOROIDAL    4)

; Curve types (ap_Curvetype)

(setq AP_LINE      0)   
(setq AP_ELLIPSE   1)   
(setq AP_HYPERBOLA 2)   
(setq AP_PARABOLA  3) 
(setq AP_CYLCYL    4)   ; Cylinder-cylinder intersection
(setq AP_CONCON    5)   ; Cone-cone intersection

; Point or edge segment classification values (ap_Class)

(setq AP_FAILED    0)   ; Classification failed
(setq AP_OFFOBJECT 1)   ; Point or line segment is outside the object
(setq AP_ONOBJECT  2)   ; Point or line segment is on the object boundary
(setq AP_INOBJECT  3)   ; Point or line segment is inside the object

; Error code obtained from (ap_last_errcode) when CTRL-C was hit

(setq AP_CANCEL_CODE 45)
















