/******************************************************************************
Name: approto.h, AME_APLIB_APHEAD_approto.h
 
Description: AME1/API function prototypes
 
Author: AME Group
        Autodesk, Inc.
 
        ______________________________________________________________

        (C) Copyright 1988-1993 by Autodesk, Inc.
  
        This program is copyrighted by Autodesk, Inc. and is  licensed
        to you under the following conditions.  You may not distribute
        or  publish the source code of this program in any form.   You
        may  incorporate this code in object form in derivative  works
        provided  such  derivative  works  are  (i.) are  designed and
        intended  to  work  solely  with  Autodesk, Inc. products, and
        (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright
        1988-1992 by Autodesk, Inc."
  
        AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
        AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
        CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
        DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
        UNINTERRUPTED OR ERROR FREE.
        ______________________________________________________________

 
******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

ap_Status ap_all_edges       _((ap_Solid ,ap_EdgeList **));
ap_Status ap_all_faces       _((ap_Solid ,ap_FaceList **));
ap_Status ap_assocmat        _((ap_Solid obj, ap_Trans3d map));
ap_Status ap_box             _((ap_Real ,ap_Real ,ap_Real ,ap_Solid *));
ap_Status ap_compose         _((ap_Real (*)[4],ap_Real (*)[4],ap_Real (*)[4]));
ap_Status ap_cone            _((ap_Real ,ap_Real ,ap_Real ,ap_Solid *));
ap_Status ap_cylinder        _((ap_Real ,ap_Real ,ap_Real ,ap_Solid *));
ap_Status ap_delsol          _((ap_Solid ));
ap_Status ap_diff            _((ap_Solid ,ap_Solid ,ap_Solid *));
ap_Status ap_dupsol          _((ap_Solid ,ap_Solid *));
ap_Status ap_edge_class      _((ap_Solid ,ap_EdgeInfo *,ap_SegList **));
ap_Status ap_edge_face       _((ap_Solid ,ap_Featid ,ap_FaceList **));
ap_Status ap_edge_info       _((ap_Solid ,ap_Featid ,ap_EdgeInfo *));
ap_Status ap_edgeparm2pt     _((ap_Solid ,ap_Featid ,ap_Real ,ads_real *));
ap_Status ap_edgept2parm     _((ap_Solid ,ap_Featid ,ads_real *,ap_Real *));
ap_Status ap_evalpmesh       _((ap_Solid ,long *));
ap_Status ap_evalprof        _((ap_Solid ,ap_Bool ,long *,long *));
ap_Status ap_evalwire        _((ap_Solid ,long *));
ap_Status ap_extrude         _((long ,ap_Swp_pts *,ads_real ,ads_real ,ap_Solid *));
ap_Status ap_face_edge       _((ap_Solid ,ap_Featid ,ap_EdgeList **));
ap_Status ap_face_info       _((ap_Solid ,ap_Featid ,ap_FaceInfo *));
ap_Status ap_free_edge_list  _((ap_EdgeList *));
ap_Status ap_free_face_list  _((ap_FaceList *));
ap_Status ap_free_seg_list   _((ap_SegList *));
ap_Status ap_getvar          _((char *,struct resbuf **));
ap_Status ap_identity        _((ap_Real (*)[4]));
ap_Status ap_int             _((ap_Solid *,ap_Solid *));
ap_Status ap_invert          _((ap_Real (*)[4],ap_Real (*)[4]));
ap_Status ap_name2sol        _((long *,ap_Solid *));
ap_Status ap_postsol         _((ap_Solid ,Ap_posttype ));
ap_Status ap_pt_class        _((ap_Solid ,ads_real *,Ap_pt_class *));
ap_Status ap_pt_norm_surf    _((ap_Solid ,ap_Featid ,ads_real *,ads_real *,ap_Bool ));
ap_Status ap_pt_tang_edg     _((ap_Solid ,ap_Featid ,ads_real *,ads_real *));
ap_Status ap_pt_to_surf      _((ap_Solid ,ap_Featid ,ads_real *));
ap_Status ap_q_mprop         _((ap_Solid ,ap_Mprop *));
ap_Status ap_q_solinfo       _((ap_Solid ,ap_Solinfo *));
ap_Status ap_revolve         _((long ,ap_Swp_pts *,ads_real ,ap_Bool ,ap_Solid *));
ap_Status ap_rotx            _((ads_real ,ads_real (*)[4]));
ap_Status ap_roty            _((ads_real ,ads_real (*)[4]));
ap_Status ap_rotz            _((ads_real ,ads_real (*)[4]));
ap_Status ap_s_matl          _((ap_Solid ,char *));
ap_Status ap_scalsol         _((ap_Solid ,ads_real ));
ap_Status ap_section         _((ap_Solid ,long *));
ap_Status ap_select_edge     _((ap_Solid *,ap_Featid *));
ap_Status ap_select_face     _((ap_Solid *,ap_Featid *));
ap_Status ap_separate        _((ap_Solid ,ap_Solid **));
ap_Status ap_setvar          _((char *,struct resbuf *));
ap_Status ap_sol2name        _((ap_Solid ,long *));
ap_Status ap_sphere          _((ap_Real ,ap_Solid *));
ap_Status ap_surfparm2pt     _((ap_Solid ,ap_Featid ,ap_Param *,ads_real *));
ap_Status ap_torus           _((ap_Real ,ap_Real ,ap_Solid *));
ap_Status ap_translate       _((ads_real ,ads_real ,ads_real ,ap_Real (*)[4]));
ap_Status ap_union           _((ap_Solid *,ap_Solid *));
ap_Status ap_wedge           _((ap_Real ,ap_Real ,ap_Real ,ap_Solid *));

#ifdef __cplusplus
}
#endif /* __cplusplus */
