/******************************************************************************
Name: aproto.h, AME_APLIB_APHEAD_aproto.h
 
Description: AME2/API function prototypes
 
Author: AME Group
        Autodesk, Inc.
 
        ______________________________________________________________

        (C) Copyright 1988-1993 by Autodesk, Inc.
 
        This program is copyrighted by Autodesk, Inc. and is  licensed
        to you under the following conditions.  You may not distribute
        or  publish the source code of this program in any form.   You
        may  incorporate this code in object form in derivative  works
        provided  such  derivative  works  are  (i.) are  designed and
        intended  to  work  solely  with  Autodesk, Inc. products, and
        (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright
        1988-1992 by Autodesk, Inc."

        AUTODESK  PROVIDES THIS PROGRAM "AS IS" AND WITH  ALL  FAULTS.
        AUTODESK  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF  MER-
        CHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK,  INC.
        DOES  NOT  WARRANT THAT THE OPERATION OF THE PROGRAM  WILL  BE
        UNINTERRUPTED OR ERROR FREE.
        ______________________________________________________________

 
******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

ap_Status ap_box             _((ap_Real ,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_circle          _((ap_Real ,ap_Objid *));
ap_Status ap_class_edge      _((ap_Objid ,ap_Edgeinfo *,ap_Seglist **));
ap_Status ap_class_pt        _((ap_Objid ,ads_real *,ap_Class *));
ap_Status ap_compose         _((ap_Real (*)[4],ap_Real (*)[4],ap_Real (*)[4]));
ap_Status ap_cone            _((ap_Real ,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_create_matl     _((ap_Material ,char *,ap_Bool ));
ap_Status ap_cut_obj         _((ap_Objid *,ads_point *,ap_Objid **,ap_Objid **));
ap_Status ap_cylinder        _((ap_Real ,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_del_obj         _((ap_Objid ));
ap_Status ap_dup_obj         _((ap_Objid ,ap_Objid *));
ap_Status ap_edge2faces      _((ap_Objid ,ap_Featid ,ap_Bool ,ap_Facelist **));
ap_Status ap_edge2loops      _((ap_Objid ,ap_Featid ,ap_Featid **));
ap_Status ap_edge2vertices   _((ap_Objid ,ap_Featid ,ap_Featid *,ap_Featid *));
ap_Status ap_edgeparm2pt     _((ap_Objid ,ap_Featid ,ap_Real ,ads_real *));
ap_Status ap_edgept2parm     _((ap_Objid ,ap_Featid ,ads_real *,ap_Real *));
ap_Status ap_ent2pline       _((long *,ap_Real (*)[4],ap_Swp_pts **,long *));
ap_Status ap_evalmesh        _((ap_Objid ,long *));
ap_Status ap_evalprofile     _((ap_Objid *,ap_Bool, ap_Bool ,ap_Bool ,long *,long *));
ap_Status ap_evalwire        _((ap_Objid ,long *));
ap_Status ap_extrude_pline   _((long ,ap_Swp_pts *,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_extrude_region  _((ap_Objid ,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_face2edges      _((ap_Objid ,ap_Featid ,ap_Bool ,ap_Edgelist **));
ap_Status ap_faceparm2pt     _((ap_Objid ,ap_Featid ,ap_Param *,ads_real *));
ap_Status ap_facept2parm     _((ap_Objid ,ap_Featid ,ads_real *,ap_Param *));
ap_Status ap_free_edgeinfo   _((ap_Edgeinfo *));
ap_Status ap_free_edgelist   _((ap_Edgelist *));
ap_Status ap_free_faceinfo   _((ap_Faceinfo *));
ap_Status ap_free_facelist   _((ap_Facelist *));
ap_Status ap_free_seglist    _((ap_Seglist *));
ap_Status ap_get_edgeinfo    _((ap_Objid ,ap_Featid ,ap_Edgeinfo **));
ap_Status ap_get_faceinfo    _((ap_Objid ,ap_Featid ,ap_Faceinfo **));
ap_Status ap_get_massprop    _((ap_Objid ,ap_Massprop *));
ap_Status ap_get_matl        _((char *,char *,ap_Material *));
ap_Status ap_get_objinfo     _((ap_Objid ,ap_Objinfo *));
ap_Status ap_get_objtype     _((ap_Objid ,ap_Objtype *));
ap_Status ap_get_ucsmat      _((ap_Real (*)[4]));
ap_Status ap_getvar          _((char *,struct resbuf **));
ap_Status ap_identity        _((ap_Real (*)[4]));
ap_Status ap_init            _((void));
ap_Status ap_interference    _((ap_Objid ,ap_Objid ,ap_Bool *));
ap_Status ap_intersect       _((ap_Objid *,ap_Objid *));
ap_Status ap_invert          _((ap_Real (*)[4],ap_Real (*)[4]));
ap_Status ap_loop2edges      _((ap_Objid ,ap_Featid ,ap_Bool ,ap_Edgelist **));
ap_Status ap_move_obj        _((ap_Objid ,ap_Real (*)[4],ap_Bool ));
ap_Status ap_name2obj        _((long *,ap_Objid *));
ap_Status ap_obj2edges       _((ap_Objid ,ap_Bool ,ap_Edgelist **));
ap_Status ap_obj2extents     _((ap_Objid ,ap_Bool ,ads_real *,ads_real *));
ap_Status ap_obj2faces       _((ap_Objid ,ap_Bool ,ap_Facelist **));
ap_Status ap_obj2loops       _((ap_Objid ,ap_Featid **));
ap_Status ap_obj2name        _((ap_Objid ,long *));
ap_Status ap_obj2vertices    _((ap_Objid ,ap_Featid **));
ap_Status ap_polygon         _((long ,ap_Real ,ap_Real ,ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_polyline        _((long ,ap_Swp_pts *,ap_Objid *));
ap_Status ap_post_obj        _((ap_Objid ,ap_Posttype ));
ap_Status ap_pt2face         _((ap_Objid ,ap_Featid ,ads_real *,ads_real *));
ap_Status ap_pt_norm2face    _((ap_Objid ,ap_Featid ,ads_real *,ap_Bool ,ads_real *));
ap_Status ap_pt_tang2edge    _((ap_Objid ,ap_Featid ,ads_real *,ads_real *));
ap_Status ap_pts2xfm         _((ads_point *,short ,ap_Real (*)[4]));
ap_Status ap_purge           _((ap_Objid ,ap_Objid *));
ap_Status ap_replace_prim    _((ap_Objid ,ap_Objid ));
ap_Status ap_revolve_pline   _((long ,ap_Swp_pts *,ap_Real ,ads_point *,ap_Objid *));
ap_Status ap_revolve_region  _((ap_Objid ,ap_Real ,ads_point *,ap_Objid *));
ap_Status ap_rotate_axis     _((ads_point *,ads_real ,ap_Real (*)[4]));
ap_Status ap_rotate_x        _((ads_real ,ap_Real (*)[4]));
ap_Status ap_rotate_y        _((ads_real ,ap_Real (*)[4]));
ap_Status ap_rotate_z        _((ads_real ,ap_Real (*)[4]));
ap_Status ap_scale_obj       _((ap_Objid ,ap_Real ,ads_real *));
ap_Status ap_sect_obj        _((ap_Objid *,ads_point *,long *));
ap_Status ap_sel_edge        _((char *,ap_Objid *,ap_Featid *));
ap_Status ap_sel_face        _((char *,ap_Objid *,ap_Featid *));
ap_Status ap_sep_obj         _((ap_Objid ,ap_Objid **));
ap_Status ap_set_matl        _((ap_Objid ,char *,char *));
ap_Status ap_setvar          _((char *,struct resbuf *));
ap_Status ap_solidify        _((long *,ap_Objid *));
ap_Status ap_sphere          _((ap_Real ,ap_Objid *));
ap_Status ap_subtract        _((ap_Objid ,ap_Objid ,ap_Objid *));
ap_Status ap_torus           _((ap_Real ,ap_Real ,ap_Objid *));
ap_Status ap_translate       _((ads_real ,ads_real ,ads_real ,ap_Real (*)[4]));
ap_Status ap_union           _((ap_Objid *,ap_Objid *));
ap_Status ap_vertex2edges    _((ap_Objid ,ap_Featid ,ap_Bool ,ap_Edgelist **));
ap_Status ap_vertex2pt       _((ap_Objid ,ap_Featid ,ads_real *));
ap_Status ap_wedge           _((ap_Real ,ap_Real ,ap_Real ,ap_Objid *));

#ifdef __cplusplus
}
#endif /* __cplusplus */

/* EOF */
