/* Next available MSG number is  24 */

//----------------------------------------------------------------------------
//
//   DLGTEST.DCL   Version 1.0
//
//   Copyright (C) 1991-1993 by Autodesk, Inc.
//      
//   Permission to use, copy, modify, and distribute this software 
//   for any purpose and without fee is hereby granted, provided 
//   that the above copyright notice appears in all copies and that 
//   both that copyright notice and this permission notice appear in 
//   all supporting documentation.
//      
//   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//   
//----------------------------------------------------------------------------
//
//  Dlgtest.dcl - For use with dlgtest.c and dlgtest.lsp
//   (Test Programs for User Programmable Dialog Boxes)
//
//----------------------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 3; }

// Display and set some of the dimensioning variables
dimensions : dialog {
    aspect_ratio = 0;
    label = /*MSG1*/"AutoCAD Dimension Controls";
    : cluster {
        : cluster {
            layout = vertical;
            : plain_cluster {
                layout = vertical;
                : toggle {
                    label = /*MSG2*/"Suppress Extension line 1";
                    key = "dimse1";
                }
                : toggle {
                    label = /*MSG3*/"Suppress Extension line 2";
                    key = "dimse2";
                }
                : toggle {
                    label = /*MSG4*/"Text Inside Horizontal";
                    key = "dimtih";
                }
                : toggle {
                    label = /*MSG5*/"Text Outside Horizontal";
                    key = "dimtoh";
                }
                : toggle {
                    label = /*MSG6*/"Text Above Dimension Line";
                    key = "dimtad";
                }
                : toggle {
                    label = /*MSG7*/"Append tolerance";
                    key = "dimtol";
                }
                : toggle {
                    label = /*MSG8*/"Generate limits";
                    key = "dimlim";
                }
                : toggle {
                    label = /*MSG9*/"Alternate units";
                    key = "dimalt";
                }
                : toggle {
                    label = /*MSG10*/"Associative dimensioning";
                    key = "dimaso";
                }
                : toggle {
                    label = /*MSG11*/"Show new dimension";
                    key = "dimsho";
                }
            }
        }
        : cluster {
            layout = vertical;
            : plain_cluster {
                layout = vertical;
                : edit_box {
                    label = /*MSG12*/"Arrow size";
                    key = "dimasz";
                }
                : edit_box {
                    label = /*MSG13*/"Tick size";
                    key = "dimtsz";
                }
                : edit_box {
                    label = /*MSG14*/"Text size";
                    key = "dimtxt";
                }
                : edit_box {
                    label = /*MSG15*/"Center mark size";
                    key = "dimcen";
                }
                : edit_box {
                    label = /*MSG16*/"Extension line offset";
                    key = "dimexo";
                }
                : edit_box {
                    label = /*MSG17*/"Extension line extension";
                    key = "dimexe";
                }
                : edit_box {
                    label = /*MSG18*/"Dimension line extension";
                    key = "dimdle";
                }
            }
        }
    }
    ok_cancel;
    errtile;
}





// TestLisp DCL (Dialog Control Language)
// Test Proteus/LISP

setcolor : dialog {
    aspect_ratio = 0;
    label = /*MSG19*/"Select Color";
    : cluster {
        layout = vertical;
        image_block;
        : list_box {
            key = "list_col";
            allow_accept = true;
        }
        : edit_box {
            key = "edit_col";
            allow_accept = true;
            label = /*MSG20*/"Color code";
            edit_width = 10;
            fixed_width = true;
        }
    }
    ok_cancel;
    errtile;
}


chgtext : dialog {
    aspect_ratio = 0;
    label = /*MSG21*/"Change Text";
    initial_focus = "old_str";
    : edit_box {
        key = "old_str";
        label = /*MSG22*/"Old String:";
        edit_width = 30;
        fixed_width = true;
    }
    : edit_box {
        key = "new_str";
        allow_accept = true;
        label = /*MSG23*/"New String:";
        edit_width = 30;
        fixed_width = true;
    }
    ok_cancel;
    errtile;
}
