//-------------------------------------------------------------------------
//
//	ASE.DCL 			 Autodesk SQL Extention dialog file
//
//	Copyright (C) 1991-93 by Autodesk, Inc.
//
//	Permission to use, copy, modify, and distribute this software
//	for any purpose and without fee is hereby granted, provided
//	that the above copyright notice appears in all copies and that
//	both that copyright notice and this permission notice appear in
//	all supporting documentation.
//
//	THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//	WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//	PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//
//-------------------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 0; }

ase_errtile : text {
	key = "error";
	is_error_tile = true;
}

values_list : list_box {
    key = "list_values" ;
    label = "Values" ;
    width = 50 ;
    tabs = "18 20 22 24 26 28 30 32 34 36 38 40 42 44 46 48" ;
    mnemonic = "V" ;
    value = "0" ;
}

l_slider : column {
  width = 50 ;
  is_enabled = false ;
  : slider {
    key = "slider_list" ;
    value = "0" ;
    min_value = 0 ;
    max_value = 5000 ;
    small_increment = 200 ;
    big_increment = 1000 ;
    layout = horizontal ;
  }
}

high_buttons : column {
  alignment = centered ;
  horizontal_alignment = centered ;
  vertical_alignment = centered ;
  : button {
     key = "button_highlight" ;
     label = "Highlight" ;
     mnemonic = "H" ;
  }
  : button {
     key = "button_unhighlight" ;
     label = "Unhighlight" ;
     mnemonic = "U" ;
  }
}

nav_buttons : column {
  alignment = centered ;
  horizontal_alignment = centered ;
  vertical_alignment = centered ;
  : button {
    key = "button_next" ;
    label = "Next" ;
    mnemonic = "N" ;
  }
  : button {
    key = "button_previous" ;
    label = "Previous" ;
    mnemonic = "P" ;
  }
  : button {
    key = "button_first" ;
    label = "First" ;
    mnemonic = "F" ;
  }
  : button {
    key = "button_last" ;
    label = "Last" ;
    mnemonic = "L" ;
  }
}

stm_slider : column {
  :text {
    key = "text_stm" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = left ;
  }
  : slider {
    key = "slider_stm" ;
    value = "0" ;
    min_value = 0 ;
    max_value = 5000 ;
    height = 1 ;
    small_increment = 200 ;
    big_increment = 1000 ;
    layout = horizontal ;
  }
}

msg_text : column {
  : text {
    key = "text_1" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : text {
    key = "text_2" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : text {
    key = "text_3" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
}

m_name : boxed_column {
  label = "Current Settings" ;
  : text {
    key = "text_dbms" ;
    width = 50 ;
  }
}

mb_name : boxed_column {
  label = "Current Settings" ;
  : text {
    key = "text_dbms" ;
    width = 50 ;
  }
  : text {
    key = "text_db" ;
    width = 50 ;
  }
}

mbt_name : boxed_column {
  label = "Current Settings" ;
  : text {
    key = "text_dbms" ;
    width = 50 ;
  }
  : text {
    key = "text_db" ;
    width = 50 ;
  }
  : text {
    key = "text_tbl" ;
    width = 50 ;
  }
}

link_path : boxed_column {
  width = 50 ;
  label = "Link Path" ;
  : text {
    key = "text_dbms" ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : text {
    key = "text_db" ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : text {
    key = "text_tbl" ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
}

confirm : dialog {
  label = "ASE Confirmation" ;
  initial_focus = "button_yes" ;
  msg_text ;
  : row {
    fixed_width = true ;
    alignment = centered ;
    : button {
      key = "button_yes" ;
      label = "Yes" ;
      mnemonic = "Y" ;
      is_default = true ;
    }
    : spacer { width = 2 ; }
    : button {
      key = "button_no" ;
      label = "No" ;
      mnemonic = "N" ;
      is_cancel = true ;
    }
  }
}

message : dialog {
  label = "ASE Message" ;
  initial_focus = "accept" ;
  msg_text ;
  ok_only ;
}

sqlerr : dialog {
  label = "SQL Error Message" ;
  initial_focus = "accept" ;
  stm_slider ;
  msg_text ;
  ok_only ;
}

termdbms : dialog {
    label = "Terminate DBMS Driver";
    initial_focus = "edit_value";
    : column{
      : list_box {
	 key = "list_dbms";
	 label = "DBMS Drivers";
	 height = 4 ;
	 width = 35 ;
	 tabs = "22 24 28 32" ;
	 mnemonic = "B" ;
      }
      :edit_box {
	 key = "edit_value" ;
	 label = "Driver:" ;
	 edit_limit = 35 ;
	 mnemonic = "D" ;
      }
    }
    : column {
      ok_cancel;
      : ase_errtile {
	width = 35 ;
      }
    }
}

getdbmsname : dialog {
    label = "Set DBMS Driver";
    initial_focus = "edit_value";
    : column{
      : list_box {
	 key = "list_dbms";
	 label = "DBMS Drivers";
	 height = 4 ;
	 width = 35 ;
	 tabs = "22 24 28 32" ;
	 mnemonic = "B" ;
      }
      :edit_box {
	 key = "edit_value" ;
	 label = "Driver:" ;
	 edit_limit = 32 ;
	 mnemonic = "D" ;
      }
    }
    : column {
      ok_cancel;
      : ase_errtile {
	width = 35 ;
      }
    }
}

getdbname : dialog {
  label = "Set Current Database";
  initial_focus = "edit_value";
  m_name ;
  : column{
    : list_box {
       key = "list_db";
       label = "Attached Databases";
       height = 4 ;
       mnemonic = "D" ;
    }
    :edit_box {
       key = "edit_value" ;
       label = "Database:" ;
       edit_limit = 18 ;
       mnemonic = "b" ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

closedb : dialog {
  label = "Close Database";
  initial_focus = "edit_db";
  m_name ;
  : column{
    : list_box {
       key = "list_db";
       label = "Attached Databases";
       height = 4 ;
       mnemonic = "D" ;
    }
    :edit_box {
       key = "edit_db" ;
       label = "Database:" ;
       edit_limit = 18 ;
       mnemonic = "b" ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

tblget : dialog {
  label = "Set Current Table";
  initial_focus = "edit_value";
  mb_name ;
  : column{
    : list_box {
       key = "list_tbl";
       label = "Attached Tables";
       height = 4 ;
       mnemonic = "T" ;
    }
    :edit_box {
       key = "edit_value" ;
       label = "Table:" ;
       edit_limit = 18 ;
       mnemonic = "b" ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

erasedbms : dialog {
    label = "Erase DBMS Driver";
    initial_focus = "edit_value";
    : column{
      : list_box {
	 key = "list_dbms";
	 label = "DBMS Drivers";
	 height = 4 ;
	 width = 35 ;
	 tabs = "22 24 28 32" ;
	 mnemonic = "B" ;
      }
      :edit_box {
	 key = "edit_value" ;
	 label = "Driver:" ;
	 edit_limit = 18 ;
	 mnemonic = "D" ;
      }
    }
    : column {
      ok_cancel;
      : ase_errtile {
	width = 35 ;
      }
    }
}

erasedb : dialog {
  label = "Erase Database";
  initial_focus = "edit_db";
  m_name ;
  : column{
    : list_box {
       key = "list_db";
       label = "Attached Databases";
       height = 4 ;
       mnemonic = "D" ;
    }
    :edit_box {
       key = "edit_db" ;
       label = "Database:" ;
       edit_limit = 18 ;
       mnemonic = "b" ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

erasetbl : dialog {
  label = "Erase Table";
  initial_focus = "edit_value";
  mb_name ;
  : column{
    : list_box {
       key = "list_tbl";
       label = "Attached Tables";
       height = 4 ;
       mnemonic = "T" ;
    }
    :edit_box {
       key = "edit_value" ;
       label = "Table:" ;
       edit_limit = 18 ;
       mnemonic = "b" ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

password : dialog {
  label = "Connecting to Database";
  initial_focus = "edit_username";
  mb_name ;
  value = "Set Database Please Enter";
  : edit_box {
    key = "edit_username" ;
    label = "Username:" ;
    edit_limit = 19 ;
    mnemonic = "U";
  }
  : edit_box {
    key = "edit_password" ;
    label = "Password:" ;
    edit_limit = 19 ;
    mnemonic = "P";
  }
  ok_cancel ;
}

asecursor_view : dialog {
  label = "Set Current Row by Search Criteria" ;
  initial_focus = "list_values" ;
  mbt_name ;
  : row {
    : column {
      stm_slider ;
      : text {
	key = "text_rownumber" ;
      }
      : values_list {
	height = 7 ;
      }
      l_slider ;
    }
      : cluster {
	children_fixed_height = true;
	children_alignment = centered;
	: column {
	  spacer ;
	  spacer ;
	  nav_buttons ;
	  high_buttons;
	  spacer ;
	}
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

asecursor_edit : dialog {
  label = "Edit SQL Selection Set" ;
  initial_focus = "list_values" ;
  mb_name ;
  : row {
    : column {
      stm_slider ;
      : text {
	  key = "text_rownumber" ;
      }
      : values_list {
	height = 8 ;
      }
      l_slider ;
      spacer ;
      : edit_box {
	key = "edit_value" ;
	label = "Edit:" ;
	edit_limit = 254 ;
	mnemonic = "E" ;
	horizontal_alignment = left ;
      }
      : ase_errtile {
	width = 50 ;
      }
    }
    : cluster {
      children_fixed_height = true;
      children_alignment = centered;
      : column {
	nav_buttons;
	high_buttons;
	: button {
	    key = "button_select"   ;
	    label = "Sel. Set" ;
	    mnemonic = "S" ;
	    alignment = centered ;
	}
	: button {
	    key = "button_delete" ;
	    label = "Delete" ;
	    mnemonic = "D" ;
	    alignment = centered ;
	}
	: row {
	  : toggle {
	    key = "toggle_update" ;
	    label = "" ;
	    value = "0" ;
	    width = 1 ;
	  }
	  : button {
	    key = "button_update" ;
	    label = "Update" ;
	    mnemonic = "U" ;
	    alignment = centered ;
	    width = 6 ;
	    is_enabled = false ;
	  }
	}
	: button {
	  label = "Exit";
	  key = "accept";
	  width  = 11;
	  alignment = centered;
	  is_cancel = true;
	  is_default  = true;
	  mnemonic = "x";
	}
      }
    }
  }
}

row_edit : dialog {
  label = "Edit Row" ;
  initial_focus = "list_values" ;
  mbt_name ;
  : values_list {
    hight = 9 ;
  }
  l_slider ;
  : row {
    : edit_box {
      key = "edit_value" ;
      label = "Edit:" ;
      edit_limit = 254 ;
      mnemonic = "E" ;
      horizontal_alignment = left ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

row_add : dialog {
  label = "Add Row" ;
  initial_focus = "list_values" ;
  mbt_name ;
  : values_list {
    height = 9 ;
  }
  l_slider ;
  : row {
    : edit_box {
      key = "edit_value" ;
      label = "Edit:" ;
      edit_limit = 254 ;
      mnemonic = "E" ;
      horizontal_alignment = left ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

row_view : dialog {
  label = "View Row" ;
  mbt_name ;
  : values_list {
    height = 9 ;
  }
  l_slider ;
  ok_only ;
}


row_setrow : dialog {
  label = "Set Current Row by Key Values" ;
  initial_focus = "edit_value" ;
  mbt_name ;
  : values_list {
    height = 3 ;
  }
  l_slider ;
  : row {
    : edit_box {
      key = "edit_value" ;
      label = "Edit:" ;
      edit_limit = 254 ;
      mnemonic = "E" ;
      horizontal_alignment = left ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

row_editlink : dialog {
  label = "Edit Link Key Values" ;
  initial_focus = "list_values" ;
  mbt_name ;
  : values_list {
    height = 3 ;
  }
  l_slider ;
  : row {
    : edit_box {
      key = "edit_value" ;
      label = "Edit:" ;
      edit_limit = 254 ;
      mnemonic = "E" ;
      horizontal_alignment = left ;
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}


link_view : dialog {
  label = "View Link" ;
  link_path ;
  : text {
    key = "text_rownumber" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : row {
    : column {
      : values_list {
	height = 3 ;
      }
      l_slider ;
      : list_box {
	key = "list_cols" ;
	label = "DA Columns" ;
	width = 50 ;
	height = 3 ;
	horizontal_alignment = centered ;
	vertical_alignment = centered ;
	mnemonic = "D" ;
	value = "0" ;
      }
    }
    nav_buttons ;
  }
  ok_only ;
  spacer ;
}

link_select : dialog {
  label = "Selection Link" ;
  initial_focus = "list_values" ;
  link_path ;
  : text {
    key = "text_rownumber" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : row {
    : column {
      : values_list {
	height = 3 ;
      }
      l_slider ;
      : list_box {
	key = "list_cols" ;
	label = "DA columns" ;
	width = 50 ;
	height = 3 ;
	horizontal_alignment = centered ;
	vertical_alignment = centered ;
	mnemonic = "D" ;
	value = "0" ;
      }
    }
    nav_buttons ;
  }
  ok_cancel ;
  spacer ;
}


link_edit : dialog {
  label = "Edit Link" ;
  initial_focus = "list_values" ;
  link_path ;
  : text {
    key = "text_rownumber" ;
    width = 50 ;
    horizontal_alignment = centered ;
    vertical_alignment = centered ;
  }
  : row {
    : column {
      spacer ;
      : values_list {
	height = 3 ;
      }
      l_slider ;
      : list_box {
	key = "list_cols" ;
	label = "DA Columns" ;
	width = 50 ;
	height = 3 ;
	horizontal_alignment = centered ;
	vertical_alignment = centered ;
	mnemonic = "D" ;
	value = "0" ;
      }
    }
    : cluster {
      children_fixed_height = true;
      children_alignment = centered;
      : column {
	nav_buttons ;
	: button {
	  key = "button_proceed" ;
	  label = "Proceed..." ;
	  mnemonic = "P" ;
	  alignment = centered ;
	}
      }
    }
  }
  ok_only ;
}

cols_get : dialog {
  label = "Select Key Columns" ;
  initial_focus = "list_cols" ;
  mbt_name ;
  : row {
    : list_box {
      key = "list_cols" ;
      label = "Column Names                      Key"  ;
      height = 7 ;
      width = 40 ;
      tabs = "34 36 38 40" ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
      mnemonic = "C" ;
      value = "0" ;
    }
    : column {
      spacer ;
      : button {
	key = "button_on" ;
	label = "On" ;
	mnemonic = "n" ;
	width = 8 ;
	fixed_width = true ;
	alignment = centered ;
      }
      : button {
	key = "button_off" ;
	label = "Off" ;
	mnemonic = "f" ;
	width = 8 ;
	fixed_width = true ;
	alignment = centered ;
      }
      : button {
	key = "button_allon" ;
	label = "All" ;
	mnemonic = "A" ;
	width = 8 ;
	fixed_width = true ;
	alignment = centered ;
      }
      : button {
	key = "button_alloff" ;
	label = "Reset" ;
	mnemonic = "R" ;
	width = 8 ;
	fixed_width = true ;
	alignment = centered ;
      }
    }
  }
  : column {
    ok_cancel;
    : ase_errtile {
      width = 50 ;
    }
  }
}

getkeyvals : dialog {
  label = "Edit Link Options" ;
  initial_focus = "edit_value";
  mbt_name ;
  : text {
    key = "text_editval" ;
    value = "Enter Search Criteria:" ;
    horizontal_alignment = centered ;
    vertical_alignment = left ;
  }
  : edit_box {
    key = "edit_value" ;
    label = "Criteria:" ;
    edit_limit = 254 ;
    mnemonic = "C" ;
  }
  : row {
    spacer ;
    : button {
      key = "button_key" ;
      label = "Key..." ;
      mnemonic = "K" ;
      width = 12 ;
      fixed_width = true ;
      alignment = centered ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
    }
    : button {
      key = "button_search" ;
      label = "Search..." ;
      mnemonic = "S" ;
      width = 12 ;
      fixed_width = true ;
      alignment = centered ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
    }
    cancel_button ;
    spacer ;
  }
  : ase_errtile {
    width = 50 ;
  }
}

getrowkeyvals : dialog {
  label = "Set Row Options" ;
  initial_focus = "edit_value" ;
  mbt_name ;
  : text {
    key = "text_editval" ;
    value = "Enter Search Criteria" ;
    horizontal_alignment = centered ;
    vertical_alignment = left ;
  }
  : edit_box {
    key = "edit_value" ;
    label = "Criteria:" ;
    edit_limit = 254 ;
    mnemonic = "C" ;
  }
  : row {
    : button {
      key = "button_key" ;
      label = "Key..." ;
      mnemonic = "K" ;
      width = 12 ;
      fixed_width = true ;
      alignment = centered ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
    }
    : button {
      key = "button_search" ;
      label = "Search..." ;
      mnemonic = "S" ;
      width = 12 ;
      fixed_width = true ;
      alignment = centered ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
    }
    : button {
      key = "button_graphical" ;
      label = "Graphical <" ;
      mnemonic = "G" ;
      width = 12 ;
      fixed_width = true ;
      alignment = centered ;
      horizontal_alignment = centered ;
      vertical_alignment = centered ;
    }
    cancel_button ;
  }
  : ase_errtile {
    width = 50 ;
  }
}

dacols : dialog {
  label = "Make Displayable Attribute" ;
  initial_focus = "list_tabcols" ;
  mbt_name ;
  : row {
    : column {
      : list_box {
	key = "list_tabcols" ;
	label = "Table Columns"  ;
	height = 7 ;
	width = 20 ;
	horizontal_alignment = centered ;
	vertical_alignment = centered ;
	mnemonic = "T" ;
	value = "0" ;
      }
    }
    : column {
      : list_box {
	key = "list_dacols" ;
	label = "DA Columns"  ;
	height = 7 ;
	width = 20 ;
	horizontal_alignment = centered ;
	vertical_alignment = centered ;
	mnemonic = "D" ;
	value = "0" ;
      }
    }
  }
  : row {
    : button {
      key = "button_get" ;
      label = "Replace" ;
      mnemonic = "R" ;
      width = 8 ;
      fixed_width = true ;
      alignment = centered ;
    }
    : button {
      key = "button_insert" ;
      label = "Insert" ;
      mnemonic = "I" ;
      width = 8 ;
      fixed_width = true ;
      alignment = centered ;
    }
    : button {
      key = "button_erase" ;
      label = "Erase" ;
      mnemonic = "E" ;
      width = 8 ;
      fixed_width = true ;
      alignment = centered ;
    }
    : button {
      key = "button_reset" ;
      label = "Erase all" ;
      mnemonic = "a" ;
      width = 8 ;
      fixed_width = true ;
      alignment = centered ;
    }
  }
  ok_cancel ;
}


sql_getstm : dialog {
  label = "SQL Editor" ;
  initial_focus = "edit_value";
  mb_name ;
  : text {
    key = "text_editval" ;
    value = "Enter SQL Statement";
    horizontal_alignment = centered ;
    vertical_alignment = left ;
  }
  :edit_box {
    key = "edit_value" ;
    label = "SQL:" ;
    edit_limit = 254 ;
    mnemonic = "S" ;
  }
  : row {
    spacer ;
    : button {
      key = "button_file" ;
      label = "File..." ;
      mnemonic = "F" ;
      width = 8 ;
      fixed_width = true ;
      alignment = centered ;
    }
    : button {
	key = "button_history" ;
	label = "History..." ;
	mnemonic = "H" ;
	width = 10 ;
	fixed_width = true ;
	alignment = centered ;
    }
    : button {
	label  = "Execute...";
	key    = "accept";
	width  = 10;
	fixed_width  = true;
	is_default  = true;
	mnemonic = "E";
    }
    : button {
	label = "Exit";
	key = "cancel";
	fixed_width  = true;
	width  = 8;
	alignment = centered;
	is_cancel	= true;
	mnemonic = "x";
    }
    spacer ;
  }
  : ase_errtile {
    width = 50 ;
  }
}

sql_oldstm : dialog {
  label = "History of SQL Statements" ;
  initial_focus = "list_values";
  mb_name ;
  : values_list {
    hight = 10 ;
  }
  l_slider ;
  ok_cancel ;
}

asemakerep : dialog {
  label = "ASE Make Report" ;
  initial_focus = "edit_value";
  mb_name ;
  : text {
    key = "text_editval" ;
    value = "Enter Report Execution Statement";
    horizontal_alignment = centered ;
    vertical_alignment = left ;
  }
  :edit_box {
    key = "edit_value" ;
    label = "Execute:" ;
    edit_limit = 254 ;
    mnemonic = "E" ;
  }
  : row {
    spacer ;
    : button {
      key = "button_history" ;
      label = "History..." ;
      mnemonic = "H" ;
      width = 10 ;
      fixed_width = true ;
      alignment = centered ;
    }
    : button {
	label  = "Execute";
	key    = "accept";
	width  = 10;
	fixed_width  = true;
	is_default  = true;
	mnemonic = "E";
    }
    : button {
	label = "Exit";
	key = "cancel";
	fixed_width  = true;
	width  = 8;
	alignment = centered;
	is_cancel	= true;
	mnemonic = "x";
    }
    spacer ;
  }
  : ase_errtile {
    width = 50 ;
  }
}

asemakerephis: dialog {
  label = "ASE Make Report History" ;
  initial_focus = "list_values";
  mb_name ;
  : values_list {
    hight = 10 ;
  }
  l_slider ;
  ok_cancel ;
}
