;;;----------------------------------------------------------------------------;
;;;
;;;   ASE.LSP
;;;
;;;   (C) Copyright 1991-1993 by Autodesk, Inc.
;;;
;;;   This program is copyrighted by Autodesk, Inc. and is  licensed
;;;   to you under the following conditions.  You may not distribute
;;;   or  publish the source code of this program in any form.   You
;;;   may  incorporate this code in object form in derivative  works
;;;   provided  such  derivative  works  are  (i.) are  designed and 
;;;   intended  to  work  solely  with  Autodesk, Inc. products, and 
;;;   (ii.)  contain  Autodesk's  copyright  notice  "(C)  Copyright  
;;;   1991-1993 by Autodesk, Inc."
;;;
;;;   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
;;;   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;;;   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;;;
;;;----------------------------------------------------------------------------;

(defun c:aseqview (/ ent)
  (setq saveerr *error*)
  (setq *error* *aseerr*)
  (if (/= nil c:aseinit)
    (progn
      (if (/= nil ase_errno)
        (progn
          (while (= nil (setq ent (car (entsel)))))
          (c:asesetrow ent)
          (if (= 0 ase_errno)
            (c:aseviewrow)
          )
        )
        (alert "ASE Must Be Initialized To Use This Command")
      )
    )
    (alert "ASE Must Be Loaded To Use This Command")
  )
  (setq *error* saveerr)
  (setq saveerr nil)
  (princ)
)

(defun c:aseqedit (/ ent)
  (setq saveerr *error*)
  (setq *error* *aseerr*)
  (if (/= nil c:aseinit)
    (progn
      (if (/= nil ase_errno)
        (progn
          (while (= nil (setq ent (car (entsel)))))
          (c:asesetrow ent)
          (if (= 0 ase_errno)
            (c:aseeditrow)
          )
        )
        (alert "ASE Must Be Initialized To Use This Command")
      )
    )
    (alert "ASE Must Be Loaded To Use This Command")
  )
  (setq *error* saveerr)
  (setq saveerr nil)
  (princ)
)

(defun c:aseqlink ()
  (setq saveerr *error*)
  (setq *error* *aseerr*)
  (if (/= nil c:aseinit)
    (progn
      (if (/= nil ase_errno)
        (progn
          (c:asesetrow)
          (if (= 0 ase_errno)
            (c:asemakelink)
          )
        )
        (alert "ASE Must Be Initialized To Use This Command")
      )
    )
    (alert "ASE Must Be Loaded To Use This Command")
  )
  (setq *error* saveerr)
  (setq saveerr nil)
  (princ)
)

(defun c:aseqmakeda (/ ent)
  (setq saveerr *error*)
  (setq *error* *aseerr*)
  (if (/= nil c:aseinit)
    (progn
      (if (/= nil ase_errno)
        (progn
          (while (= nil (setq ent (car (entsel)))))
          (c:asesetrow ent)
          (if (= 0 ase_errno)
            (c:asemakeda)
          )
        ) 
        (alert "ASE Must Be Initialized To Use This Command")
      )
    )
    (alert "ASE Must Be Loaded To Use This Command")
  )
  (setq *error* saveerr)
  (setq saveerr nil)
  (princ)
)

(defun *aseerr* (msg)
  (if (/= msg "Function cancelled")
    (if (= msg "quit / exit abort")
      (princ)
      (princ (strcat "\nError: " msg))
    )
    (princ)
  )
  (setq *error* saveerr)
  (setq saveerr nil)
  (princ)
)

(princ)
