/* Next available MSG number is 157 */

//    DDIM.DCL      Version 1.0
//
//    Copyright (C) 1991-1993 by Autodesk, Inc.
//         
//    Permission to use, copy, modify, and distribute this software 
//    for any purpose and without fee is hereby granted, provided 
//    that the above copyright notice appears in all copies and that 
//    both that copyright notice and this permission notice appear in 
//    all supporting documentation.
//
//    THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//    WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//    PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.

dcl_settings : default_dcl_settings { audit_level = 0; }

mutton :button{
    fixed_width = true;
    width = 22;
}

// column with default small margins
stack :cluster{
    layout = vertical;
}

dim_row :row{
    children_alignment = bottom;
}

dprot_clrd :dim_row{

    :edit_box{
        label = /*MSG77*/"Dimension Line Color:";
        mnemonic = /*MSG78*/"L";
        key = "clrdt";
        width = 9;
        edit_width=9;
    }
    :swatch{
        key = "clrd";
    }
}

dprot_clre :dim_row{
    :edit_box{
        label = /*MSG79*/"Extension Line Color:";
        mnemonic = /*MSG80*/"E";
        key = "clret";
        width = 9;
        edit_width=9;
    }
    :swatch{
        key = "clre";
    }
}

dprot_clrt :dim_row{
    :edit_box{
        label = /*MSG81*/"Dimension Text Color:";
        mnemonic = /*MSG82*/"D";
        key = "clrtt";
        width = 9;
        edit_width=9;
    }
    :swatch{
        key = "clrt";
    }
}

dprot_e :boxed_column{
    label = /*MSG83*/"Extension Lines";
    :edit12_box{
        label = /*MSG84*/"Extension Above Line:";
        mnemonic = /*MSG85*/"E";
        key = "exe";
    }
    :edit12_box{
        label = /*MSG86*/"Feature Offset:";
        mnemonic = /*MSG87*/"O";
        key = "exo";
    }
    :popup_list{
        label = /*MSG88*/"Visibility";
        mnemonic = /*MSG89*/"y";
        key = "se12";
        list = /*MSG90*/"Draw Both\nSuppress First\nSuppress Second\nSuppress Both";
    }
    :edit12_box{
        label = /*MSG91*/"Center Mark Size:";
        mnemonic = /*MSG92*/"C";
        key = "cen";
    }
    :toggle{
        label = /*MSG93*/"Mark with Center Lines";
        mnemonic = /*MSG94*/"M";
        key = "mcen";
    }
}

dprot_glb :column{
    :row{
        fixed_width = true;
        :text{
            label = /*MSG95*/"Style:";
            is_bold = true;
        }
        :text{
            key = "gdsty";
            width = 24;
        }
    }
    :edit12_box{
        label = /*MSG96*/"Feature Scaling:";
        mnemonic = /*MSG97*/"F";
        key = "gdscl";
    }
    :toggle{
        label = /*MSG98*/"Use Paper Space Scaling";
        mnemonic = /*MSG99*/"P";
        key = "psdscl";
    }
}

dprot_l :boxed_column{
    label = /*MSG100*/"Dimension Line";
    :toggle{
        label = /*MSG101*/"Force Interior Lines";
        mnemonic = /*MSG102*/"I";
        key = "tofl";
    }
    :toggle{
        label = /*MSG103*/"Basic Dimension";
        mnemonic = /*MSG104*/"D";
        key = "ref";
    }
    :edit12_box{
        label = /*MSG105*/"Text Gap:";
        mnemonic = /*MSG106*/"G";
        key = "gap";
    }
    :edit12_box{
        label = /*MSG107*/"Baseline Increment:";
        mnemonic = /*MSG108*/"B";
        key = "dli";
    }
}

dprot_t :boxed_column{
    label = /*MSG109*/"Text Position";
    :edit12_box{
        label = /*MSG110*/"Text Height:";
        mnemonic = /*MSG111*/"x";
        key = "txt";
    }
    :edit12_box{
        label = /*MSG112*/"Tolerance Height:";
        mnemonic = /*MSG113*/"T";
        key = "tfac";
    }
    :popup_list{
        label = /*MSG115*/"Horizontal";
        mnemonic = /*MSG116*/"r";
        key = "tix_soxd";
        list = /*MSG117*/"Default\nForce Text Inside\nText, Arrows Inside";
    }
    :popup_list{
        label = /*MSG118*/"Vertical";
        mnemonic = /*MSG119*/"V";
        key = "tad_tvp";
        list = /*MSG120*/"Centered\nAbove\nRelative";
    }
    :edit12_box{
        label = /*MSG121*/"Relative Position:";
        mnemonic = /*MSG122*/"P";
        key = "tvp";
    }
    :popup_list{
        label = /*MSG123*/"Alignment";
        mnemonic = /*MSG124*/"l";
        key = "tih_toh";
        edit_width = 25;
        list = /*MSG125*/"Orient Text Horizontally\nAlign With Dimension Line\nAligned When Inside Only\nAligned When Outside Only";
    }
}

dprot_a :boxed_column{
    label = /*MSG126*/"Arrows";
    :radio_cluster{
        key = "atype";
        :radio_button{
            label = /*MSG127*/"Arrow";
            mnemonic = /*MSG128*/"A";
            key = "atarrow";
        }
        :radio_button{
            label = /*MSG129*/"Tick";
            mnemonic = /*MSG130*/"k";
            key = "attick";
        }
        :radio_button{
            label = /*MSG131*/"Dot";
            mnemonic = /*MSG132*/"D";
            key = "atdot";
        }
        :radio_button{
            label = /*MSG133*/"User";
            mnemonic = /*MSG134*/"U";
            key = "atblk";
        }
    }
    :edit12_box{
        label = /*MSG135*/"Arrow Size:";
        mnemonic = /*MSG136*/"z";
        key = "asz";
    }
    :column{
        :edit12_box{
            label = /*MSG137*/"User Arrow:";
            mnemonic = "w";
            key = "blk";
            edit_limit = 32;
        }
        :toggle{
            label = /*MSG138*/"Separate Arrows";
            mnemonic = /*MSG139*/"S";
            key = "sah";
        }
        :column{
            :edit12_box{
                label = /*MSG140*/"First Arrow:";
                mnemonic = /*MSG141*/"F";
                key = "blk1";
                edit_limit = 32;
            }
            :edit12_box{
                label = /*MSG142*/"Second Arrow:";
                mnemonic = /*MSG143*/"n";
                key = "blk2";
                edit_limit = 32;
            }
        }
    }
    :edit12_box{
        label = /*MSG144*/"Tick Extension:";
        mnemonic = /*MSG145*/"x";
        key = "dle";
    }
}


ddim :dialog{
    label = /*MSG1*/"Dimension Styles and Variables";
    initial_focus = "styname";
    :row{
        :boxed_column{
            label = /*MSG2*/"Dimension Styles";
            mnemonic = /*MSG51*/"S";
            width = 24;
            :list_box{
                key = "stlb";
                height = 9;
                allow_accept = true;
            }
        }
        :boxed_column{
            label = /*MSG3*/"Dimension Variables";
            width = 24;
            children_alignment = centered;
            :column {
                fixed_height = true;
                :mutton{
                    label = /*MSG146*/"Dimension Line...";
                    mnemonic = /*MSG147*/"L";
                    key = "dlin";
                }
                :mutton{
                    label = /*MSG148*/"Extension Lines...";
                    mnemonic = /*MSG149*/"E";
                    key = "dext";
                }
                :mutton{
                    label = /*MSG150*/"Arrows...";
                    mnemonic = /*MSG151*/"A";
                    key = "darr";
                }
                :mutton{
                    label = /*MSG152*/"Text Location...";
                    mnemonic = /*MSG153*/"T";
                    key = "dtxt";
                }
            }
            :column {
                fixed_height = true;
                :mutton{
                    label = /*MSG4*/"Text Format...";
                    mnemonic = /*MSG52*/"o";
                    key = "dmt";
                }
                :mutton{
                    label = /*MSG5*/"Features...";
                    mnemonic = /*MSG53*/"F";
                    key = "dft";
                }
                :mutton{
                    label = /*MSG6*/"Colors...";
                    mnemonic = /*MSG54*/"C";
                    key = "dct";
                }
            }
        }
    }
    :edit_box{
        label = /*MSG7*/"Dimension Style:";
        mnemonic = /*MSG55*/"D";
        fixed_width = true;
        key = "styname";
        edit_width = 32;
    }
    ok_cancel_help_errtile;
}

dim_a :dialog{
    label = /*MSG8*/"Arrows";
    dprot_glb;
    dprot_clrd;
    dprot_a;
    ok_cancel_help_errtile;
}

dim_c :dialog{
    label = /*MSG9*/"Colors";
    dprot_glb;

    :stack{
        dprot_clrd;
        dprot_clre;
        dprot_clrt;
    }
    ok_cancel_help_errtile;
}

dim_e :dialog{
    label = /*MSG10*/"Extension Lines";
    dprot_glb;
    dprot_clre;
    dprot_e;
    ok_cancel_help_errtile;
}

dim_f :dialog{
    label = /*MSG11*/"Features";
    :row{
        :stack{
            dprot_glb;
            dprot_l;
            dprot_a;
        }
        :stack{
            dprot_e;
            dprot_t;
            ok_cancel_help_errtile;
        }
    }
}

dim_l :dialog{
    label = /*MSG12*/"Dimension Line";
    dprot_glb;
    dprot_clrd;
    dprot_l;
    ok_cancel_help_errtile;
}

dim_m :dialog{
    label = /*MSG13*/"Text Format";
    :row{
        :column{
            dprot_glb;
            :boxed_column{
                label = /*MSG14*/"Basic Units";
                :edit12_box{
                    label = /*MSG15*/"Length Scaling:";
                    mnemonic = /*MSG56*/"S";
                    key = "lfac";
                }
                :toggle{
                    label = /*MSG57*/"Scale In Paper Space Only";
                    mnemonic = /*MSG58*/"O";
                    key = "pslfac";
                }
                :edit12_box{
                    label = /*MSG16*/"Round Off:";
                    mnemonic = /*MSG59*/"R";
                    key = "rnd";
                }
                :edit12_box{
                    label = /*MSG17*/"Text Prefix:";
                    mnemonic = /*MSG60*/"i";
                    key = "post_1";
                }
                :edit12_box{
                    label = /*MSG18*/"Text Suffix:";
                    mnemonic = /*MSG61*/"x";
                    key = "post_2";
                }
            }
            :boxed_row{
                label = /*MSG19*/"Zero Suppression";
                :column{
                    :toggle{
                        label = /*MSG154*/"0 Feet";
                        mnemonic = /*MSG62*/"F";
                        key = "z1";
                    }
                    :toggle{
                        label = /*MSG155*/"0 Inches";
                        mnemonic = "0";
                        key = "z2";
                    }
                }
                :column {
                    :toggle{
                        label = /*MSG20*/"Leading";
                        mnemonic = /*MSG63*/"e";
                        key = "z3";
                    }
                    :toggle{
                        label = /*MSG21*/"Trailing";
                        mnemonic = /*MSG64*/"T";
                        key = "z4";
                    }
                }
            }
        }
        :column{
            :boxed_column{
                fixed_height = true;
                label = /*MSG22*/"Tolerances";
                :radio_column{
                    key = "toltyp";
                    :radio_button{
                        label = /*MSG23*/"None";
                        mnemonic = /*MSG65*/"N";
                        key = "tlnone";
                    }
                    :radio_button{
                        label = /*MSG24*/"Variance";
                        mnemonic = /*MSG66*/"V";
                        key = "tltol";
                    }
                    :radio_button{
                        label = /*MSG25*/"Limits";
                        mnemonic = /*MSG67*/"L";
                        key = "tllim";
                    }
                }
                :column{
                    fixed_height = true;
                    :edit12_box{
                        label = /*MSG26*/"Upper Value:";
                        mnemonic = /*MSG68*/"p";
                        key = "tp";
                    }
                    :edit12_box{
                        label = /*MSG27*/"Lower Value:";
                        mnemonic = /*MSG69*/"w";
                        key = "tm";
                    }
                }
            }
            :boxed_column{
                fixed_height = true;
                label = /*MSG28*/"Alternate Units";
                :toggle{
                    label = /*MSG29*/"Show Alternate Units?";
                    mnemonic = /*MSG70*/"A";
                    key = "alt";
                }
                :column{
                    fixed_height = true;
                    :edit12_box{
                        label = /*MSG30*/"Decimal Places:";
                        mnemonic = /*MSG71*/"D";
                        key = "altd";
                    }
                    :edit12_box{
                        label = /*MSG31*/"Scaling:";
                        mnemonic = /*MSG72*/"c";
                        key = "altf";
                    }
                    :edit12_box{
                        label = /*MSG32*/"Suffix:";
                        mnemonic = /*MSG73*/"u";
                        key = "apost";
                    }
                }
            }
        }
    }
    ok_cancel_help_errtile;
}

dim_t :dialog{
    label = /*MSG33*/"Text Location";
    dprot_glb;
    dprot_clrt;
    dprot_t;
    ok_cancel_help_errtile;
}


// The standard color selection dialogue comes to ADS
// The meat of the dialogue is defined in base.dcl and used here and in
//    acad.dcl.
rq_chroma :dialog {
    label = /*MSG74*/"Select Color";
    key = "chroma";                   // used by Help button to obtain label
    initial_focus = "color_edit";
    std_rq_color;
}

button_12 :button{
    width = 12;
    fixed_width = true;
}

//  Scrolling dialog for displaying help text.
//  Used by the HELPD ADS application.
Help_dia : dialog {
    label = /*MSG34*/"Help";
    initial_focus = "help_item";
    :column {
        :list_box {
            width = 73;
            height = 15;
            key = "help_text";
            multiple_select = true;
            tabs = "9 17 25 33 41 49 57 65 73 81";
            max_lines = 1000;         // Max lines per help item
        }
        :row {
            fixed_width = true;
            alignment = centered;
            :edit_box {
                key = "help_item";
                label = /*MSG35*/"Help Item:";
                mnemonic = /*MSG36*/"H";
                edit_width = 40;
                allow_accept = false;
            }
            :button_12 {
                key = "help_index";
                label = /*MSG43*/"Index...";
                mnemonic = /*MSG44*/"I";
            }
        }
    }
    :row {
        fixed_width = true;
        alignment = centered;
        :button_12 {
            key = "accept";
            label = /*MSG156*/"OK";
            is_default = true;
            is_cancel = true;
        }
        :button_12 {
            key = "help_top";
            label = /*MSG39*/"Top";
            mnemonic = /*MSG40*/"T";
        }
        :button_12 {
            key = "help_prev";
            label = /*MSG41*/"Previous";
            mnemonic = /*MSG42*/"P";
        }
        :button_12 {
            key = "help_next";
            label = /*MSG45*/"Next";
            mnemonic = /*MSG46*/"N";
        }
    }
    errtile;
}

Help_index :dialog {
    label = /*MSG49*/"Help Index";
    initial_focus = "help_index_pattern";
    :list_box {
        key = "help_index_list";
        width = 41;
        height = 15;
        allow_accept = true;
    }
    :edit_box {
        key = "help_index_pattern";
        label = /*MSG75*/"Pattern:";
        mnemonic = /*MSG76*/"P";
        edit_width = 20;
        fixed_width = true;
    }
    ok_cancel_err;
}
