/* Next available MSG number is  35 */

//----------------------------------------------------------------------------
//
//   DDSELECT.DCL   Version 1.0
//
//   Copyright (C) 1991-1993 by Autodesk, Inc.
//      
//   Permission to use, copy, modify, and distribute this software 
//   for any purpose and without fee is hereby granted, provided 
//   that the above copyright notice appears in all copies and that 
//   both that copyright notice and this permission notice appear in 
//   all supporting documentation.
//      
//   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//   
//----------------------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 0; }

ddselect : dialog {
    label = /*MSG1*/"Entity Selection Settings";
    : boxed_column {
        label = /*MSG2*/"Selection Modes";
        : toggle {
            label = /*MSG3*/"Noun/Verb Selection";
            key = "pickfirst";
            mnemonic = /*MSG21*/"N";
            fixed_width = true;
        }
        : toggle {
            label = /*MSG4*/"Use Shift to Add";
            key = "pickadd";
            mnemonic = /*MSG22*/"U";
            fixed_width = true;
        }
        : toggle {
            label = /*MSG5*/"Press and Drag";
            key = "pickdrag";
            mnemonic = /*MSG23*/"P";
            fixed_width = true;
        }
        : toggle {
            label = /*MSG6*/"Implied Windowing";
            key = "pickauto";
            mnemonic = /*MSG24*/"I";
            fixed_width = true;
        }
        : button {
            label = /*MSG7*/"Default Selection Mode";
            key = "default_mode";
            fixed_width = true;
            mnemonic = /*MSG25*/"D";
            alignment = centered;
        }
    }
    : boxed_row {
        label = /*MSG8*/"Pickbox Size";
        mnemonic = /*MSG34*/"S";
        spacer_0;
        : column {
            spacer_0;
            fixed_width = true;
            : text {
                  label = /*MSG9*/"Min         Max";
                  alignment = centered;
            }
            : slider {
                key = "pickbox_slider";
                min_value = 0;
                max_value = 19;
                width = 20;
                height = 1;
                small_increment = 1;
                big_increment = 1;
                fixed_width = true;
                fixed_height = true;
            }
            spacer_0;
        }
        : image {
            key = "pickbox_image";
            aspect_ratio = 1;
            height = 4;
            width = 7;
            color = -2;
        }
        spacer_0;
    }
    : button {
        label = /*MSG11*/"Entity Sort Method...";
        key = "ent_sort";
        mnemonic = /*MSG26*/"E";
        fixed_width = true;
        alignment = centered;
    }
    ok_cancel_help;
}

sortents : dialog {
    label = /*MSG12*/"Entity Sort Method";
    : text {
        label = /*MSG13*/"Sort Entities for...";
    }
    : toggle {
        label = /*MSG14*/"Object Selection";
        key = "sort_obj_sel";
        mnemonic = /*MSG27*/"O";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG15*/"Object Snap";
        key = "sort_obj_snap";
        mnemonic = /*MSG28*/"S";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG16*/"Redraws";
        key = "sort_redraws";
        mnemonic = /*MSG29*/"R";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG17*/"Slide Creation";
        key = "sort_slide";
        mnemonic = /*MSG30*/"l";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG18*/"Regens";
        key = "sort_regens";
        mnemonic = /*MSG31*/"e";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG19*/"Plotting";
        key = "sort_plot";
        mnemonic = /*MSG32*/"P";
        fixed_width = true;
    }
    : toggle {
        label = /*MSG20*/"PostScript Output";
        key = "sort_post";
        mnemonic = /*MSG33*/"c";
        fixed_width = true;
    }
    ok_cancel;
}
