/* Next available MSG number is  61 */

//----------------------------------------------------------------------------
//
//   DDVIEW.DCL   Version 1.0
//
//   Copyright (C) 1991-1993 by Autodesk, Inc.
//      
//   Permission to use, copy, modify, and distribute this software 
//   for any purpose and without fee is hereby granted, provided 
//   that the above copyright notice appears in all copies and that 
//   both that copyright notice and this permission notice appear in 
//   all supporting documentation.
//      
//   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//   
//----------------------------------------------------------------------------
//
//  Dialogue interface to VIEW command.  Used with DDVIEW.LSP
//
//----------------------------------------------------------------------------

dcl_settings : default_dcl_settings { audit_level = 0; }

view : dialog {
    label = /*MSG1*/"View Control";
    initial_focus = "edit_view";
    : list_box {
        label = /*MSG42*/"Views";
        mnemonic = /*MSG43*/"V";
        width = 38;
        tabs = "34";
        key = "list_view";
    }
    : concatenation {
        : text_part {
            label = /*MSG45*/"Restore View: ";
        }
        : text_part {
            key = "res_text";
            width = 32;
        }
    }
    : row {
        : button {
            label = /*MSG3*/"Restore";
            mnemonic = /*MSG4*/"R";
            key = "restore";
        }
        : button {
            label = /*MSG11*/"New...";
            mnemonic = /*MSG46*/"N";
            key = "new_view";
        }
        : button {
            label = /*MSG9*/"Delete";
            mnemonic = /*MSG10*/"D";
            key = "delete";
        }
        : button {
            label = /*MSG59*/"Description...";
            mnemonic = /*MSG12*/"e";
            key = "describe";
        }
    }
    spacer_0;
    ok_cancel_help;
}

new_view : dialog {
    label = /*MSG60*/"Define New View";
    : edit_box {
        key = "new_view_name";
        allow_accept = false;
        label = /*MSG13*/"New Name:";
        mnemonic = /*MSG44*/"N";
        edit_width = 26;
        edit_limit = 31;
    }
    : radio_column {
        : radio_button {
            label = /*MSG5*/"Current Display";
            mnemonic = /*MSG6*/"C";
            key = "r_current";
        }
        : radio_button {
            label = /*MSG7*/"Define Window";
            mnemonic = /*MSG8*/"D";
            key = "r_window";
        }
    }
    : button {
        label = /*MSG47*/"Window <";
        mnemonic = /*MSG48*/"W";
        width = 10;
        key = "window";
        horizontal_alignment = left;
        fixed_width = true;
    }
    : row {
        : boxed_column {
            label = /*MSG49*/"First Corner";
            key = "fc";
            : concatenation {
                : text_part {
                    label = /*MSG50*/"X: ";
                    key = "x1_label";
                }
                : text_part {
                    key = "x1_text";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG51*/"Y: ";
                    key = "y1_label";
                }
                : text_part {
                    key = "y1_text";
                    width = 10;
                }
            }
        }
        : boxed_column {
            label = /*MSG52*/"Other Corner";
            key = "oc";
            : concatenation {
                : text_part {
                    label = /*MSG53*/"X: ";
                    key = "x2_label";
                }
                : text_part {
                    key = "x2_text";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG54*/"Y: ";
                    key = "y2_label";
                }
                : text_part {
                    key = "y2_text";
                    width = 10;
                }
            }
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label = /*MSG55*/"Save View";
            mnemonic = /*MSG56*/"S";
            key = "save_view";
            fixed_width = true;
        }
        : spacer { width = 2; }
        cancel_button;
    }
    errtile;
}


valert : dialog {
    label = /*MSG14*/"Alert";
    : paragraph {
        : text_part {
            label = /*MSG57*/"A View with this name already exists in this";
        }
        : text_part {
            label = /*MSG58*/"drawing.  Do you want to redefine it?";
        }
    }
    : row {
        fixed_width = true;
        alignment = centered;
        : button {
            label           = /*MSG16*/"Redefine";
            key             = "accept";
            mnemonic        = /*MSG17*/"R";
            is_default      = true;
            width           = 8;
        }
        : spacer {
            width = 2;
        }
        : button {
            label           = /*MSG18*/"Cancel";
            key             = "cancel";
            mnemonic        = /*MSG19*/"C";
            is_cancel       = true;
            width           = 6;
        }
    }
}

vinquiry : dialog {
    label = /*MSG20*/"View Description";
    : concatenation {
        : text {
            label = /*MSG21*/"View Name:";
        }
        : text {
            key = "v_name";
            width = 31;
        }
    }
    spacer_1;
    : row {
        : row {
            : column {
                spacer_1;
                : text {
                    label = /*MSG22*/"Width:";
                }
                : text {
                    label = /*MSG23*/"Height:";
                }
                : text {
                    label = /*MSG24*/"Twist:";
                }
            }
            : column {
                spacer_1;
                : text {
                    key = "v_width";
                    width = 10;
                }
                : text {
                    key = "v_height";
                    width = 10;
                }
                : text {
                    key = "v_twist";
                    width = 10;
                }
            }
        }
        spacer_1;
        : column {
            : text {
                key = "cen_tar";
                width = 15;
            } 
            : concatenation {
                : text_part {
                    label = /*MSG29*/"X: ";
                }
                : text_part {
                    key = "vtar_x";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG30*/"Y: ";
                }
                : text_part {
                    key = "vtar_y";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG31*/"Z: ";
                }
                : text_part {
                    key = "vtar_z";
                    width = 10;
                }
            }
        }
        : column {
            : text {
                key = "direction";
                width = 15;
            } 
            : concatenation {
                : text_part {
                    label = /*MSG33*/"X: ";
                }
                : text_part {
                    key = "vdir_x";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG34*/"Y: ";
                }
                : text_part {
                    key = "vdir_y";
                    width = 10;
                }
            }
            : concatenation {
                : text_part {
                    label = /*MSG35*/"Z: ";
                }
                : text_part {
                    key = "vdir_z";
                    width = 10;
                }
            }
        }
    }
    spacer_1;
    : row {
        children_fixed_width = true;
        : column {
            : row {
                : column {
                    : text {
                        label = /*MSG36*/"Perspective:";
                    }
                    : text {
                        label = /*MSG38*/"Front Clipping:";
                    }
                    : text {
                        label = /*MSG40*/"Back Clipping:";
                    }
                }
                : column {
                    : text {
                        key = "persp";
                        width = 4;
                    }
                    : text {
                        key = "fclipon";
                        width = 4;
                    }
                    : text {
                        key = "bclipon";
                        width = 4;
                    }
                }
            }
        }
        : column {
            children_fixed_width = true;
            : row {
                : column {
                    : text {
                        label = /*MSG37*/"Lens Length:";
                    }
                    : text {
                        label = /*MSG39*/"Offset:";
                    }
                    : text {
                        label = /*MSG41*/"Offset:";
                    }
                }
                : column {
                    : text {
                        key = "lens";
                        width = 8;
                    }
                    : text {
                        key = "fclip";
                        width = 8;
                    }
                    : text {
                        key = "bclip";
                        width = 8;
                    }
                }
            }
        }
    }
    spacer_1;
    ok_only;
}


