/* Next available MSG number is  13 */

//----------------------------------------------------------------------------
//
//   DDVPOINT.DCL   Version 1.0
//
//   Copyright (C) 1991-1993 by Autodesk, Inc.
//      
//   Permission to use, copy, modify, and distribute this software 
//   for any purpose and without fee is hereby granted, provided 
//   that the above copyright notice appears in all copies and that 
//   both that copyright notice and this permission notice appear in 
//   all supporting documentation.
//      
//   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
//   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
//   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
//   
//----------------------------------------------------------------------------
//
//  Ddvpoint.dcl - 3D View direction specification tool
//
//----------------------------------------------------------------------------


dcl_settings : default_dcl_settings { audit_level = 0; }

ddvpoint : dialog {
  aspect_ratio = 0;
  label        = /*MSG1*/"Viewpoint Presets";
  fixed_height = true;
  fixed_width  = true;
  : column {
    : row {
      : text {
        label = /*MSG2*/"Set Viewing Angles";
        key   = "ddvp_header";
      }
    }
    : row {
      : radio_row {
        : radio_button {
          label    = /*MSG3*/"Absolute to WCS";
          key      = "ddvp_abs_wcs";
          mnemonic = /*MSG4*/"W";
          value    = "1";
        }
        : radio_button {
          label    = /*MSG5*/"Relative to UCS";
          key      = "ddvp_rel_ucs";
          mnemonic = /*MSG6*/"U";
        }
      }
    }
    : row {
      fixed_width = true;
      fixed_height = true;
      : image_button {
        alignment = top;
        fixed_width = true;
        fixed_height = true;
        key    = "ddvp_image";
        width  = 39;
        height = 14;
        color  = 0;
      }
    }
    : row {
      : edit_box {
        label       = /*MSG7*/"From:  X Axis:";
        mnemonic    = /*MSG8*/"A";
        key         = "ddvp_val_x";
        fixed_width = true;
        edit_width  = 6;
      }
      : edit_box {
        label       = /*MSG9*/"XY Plane:";
        mnemonic    = /*MSG10*/"P";
        key         = "ddvp_val_xyp";
        fixed_width = true;
        edit_width  = 6;
      }
    }
    : row {
      : button {
        label = /*MSG11*/"Set to Plan View";
        key   = "ddvp_set_plan";
        mnemonic = /*MSG12*/"V";
      }
    }
  }
  spacer_1;
  ok_cancel_help_errtile;
}
