'- See the document "Maint.Wri" to find out how to
'modify and add System Variables to this program.

'- Flag to prevent Meaning text being formated redundnatly
'because the Extra Info was toggled off an on while the
'MeanAry was being built.
Dim IsMkMeanAry%
     
'- Used to pass a point value between GetVal & PutVal
'and Pt2Str2 & Pt2Str3.
 Dim TmpPoint As ads_point

'- This procedure returns a value used to adjust
'MatchLstVar's selecting so that it makes the closest
'match.
'      -1 = Make the final selection the variable above
'           the one selected by NumSel.
'       0 = Make the final selection the variable equal
'           to NumSel.
'       1 = Make the final selection the variable below
'           the one selected by NumSel.
'
Function CloseMatch (NumSel%, Key$) As Integer
    
    '--Declare.
    '       Cur% = System Variable currently selected by
    '              NumSel.
    '       Prv% = System Variable previous to the one
    '              selected by NumSel.
    '       Nxt% = System Variable currently selected by
    '              NumSel.
    '
    '   - How many characters match EXactly.
        Dim CurEx%, PrvEx%, NxtEx%
    '
    '   - How far OFF is the first character that doesn't
    '   match exactly.
        Dim CurOff%, PrvOff%, NxtOff%
    '
    '   - Overall rating of how close the string is to
    '   the Key.
        Dim Cur%, Prv%, Nxt%



    HowClose NumSel%, Key$, CurEx%, CurOff%

    '- If NumSel is after the first item in LstVar or
    'later then compute closeness.
    If NumSel > 0 Then
        HowClose (NumSel% - 1), Key$, PrvEx%, PrvOff%
        Else
            PrvEx% = 0
            PrvOff% = 128
    End If

    '- If NumSel is before the last item in LstVar or
    'earlier then compute closeness.
    If NumSel < (FrmSysVars.LstVar.ListCount - 1) Then
        HowClose (NumSel% + 1), Key$, NxtEx%, NxtOff%
        Else
            NxtEx% = 0
            NxtOff% = 128
    End If

    '--Make so the closer the match, the higher the value.
        CurOff% = 128 - CurOff%
        PrvOff% = 128 - PrvOff%
        NxtOff% = 128 - NxtOff%

    '--Make exact matches count more heavly.
        Cur% = (CurEx% * 129) + CurOff%
        Prv% = (PrvEx% * 129) + PrvOff%
        Nxt% = (NxtEx% * 129) + NxtOff%

    '- Determine which variable is the closest match to
    'Key.
    If (Cur% >= Prv%) And (Cur% >= Nxt%) Then
        CloseMatch = 0
        Exit Function
    End If
    If (Prv% >= Cur%) And (Prv% >= Nxt%) Then
        If NumSel > 0 Then
            CloseMatch = -1
            Exit Function
            Else
                CloseMatch = 0
                Exit Function
        End If
    End If
    If (Nxt% >= Cur%) And (Nxt% >= Prv%) Then
        If NumSel < (FrmSysVars.LstVar.ListCount + 1) Then
            CloseMatch = 1
            Exit Function
            Else
                CloseMatch = 0
                Exit Function
        End If
    End If

    '- If they are all equal in closeness, here's the
    'default.
    If NumSel > 0 Then
        CloseMatch = -1
        Else
            CloseMatch = 0
    End If

End Function

'- Resets and clear the controls and displays on the Form.
'
Sub ClrVar ()
    
    FrmSysVars.ScrlVal.Enabled = False
    
    FrmSysVars.OptValOn.Enabled = False
    FrmSysVars.OptValOn.Value = False
    FrmSysVars.OptValOff.Enabled = False
    FrmSysVars.OptValOff.Value = False
    
    FrmSysVars.LabOutVal.Caption = NULSTR
    FrmSysVars.LabOutVal.Visible = False
    
    FrmSysVars.CmbVal(CMBID).Text = NULSTR
    FrmSysVars.CmbVal(CMBID).Visible = False
    
    FrmSysVars.LabOutStatus.ForeColor = BLACK
    FrmSysVars.LabOutStatus.Caption = NULSTR
    FrmSysVars.LabOutType.Caption = NULSTR
    FrmSysVars.LabOutFrom.Caption = NULSTR
    FrmSysVars.LabOutTo.Caption = NULSTR
    FrmSysVars.LabOutSaved.Caption = NULSTR
    FrmSysVars.LabOutMeaning.Caption = NL + TB + NULSTR
    FrmSysVars.ScrlMean.Visible = False
    MeanTextGenerated = False

    '--This is a quick way to clear the contents of
    'the Combo List Box.
        Unload FrmSysVars.CmbVal(CMBID)
        Load FrmSysVars.CmbVal(CMBID)
    
End Sub

'- If no value was placed in the Combo list box, place in
'the list box the current value of the selected System
'Variable.
'
Sub CmbFill ()

    If (FrmSysVars.CmbVal(CMBID).Visible = True) And (FrmSysVars.CmbVal(CMBID).ListCount = 0) Then
        CmbA (FrmSysVars.CmbVal(CMBID).Text)
    End If

End Sub

'- Display the value of the selected System
'Variable in the appropriate output Control.
'
Sub DisplayVal (VarVal$)
    
    If FrmSysVars.CmbVal(CMBID).Visible = True Then
        FrmSysVars.CmbVal(CMBID).Text = VarVal$
        ElseIf FrmSysVars.LabOutVal.Visible = True Then
            FrmSysVars.LabOutVal.Caption = VarVal$
    End If

    UpdateControls

End Sub

'- Error for when components in the AV_ procedure
'conflict.
'
Sub ErrAVComp (VariableName$, SuspCom$)
    
    '-- Declare.
        Dim Msg$

    Beep
    Msg$ = "Internal error in the AV_ procedure for """ + VariableName$ + """. " + NL
    Msg$ = Msg$ + "Error detected in: ""ProcessAV"" " + NL
    Msg$ = Msg$ + "Elements which describe the selected System Variable conflict. "
    Msg$ = Msg$ + "As a default, this System Variable is being treated as if it were "
    Msg$ = Msg$ + "Read and Writeable. " + NL
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other variables might work properly..." + NL
    Msg$ = Msg$ + NL + "(Components in the System Variable's AV_ procedure conflict. "
    Msg$ = Msg$ + "Both CmbOn and LabOn were specified in the AV_ procedure. Only one"
    Msg$ = Msg$ + "can be specifified.)"
    
    MsgBox Msg$, 48, PROGNAME
     
    '--Recover.
    '
        '- Resolve an output conflict by unselecting the
        'Label and selecting the Combo.
        AVArg.LabOn = False
        AVArg.CmbOn = True
        '
        '- Set AVArg.StatusType$ to Read and Writeable to
        'resolve a System Variable modification conflict.
        StatusRW

End Sub

'- Error for when a System Variable name was selected in
'the list box but a match to that name cannot be found
'in DisbatchAV.
'
Sub ErrDisbatchAV ()
    
    '--Declare.
        Dim Msg$, Title$
            
    Beep
    Msg$ = "Internal Error in: ""DisbatchAV""" + NL
    Msg$ = Msg$ + "Unknown AutoCAD System Variable selected." + NL
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other selections may work..." + NL
    Msg$ = Msg$ + NL + "(The programmer made a Boo Boo, S/He declared a System Variable" + NL
    Msg$ = Msg$ + "name in InitLstAV which does not have a" + NL
    Msg$ = Msg$ + "corrosponding name match in DisbatchAV.)"
    Title$ = PROGNAME

    MsgBox Msg$, 48, Title$

    '--Recover.
    '
        'Let program flow just slip off the end of the
        'DisbatchAV procedure.

End Sub

'- Handle error caused when a System Variable value must
'be written to AutoCAD, but it is unknown where to get
'the value to write.
'
Sub ErrPutVal (ErrProc$, SysVar$)
    
    '--Declare.
        Dim Msg$

    Beep
    Msg$ = "Internal error in: """ + ErrProc$ + """" + NL
    Msg$ = Msg$ + "Cannot find the new value for """ + SysVar$ + """ ." + NL
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other variables might work properly..." + NL

    MsgBox Msg$, 48, PROGNAME

    '--Recover.
    '
        FrmSysVars.LabOutVal.Visible = True

End Sub

'- Handle error caused by "CmbBit" containing too many
'tokens.
'
Sub ErrTokenC (TokenC%)
    
    '--Declare.
        Dim Msg$
    
    Beep
    Msg$ = "Internal error in: ""CmbBitNow"" " + NL
    Msg$ = Msg$ + "Too many bit code combinations. " + NL
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other variables might work properly..." + NL
    Msg$ = Msg$ + NL + "(The maximum number of combination elements allowabled is """ + Format$(MAXTOKENC) + """. "
    Msg$ = Msg$ + "The number of combination elements found is """ + Format$(TokenC%) + """.) "
    
    MsgBox Msg$, 48, PROGNAME
     
    '--Recover.
    '
        CmbA ">>BIT CODE COMBINATIONS UNAVAILABLE FOR THIS System Variable<<"
        '- Prevent bit code combination generation.
        TokenC% = 0

End Sub

'- Display an error message reporting that
'an incorrect return type was specified.
'
Sub ErrType ()
    
    '-- Declare.
        Dim Msg$

    Beep
    Msg$ = "Internal error in the AV_ procedure for """ + VariableName$ + """" + NL
    Msg$ = Msg$ + "Error detected in: ""IsErrType"" " + NL
    Msg$ = Msg$ + "Improper return type specified."
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other variables might work properly..." + NL
    Msg$ = Msg$ + NL + "(The return type specified in this System Variable's AV_ procedure "
    Msg$ = Msg$ + "is not the same as the return type reported by AutoCAD. "
    Msg$ = Msg$ + "Correct the Rng* component in this System Variable's AV_ procedure.)"
    
    MsgBox Msg$, 48, PROGNAME
     
    '--Recover.
    '
        'Recovery done in GetVal.

End Sub

Sub ErrTypeUnknown ()
    '-- Declare.
        Dim Msg$

    Beep
    Msg$ = "Internal error in: ""IsErrType""" + NL
    Msg$ = Msg$ + "Unknown return type."
    Msg$ = Msg$ + """" + PROGNAME + """ continuing, other variables might work properly..." + NL
    
    MsgBox Msg$, 48, PROGNAME
     
    '--Recover.
    '
        'Recovery done in GetVal.


End Sub

'- Fill the array "Tokens" with one token per array
'element.
'
Sub FillTokens (ByVal TokenStr$, Tokens() As String)

    '--Declare
        Dim CurSepPos%
        Dim LastSepPos%
        Dim SepNum%
        Dim CharPos%
        Dim LenTokenStr%

    '--Initialize
        CharPos% = 1
        LastSepPos% = 1
        LenTokenStr% = Len(TokenStr$)

    For CharPos% = 1 To LenTokenStr%
        If (Mid$(TokenStr$, CharPos%, 1) = "&") Then
            CurSepPos% = CharPos%
            SepNum% = SepNum% + 1
            Tokens(SepNum%) = Mid$(TokenStr$, LastSepPos%, (CurSepPos% - 1) - LastSepPos%)
            '- Skip the space after &.
            LastSepPos% = CharPos% + 1
        End If
    Next CharPos%
        
        Tokens(SepNum% + 1) = Mid$(TokenStr$, LastSepPos%, LenTokenStr%)


End Sub

'- Initialize the global "TypeVar" to reflect the selected
'System Variable's return type.
'
Sub FillTypeVar ()

    Select Case AVArg.RngType$
        Case "RngS"
            TypeVar = TYPESTRING
        Case "RngI"
            TypeVar = TYPEINT
        Case "RngR"
            TypeVar = TYPEREAL
        Case "Rng2"
            TypeVar = TYPE2D
        Case "Rng3"
            TypeVar = TYPE3D
    End Select

End Sub

'- Display the value of the selected System Variable.
'Also see "PutVal".
'
Function GetVal () As String

    '--Declare.
        Dim ResVal$
        Dim CardType%

    '-Create a Result Buffer (RB). The result returned by
    'AutoLISP will be stored in CardIndex.
    ret% = ads_NewRB(10, CardIndex)

    '- Check if DDE reports everything is okay. If an
    'error occured attempting to make the Result Buffer,
    'DDE_STATUS will equal an error code, otherwise it
    'will equal OK.
    If DDE_STATUS = OK Then

        '- Tell AutoLISP to place the value of the
        'System Variable specified in TermVerialbleName
        'into the data structure CardIndex.
        ret% = ads_GetVar(TermVariableName$, CardIndex)
        
        '--Internal error checking:
        'Check to see if the return type specified in
        'the AV_ procedure is correct.
            ret% = GetNodeType(CardIndex, CardType%)
            If IsErrType(CardType%) Then
                GetVal = ">>>INTERNAL ERROR IN " + PROGNAME + " <<<"
                Exit Function
            End If
        
        Select Case TypeVar

            Case TYPESTRING
                '- Get String.
                Dim ResultS$
                ret% = NextStringNode(CardIndex, ResultS$)
                ResVal$ = ResultS$

            Case TYPEINT
                '- Get Integer.
                Dim ResultI%
                ret% = NextShortNode(CardIndex, ResultI%)
                ResVal$ = Format$(ResultI%)

            Case TYPEREAL
                '- Get Real.
                Dim ResultR#
                ret% = NextRealNode(CardIndex, ResultR#)
                ResVal$ = Format$(ResultR#)

            Case TYPE2D
                '- Get 2D point.
                '- TmpPoint as ads_Point declared globally.
                ret% = NextPointNode(CardIndex, TmpPoint)
                ResVal$ = Pt2Str2()
            Case TYPE3D

                '- Get 3D point.
                '- TmpPoint as ads_Point declared globally.
                ret% = NextPointNode(CardIndex, TmpPoint)
                ResVal$ = Pt2Str3()

        End Select

        '- Release the memory used to get the System
        'Variable's return value.
        ret% = ads_relrb(CardIndex)

    End If

    LasVal$ = ResVal$
    GetVal = ResVal$

End Function

'- This procedure determines how close the match is
'between Key and the item selected with NumSel (in
' LstVar).
'   Ex% = The number of exact charater matches up to
'the first unexact match.
'   off% = How far off the first unexact match is.
'
Sub HowClose (NumSel%, Key$, Ex%, Off%)
    
    '--Declare.
        Dim NumLoops%, SlaveL%, KeyL%, Pos%, Slave$
        Dim KeyChrVal%, SlaveChrVal%

    '--Initialize.
        Pos% = 1
        Key$ = UCase$(Key$)
        Slave$ = UCase$(FrmSysVars.LstVar.List(NumSel%))
        SlaveL% = Len(FrmSysVars.LstVar.List(NumSel%))
        KeyL% = Len(Key$)

    If KeyL% < SlaveL% Then
        NumLoops% = KeyL%
        Else
            NumLoops% = SlaveL%
    End If

    '- Count the number of exact character matched up
    'until the first nonexact match or end of shortest
    'string.
    Do While (Pos% <= NumLoops%) And (Mid$(Slave$, Pos%, 1) = Mid$(Key$, Pos%, 1))
        Pos% = Pos% + 1
    Loop
    Ex% = Pos% - 1
    If Pos% <= NumLoops% Then
        KeyChrVal% = (Asc(Mid$(Key$, Pos%, 1)))
        SlaveChrVal% = (Asc(Mid$(Slave$, Pos%, 1)))
        Off% = Abs(KeyChrVal% - SlaveChrVal%)
        ElseIf SlaveL% < KeyL% Then
                Off% = 128
                Else
                    Off% = 0
            
    End If

End Sub

'- Show information related to the System Variable and
'initialize the Value Controls.
'
Sub InitDisplayInfo (VariableName$, OrigVal$, Text$)

    '- Assign the System Variable's Meaning text
    'to the global variable MeaningTxt so that
    'the text can later be processed.
    MeaningTxt = Text

    '- Initialize the Value Controls and Extra Info.
    ProcessAV VariableName$, OrigVal$

    '- This should come after all other InitDisplayInfo
    'procedures because this procedure is slowest.
    'This procedure creates the scrollable Meaning text.
    Mean

End Sub

Function IsErrType (ActualType%) As Integer

    Select Case TypeVar

        Case TYPESTRING
            If ActualType% <> RTSTR Then
                ErrType
                IsErrType = True
                Exit Function
            End If

        Case TYPEINT
            If ActualType% <> RTSHORT Then
                ErrType
                IsErrType = True
                Exit Function
            End If
        
        Case TYPEREAL
            If ActualType% <> RTREAL Then
                ErrType
                IsErrType = True
                Exit Function
            End If
        
        Case TYPE2D
            If ActualType% <> RTPOINT Then
                ErrType
                IsErrType = True
                Exit Function
            End If
        
        Case TYPE3D
            If ActualType% <> RT3DPOINT Then
                ErrType
                IsErrType = True
                Exit Function
            End If
     
        Case Else
            ErrTypeUnknown
            IsErrType = True
            Exit Function
    End Select
                
    IsErrType = False

End Function

'- This procedure converts non-zero digits in
' "Bits%" to nines. Doing this simulates base two
'within base 10.
'
Sub Make9or0 (BitsStr$)
     
    '--Declare
        Dim Pos%, NewBitsStr$, LenBitStr%

    '--Initialize
        LenBitStr% = Len(BitsStr$)

    For Pos% = LenBitStr% To 1 Step -1
        If Mid$(BitsStr$, Pos%, 1) <> "0" Then
            NewBitsStr$ = "9" + NewBitsStr$
            Else
                NewBitsStr$ = "0" + NewBitsStr$
        End If

    Next Pos%
    BitsStr$ = NewBitsStr$

End Sub

'- This procedure is used by the binary search in
'MkLstMatch. Match determines whether SlaveRaw
'is equal to, Less than, or greater than KeyRaw.
'
'- The Procedure has been made case independant.
'
'- Return values:
'    0 = full match
'    1 = Slave greater
'   -1 = Slave lesser
'
Function Match (SlaveRaw$, KeyRaw$) As Integer
    
    '--Declare.
        Dim Pos%, EndPos%
        Dim KeyL%, SlaveL%
        Dim Slave$, Key$

    '--Initialize.
        Slave$ = UCase$(SlaveRaw$)
        Key$ = UCase$(KeyRaw$)
        KeyL = Len(Key$)
        SlaveL = Len(Slave$)

    If KeyL < SlaveL Then
        EndPos = KeyL
        Else
            EndPos = SlaveL
    End If

    For Pos = 1 To EndPos
        If Mid$(Slave$, Pos%, 1) < Mid$(Key$, Pos%, 1) Then
            Match = -1 'Slave lesser.
            Exit Function
        End If
        If Mid$(Slave$, Pos%, 1) > Mid$(Key$, Pos%, 1) Then
            Match = 1 'Slave greater.
            Exit Function
        End If
    Next Pos

    If SlaveL < KeyL Then
        Match = -1 'Slave lesser.
        Exit Function
        ElseIf SlaveL > KeyL Then
            Match = 1 'Slave greater.
            Exit Function
            Else
                Match = 0 'Match.
    End If

End Function

'- This procedure selects in LstVar whatever item most
'closly matches the text in TxtName.
'
'- This proc uses a binary search to find the closest
'match between the master Key, and Slave. If an exact
'match isn't found, the item selected is adjusted to
'be the closest match.
'
'- These procedures are not case sensitive, but they could
'be altered to become so by taking out the "UCase$"
'statements. I didn't make this case sensitive
'because AutoCAD's implementation of System Variables is
'case independant. Thus the listing in this program should
'also be case independant.
'
Sub MatchLstVar ()

    '--Declare.
        Dim top%, Bot%, MidSrch%, MatchVal%
        Dim Key$, Slave$

    '--Initialize.
        Bot = FrmSysVars.LstVar.ListCount - 1  'Right.
        top = 0   'Left.
        Key$ = FrmSysVars.TxtName.Text

    Do
        MidSrch% = (top + Bot) / 2
        Slave$ = FrmSysVars.LstVar.List(MidSrch%)
        MatchVal% = Match(Slave$, Key$)
        If MatchVal = -1 Then
            top% = MidSrch% + 1
            Else
                Bot% = MidSrch% - 1
        End If
    Loop Until (MatchVal = 0) Or (top% > Bot%)
    FrmSysVars.LstVar.ListIndex = MidSrch% + CloseMatch(MidSrch%, Key$)

End Sub

'- This procedure is in charge of putting the System
'Variable's Meaning text into the scrollable Meaning
'caption box.
'
Sub Mean ()

    '- If "Extra Info" checked then..
    If (FrmSysVars.ChkInfo.Value = 1) Then

        '--Declare.
            Dim LabOutText$, I%

        '- Prevent MkMeanAry from being re-invoked during
        'its internal DoEvents.
        IsMkMeanAry = True

        '- Format the Meaning text.
        MkMeanAry

        IsMkMeanAry = False

        '- If a new command has been selected while
        'Meaning text was being formated, quit and deal
        'with the new selection.
        If AbortCurPros% Then
            Exit Sub
        End If
        
        '- Setup the scroll bar for the Meaning box.
        FrmSysVars.ScrlMean.Visible = True
        If LnAryMean <= MEANWINLNS Then
            FrmSysVars.ScrlMean.Enabled = False
            Else
                FrmSysVars.ScrlMean.Max = LnAryMean - (MEANWINLNS - 1)
                FrmSysVars.ScrlMean.Value = 1
                FrmSysVars.ScrlMean.Enabled = True
        End If
        MeanTextGenerated = True
    End If

End Sub

'- Display non-scrollable text in the Meaning box. It is
'useful to first provide the top of the meaning text and
'then latter invoke the time consuming "Mean" procedure
'which makes the text scrollable. Doing so makes the
'program seem faster to the User.
'
Sub MeanPrep ()

    '- If Extra Info checked then...
    If (FrmSysVars.ChkInfo.Value = 1) Then

        '--Declare
            Dim LabOutText$, I%

        '- MeaningTxt is a global because both SizeObjects
        'and Display need to call this procedure.
        MeaningTxt = MeaningTxt + Chr$(0)

        '- Display default text if no text supplied.
        If Len(MeaningTxt) <= 0 Then
            MeaningTxt = TB + "No summary information available for this System Variable."
        End If

        '- If the first character is a space, get rid of
        'it. This allows for consistency with the way
        'ScrlMean scrolls the text.
        If Left$(MeaningTxt, 1) = " " Then
            LabOutText = Mid$(MeaningTxt, 2)
            Else
                LabOutText = MeaningTxt
        End If

        '- Display non-scrollable meaning text.
        FrmSysVars.LabOutMeaning.Caption = LabOutText
        FrmSysVars.ScrlMean.Visible = False

    End If

End Sub

'- This procedure formats a text string into an array of
'character strings. These arrays are later used by
'ScrlMean to scroll the text in the Meaning box.
'
'- This procedure is slow, but is flexable in that it
'doesn't rely on fixed size type.
'
Sub MkMeanAry ()

    '--Declare
    '
        '- A group of characters which must stay together,
        'but which can be placed anywhere on a line.
        Dim CharChunk$
        '
        '- Contains the position of the end of the
        'CharChunk.
        Dim EndCharChunk%
        '
        '- Flag: The current character chunk includes
        'a New Line?
        Dim IsNL%
        '
        '- Position of the next Space-ending and
        'New Line-ending character chunk.
        Dim SpPos%, NLPos%
        '
        '- Character string used to test if adding the
        'current character chunk will make the line too
        'long to fit in the Meaning box.
        Dim TmpLn$
        '
        '- One string which contains all of the
        'unformatted Meaning text.
        Dim RawTxt$
        '
        '- Grab Position: Position in RawTxt to continue
        'search for Spaces and New Lines, in order to
        'identify the next CharCunk.
        Dim GrbPos%
        '
        '- The array line currently being filled with
        'CharChunks.
        Dim CurLn%
        '
        '- Contains the string array to place the
        'formatted text in.
            '(Global level variable)> AryMean
        '
        '- Keeps track of the number of formated text
        'lines stored in AryMean.
            '(Global level variable)> LnAryMean

    '--Initialize
        IsLn = False
        RawTxt = MeaningTxt
        RawTxt = RawTxt + Chr$(0)
        GrbPos% = 1
        CurLn% = 1
        TmpLn$ = ""
        FrmSysVars.LabSizer.Width = FrmSysVars.LabOutMeaning.Width
    
    '- While all the RawTxt characters haven't been
    'processed do:
    Do While EndCharChunk% < (InStr(RawTxt, Chr$(0)) - 1)
        SpPos = InStr(GrbPos, RawTxt, " ")
        NLPos = InStr(GrbPos, RawTxt, NL)

        '--Make GrbPos beginning and EndCharChunk the end
        'of the current character chunk.
        '
            '- If a space is found, and closer than a NL,
            'then..
            If ((SpPos < NLPos) Or (NLPos < 1)) And (SpPos > 0) Then
                EndCharChunk = SpPos
                ElseIf ((NLPos < SpPos) Or (SpPos < 1)) And (NLPos > 0) Then
                    EndCharChunk = NLPos
                    IsNL = True

                    '- Assume the remainder of RawTxt is to be
                    'the last CharChunk.
                    Else
                        EndCharChunk = InStr(GrbPos, RawTxt, Chr$(0))
            End If
        
        '- Grab the CharChunk out of the RawTxt.
        CharChunk = Mid$(RawTxt, GrbPos, ((EndCharChunk - GrbPos) + 1))

        '- See if CharChunk will fit on the current test line.
        TmpLn$ = TmpLn$ + CharChunk
                    '- Don't count tailing space if there
                    'is one. Prevents inconsistencies
                    'between how non-formatted and
                    'formatted text appears when shown in
                    'a label.
                    FormPos = Len(TmpLn)
                    If (FormPos > 1) And (Mid$(TmpLn, FormPos, 1) = " ") Then
                            FormTmpLn$ = Left$(TmpLn, (FormPos - 1))
                        Else
                            FormTmpLn$ = TmpLn$
                    End If
        FrmSysVars.LabSizer.Caption = FormTmpLn$

        '- If the char chunk fits, make it part of the
        'permanent line array MeanAry.
        If FrmSysVars.LabSizer.Width <= FrmSysVars.LabOutMeaning.Width Then
            If IsNL = False Then
                AryMean(CurLn) = TmpLn$
            End If

            If IsNL Then
                AryMean(CurLn) = TmpLn$ + Chr$(10)
                CurLn = CurLn + 1

                '- NL (new line) is CR and LF, so must
                'skip the LF too.
                EndCharChunk = EndCharChunk + 1
                IsNL = False
                TmpLn$ = ""

                '- Accommodate MkMeanAry's slowness.
                ret% = DoEvents()
                If AbortCurPros% Then
                    Exit Sub
                End If

            End If
            Else
            '-- If the character chunk won't fit, start
            'a new line and put the CharChunk in it.
            '
                    '- Don't count tailing space if there
                    'is one.
                    FormPos = (Len(AryMean(CurLn)))
                    If FormPos > 1 Then
                        If Mid$(AryMean(CurLn), FormPos, 1) = " " Then
                            RawStr$ = AryMean(CurLn)
                            FormStr$ = Left$(RawStr$, (FormPos - 1))
                            AryMean(CurLn) = FormStr$ + NL
                            ElseIf Mid$(AryMean(CurLn), FormPos, 1) = Chr$(13) Then
                                AryMean(CurLn) = AryMean(CurLn) + Chr$(11)
                        End If
                        Else
                            AryMean(CurLn) = AryMean(CurLn) + NL
                    End If

                If IsNL = False Then
                    CurLn = CurLn + 1
                    AryMean(CurLn) = CharChunk
                    TmpLn$ = ""
                    TmpLn$ = CharChunk
                End If

                If IsNL Then
                    CurLn = CurLn + 1
                    AryMean(CurLn) = CharChunk + Chr$(10)
                    CurLn = CurLn + 1
                    TmpLn$ = ""
                    EndCharChunk = EndCharChunk + 1
                    IsNL = False
                End If

                '- Accommodate MkMeanAry's slowness.
                ret% = DoEvents()
                If AbortCurPros% Then
                    Exit Sub
                End If
        
        End If

        '- Truncate output if MeanAry not large enough to
        'hold all the RawText.
        If (CurLn + 1) > ARYMEANMAX Then
            LnAryMean% = CurLn
            Exit Sub
        End If

        '- Make EndCharChunk point to the char
        'after the last char just processed.
        GrbPos% = EndCharChunk% + 1

    Loop

    LnAryMean% = CurLn

End Sub

'- Returns the number of tokens found within "TokenStr$".
'
Function NumTokens (TokenStr$) As Integer

    '--Declare.
        Dim Pos%, TokenC%

    For Pos% = 1 To Len(TokenStr$)
        If Mid$(TokenStr$, Pos%, 1) = TOKENSEP Then
            TokenC% = TokenC% + 1
        End If
    Next Pos%
    NumTokens = TokenC% + 1

End Function

'- Return x to the y. This function uses integers so that
'it runs fast and the numbers won't get high enough to
'overflow.
'
Function Pow (X%, Y%) As Integer

    '--Declare.
        Dim I%, Iter%

    If Y < 1 Then
        Pow = 1
        Else
            Iter% = 1
            For I = 1 To Y%
                Iter% = X% * Iter%
            Next I
            Pow = Iter%
    End If

End Function

'- Process the components specified in the selected System
'Variable's "AV_" procedure.
'
Sub ProcessAV (VariableName$, SysVarVal$)

    '- Internal Error trapping:
    'Produce an error if components in the
    'System Variable's AV procedure conflict.
    If (AVArg.CmbOn = True) And (AVArg.LabOn = True) Then
            ErrAVComp VariableName$, "LabOn"
    End If
    

    '- Process the Rng* component.
    Select Case AVArg.RngType$
        Case "RngS"
            RngSNow AVArg.RangeFrom$, AVArg.RangeTo$
        Case "RngI"
            RngINow AVArg.RangeFrom$, AVArg.RangeTo$
        Case "RngR"
            RngRNow AVArg.RangeFrom$, AVArg.RangeTo$
        Case "Rng2"
            Rng2Now AVArg.RangeFrom$, AVArg.RangeTo$
        Case "Rng3"
            Rng3Now AVArg.RangeFrom$, AVArg.RangeTo$
    End Select

    '- Activate On/Off buttons if requested.
    If AVArg.OptTFOn% Then
        OptTFOnNow
    End If

    '- Activate Value Scroll if requested.
    If AVArg.ScrlOn% Then
        ScrlOnNow AVArg.ScrlOnLC%
    End If

    '- Make an output control visible.
    If AVArg.CmbOn% Then
        CmbOnNow
        If AVArg.CmbNum% Then

            '- This must come after Rng* request has been
            'processed so that it can create the proper
            'value range.
            CmbNumNow


        End If

        '- Don't use "ElseIf AVArg.LabOn% Then"
        'because the Label is the default.
        Else

        LabOnNow

    End If


    '--Display the System Variable's value. This must
    'come after an output control has been made visible.
    If FrmSysVars.CmbVal(CMBID).Visible = True Then 'If print to combo...
        FrmSysVars.CmbVal(CMBID).Text = SysVarVal$
        ElseIf FrmSysVars.LabOutVal.Visible = True Then 'If print to label...
            FrmSysVars.LabOutVal.Caption = SysVarVal$
    End If
        
    '- Make the Value Controls match the value of the
    'System Variable.
    UpdateControls

    '- Display the System Variable's modification
    'attribute.
    Select Case AVArg.StatusType$
        Case "READANDWRITE"
            StatusRWNow
        Case "READONLY"
            StatusRONow
    End Select

    '- Display where, if any where, the System Variable's
    'value is saved.
    Select Case AVArg.SavedType$

        Case "SavedCFG"
            SavedCFGNow
        Case "SavedDWG"
            SavedDWGNow
        Case "SavedNA"
            SavedNANow

    End Select

    '- Display non-scrollable Meaning text.
    MeanPrep

    '- Make this last in this procedure because it is
    'time consuming.
    If (AVArg.CmbBit$ <> "") Then
        CmbBitNow AVArg.CmbBit$
    End If
    
    '- Put default infomation in Combo List if nothing
    'else has been placed there.
    CmbFill

End Sub

'- Use the value stored in the Internals Module variable
' "TmpPoint" to output a text string displaying the X
'and Y coordinates.
'
Function Pt2Str2 () As String

    Pt2Str2 = Str$(TmpPoint.X) + ", " + Str$(TmpPoint.Y)

End Function

'- This Func converts the value in the Internals Module
'variable TmpPoint into a text string displaying
'the X, Y, and Z coordinates.
'
Function Pt2Str3 () As String

    Pt2Str3 = Str$(TmpPoint.X) + ", " + Str$(TmpPoint.Y) + ", " + Str$(TmpPoint.Z)

End Function

'- Write to AutoCAD the new value for the selected
'System Variable.
'
Sub PutVal ()
    
    '--Declare.
        Dim NewVal$

    If (SysVarSel%) And (DDE_STATUS = OK) And (FrmSysVars.LabOutStatus.Caption <> READONLY) Then

        '- Read the new value for the System Variable
        'from the visible Value Box.
        If FrmSysVars.LabOutVal.Visible = True Then
            NewVal$ = FrmSysVars.LabOutVal.Caption
            ElseIf FrmSysVars.CmbVal(CMBID).Visible = True Then
                NewVal$ = FrmSysVars.CmbVal(CMBID).Text
                Else
                    ErrPutVal "PutVal", VariableName$
                   Exit Sub
        End If

        '- If the User input a new value, save the change
        'to AutoCAD.
        If (LastVal$ <> NewVal$) Then

            '- Create a Result Buffer structure. This
            'stucture is a node which will be used in
            'a linked list. The value to be assigned to
            'the System Variable is placed in this Result
            'Buffer and given to AutoLISP to set as
            'the new value of AutoCAD's system variable.
            '- Metaphore: Make a Card Box to place index
            'cards in.
            ret% = ads_NewRB(10, CardIndex)

            
            '- Initialize the Result Buffer node.
            '- Metaphore: Make and Index Card.
            CardIndex.hResBuf% = 0

            '- Created a linked list node which contains
            'the new value for the System Variable.
            '- Metaphore: On this index card write what
            'you want ads_setvar to set the System
            'Variable to.
            Select Case TypeVar
                Case TYPESTRING
                    card.apType = RTSTR
                    card.apString = NewVal$ + Chr$(0)
                Case TYPEINT
                    card.apType = RTSHORT
                    card.apShort = Val(NewVal$)
                Case TYPEREAL
                    card.apType = RTREAL
                    card.apReal = Val(NewVal$)
                Case TYPE2D
                    card.apType = RTPOINT
                    card.apPoint.X = Str2PtX(NewVal$)
                    card.apPoint.Y = Str2PtY(NewVal$)
                    'Card.apPoint.z = Str2PtZ(NewVal$)
                Case TYPE3D
                    card.apType = RT3DPOINT
                    card.apPoint.X = Str2PtX(NewVal$)
                    card.apPoint.Y = Str2PtY(NewVal$)
                    card.apPoint.Z = Str2PtZ(NewVal$)
            End Select

            '- Add the Result Buffer node to a  VBADS
            'linked list structure.
            '- Metaphore: Place the card in the Card Box.
            'If there are other cards in the Card Box,
            'place the lattest addition in the back of
            'the box.
            ret% = ApndLLNode(CardIndex, card)

            '- Set the System Variable.
            '- Metaphore: Give ads_setvar:
            '   1) The name of the System Variable to set.
            '   2) The Card Box containing the index card
            '   which has written on it the new value to
            '   assign to the System Variable.
            ret% = ads_setvar(TermVariableName$, CardIndex)

            '- Reliquish the memory used to create the
            'linked list.
            '- Metaphore: Recycle the Card Box and all the
            'cards in it.
            ret% = ads_relrb(CardIndex)

        End If
    End If

End Sub

'- Reset the AVArg values for the next System Variable.
'
Sub ResetAVArg ()

    AVArg.RngType = ""
    AVArg.OptTFOn = False
    AVArg.ScrlOn% = False
    AVArg.LabOn% = False
    AVArg.CmbOn% = False
    AVArg.CmbBit$ = ""
    AVArg.StatusType = ""
    AVArg.SavedType = ""

End Sub

'- Determine if the same variable is being re-selected.
'
Function SameVar () As Integer
    
    If LastSelSysVarIndex = FrmSysVars.LstVar.ListIndex Then
        SameVar = True
        Else
            SameVar = False
    End If

End Function

'- This procedure sets up the Form by reading,
'interpreting, and implementing the selected
'System Variable's "AV_" procedure.
'
Sub SetupForm ()

    '- Copy the name of the variable selected into
    'the TxtName control.
    FrmSysVars.TxtName.Text = FrmSysVars.LstVar.Text

    '- Highlight the variable name in the text box because
    'the User will probably want to change the whole name
    'to a new variable name instead of editing the
    'exitsting name.
    FrmSysVars.TxtName.SelStart = 0
    FrmSysVars.TxtName.SelLength = Len(FrmSysVars.TxtName.Text)

    
    '-  Allow background processing.
    AbortCurPros% = False

    '- Record that a System Variable is currently Selected.
    SysVarSel% = True

    '- Reset Read Only warning.
    HadWarnRO% = False

    '- The currently selected System Variable index counts
    'as the "last" index when makeing checks in the future.
    LastSelSysVarIndex% = FrmSysVars.LstVar.ListIndex

    '- Reset any settings made by the last seleced System
    'Variable's AV_ procedure.
    ResetAVArg

    '- Run the DisbatchAV procedure.
    'Note: DisbatchAV cannot be directly called because
    'Visual Basic does not support calling procedures
    'contained in a Form from within a Modual. To get
    'around this LabRunDisbatchAV's _Change event runs
    'DisbatchAV. So, whenever the text in LabRunDisbatchAV
    'is changed, it is as though DisbatchAV had been
    'called.
    If FrmSysVars.LabRunDisbatchAV.Caption = "Changing the text in Caption" Then
        FrmSysVars.LabRunDisbatchAV.Caption = "causes invokes the _Change event."
        Else
            FrmSysVars.LabRunDisbatchAV.Caption = "Changing the text in Caption"
    End If


End Sub

'- Make the Form window grow or shrink to expose or hide
'additional information about selected System Variable.
'
Sub SizeObjects ()
    
    '- If "Extra Info" not checked then...
    If FrmSysVars.ChkInfo.Value = 0 Then

        FrmSysVars.Height = FRMSYSVAR_HEIGHT_INFOOFF
        FrmSysVars.LstVar.Height = LSTVAR_HEIGHT_INFOOFF

        '- I don't want the ScrlMean to get focus when
        'it's not visible.
        FrmSysVars.ScrlMean.Enabled = False

        Else  'If "Extra Info" IS checked then...

            FrmSysVars.Height = FRMSYSVAR_HEIGHT_INFOON
            FrmSysVars.LstVar.Height = LSTVAR_HEIGHT_INFOON
            If (IsMkMeanAry = False) And (DDE_STATUS = OK) Then
                If MeanTextGenerated Then
                    FrmSysVars.ScrlMean.Visible = True
                    FrmSysVars.ScrlMean.Enabled = True
                    Else
                        MeanPrep
                        Mean
                End If

            End If
    End If

End Sub

'- Convert the X coordinate portion of a string into a
'Real (Double) number and return that value.
'
Function Str2PtX (StrPoint$) As Double
    
    If InStr(StrPoint, ",") = 0 Then
        Str2PtX = Val(StrPoint)
        Else
        Str2PtX = Val(Left$(StrPoint$, (InStr(StrPoint$, ",") - 1)))
    End If

End Function

'- Convert the Y coordinate portion of a string into a
'Real (Double) number and return that value.
'
Function Str2PtY (StrPoint$) As Double
    
    If InStr(StrPoint, ",") = 0 Then
        Exit Function 'Only zero or X given.
        Else
            Dim YandZ$
            YandZ = Mid$(StrPoint, (InStr(StrPoint, ",") + 1))
            If InStr(YandZ, ",") = 0 Then
                Str2PtY = Val(YandZ)  'Only X and Y were given.
                Else
                    Str2PtY = Val(Left$(YandZ, (InStr(YandZ, ",") - 1)))
            End If
    End If

End Function

'- Convert the Z coordinate portion of a string into a
'Real (Double) number and return that value.
'
Function Str2PtZ (StrPoint$) As Double
    
    If InStr(StrPoint, ",") = 0 Then
        Exit Function 'Only zero or X given.
        Else
            Dim YandZ$
            YandZ = Mid$(StrPoint, (InStr(StrPoint, ",") + 1))
            If InStr(YandZ, ",") = 0 Then
                Exit Function    'Ony X and Y given.
                Else
                    Dim Zand4$
                    Zand4 = Mid$(YandZ, (InStr(YandZ, ",") + 1))
                    If InStr(Zand4, ",") = 0 Then   'In case 4D coords ever used.
                        Str2PtZ = Val(Zand4)
                        Else
                            Str2PtZ = Val(Left$(Zand4, (InStr(Zand4, ",") - 1)))
                    End If
            End If
    End If

End Function

'- Clean up after last selected System Variable.
'
Sub UnselVar ()
    
    '- If the currently selected System Variable is being
    'unselected then...
    If SysVarSel% Then

        '- Save the Value of the now unselected System
        'Variable.
        PutVal

        '- Abort any background processing for the now
        'unselected System Variable.
        AbortCurPros% = True

        '- Clear the Form's display.
        ClrVar

        '- Enable Read Only modification warning.
        HadWarnRO% = False
        
        '- Record that no System Variable is currently
        'selected.
        SysVarSel% = False

        '- Make the program do a full Form reset even if
        'the same System Variable which has just been
        'Canceled is immediately re-selected.
        LastSelSysVarIndex% = -1

    End If

End Sub

'- This procedure:
'   1) Ensures that the value is within a legal range
'(specified by Rng* in the AV_ procedure).
'   2) Updates the "On/Off" option buttons if appropriate.
'   3) Makes the Value Scroll bar set itself to the value
'   in the combo box.
'
Sub UpdateControls ()
    
    '--Declare.
        Dim NewVal#
        '- Contains the value in the visible input box
        'when the On/Off buttons are used. This value
        'is used to determine if the value means On or
        'Off.
        Dim TFValue$

    '- Indicate to *_Change procedures that input is
    'not comming from the User.
    UserIn = False

    If FrmSysVars.CmbVal(CMBID).Visible = True Then
        NewVal# = Val(FrmSysVars.CmbVal(CMBID).Text)
        Else
            NewVal# = Val(FrmSysVars.LabOutVal.Caption)
    End If

    '- Error checking, make sure value is within specified
    'bounds.
    If NewVal# < RngFrom# Then
        FrmSysVars.CmbVal(CMBID).Text = Format$(RngFrom#)
        FrmSysVars.CmbVal(CMBID).SelStart = 0
        FrmSysVars.CmbVal(CMBID).SelLength = Len(FrmSysVars.TxtName.Text)

        
        ElseIf NewVal > RngTo# Then
            FrmSysVars.CmbVal(CMBID).Text = Format$(RngTo#)
            FrmSysVars.CmbVal(CMBID).SelStart = 0
            FrmSysVars.CmbVal(CMBID).SelLength = Len(FrmSysVars.TxtName.Text)
    End If

    '- If On/Off values valid then...
    If IsTFValue = True Then
        If FrmSysVars.CmbVal(CMBID).Visible = True Then
            TFValue$ = UCase$(FrmSysVars.CmbVal(CMBID).Text)
            Else
                TFValue$ = UCase$(FrmSysVars.LabOutVal.Caption)
        End If
        Select Case TFValue$
            Case "1"
                FrmSysVars.OptValOn.Value = True
            Case "TRUE"
                FrmSysVars.OptValOn.Value = True
            Case "ON"
                FrmSysVars.OptValOn.Value = True
            Case "N"
                FrmSysVars.OptValOn.Value = True
            Case "0"
                FrmSysVars.OptValOff.Value = True
            Case "FALSE"
                FrmSysVars.OptValOff.Value = True
            Case "OFF"
                FrmSysVars.OptValOff.Value = True
            Case "F"
                FrmSysVars.OptValOff.Value = True
        End Select
    End If
    
    If FrmSysVars.ScrlVal.Enabled Then
        FrmSysVars.ScrlVal.Value = Val(FrmSysVars.CmbVal(CMBID).Text)
    End If

    UserIn = True

End Sub

