'- See the document "Maint.Wri" to find out how to
'modify and add System Variables to this program.

'- Add the name of a System Variable to LstVar.
'
Sub AddVar (SysVarName$)

    FrmSysVars.LstVar.AddItem (SysVarName$)

End Sub

'- Add a line of text to the Combo.
'
Sub CmbA (AddText$)

    '- Ensure that the Combo Box is activated.
    CmbOn

    FrmSysVars.CmbVal(CMBID).AddItem (AddText$)

End Sub

'- Request bit codes with descriptions to be added
'to the combo list box.
'
Sub CmbBit (TokenStr$)

    '- Ensure that the Combo Box is activated.
    CmbOn

    AVArg.CmbBit$ = TokenStr$
    
End Sub

'- Add bit codes with descriptions to be added
'to the combo list box.
'
Sub CmbBitNow (TokenStr$)

    '--Declare.
        Dim BitsStr$
        Dim BitsStrL%
        Dim Bit$
        Dim Desc$
        Dim BinaryCode%
        Dim Item%
        Dim TokenC%
        Static Tokens(1 To MAXTOKENC) As String

    '--Initialize.
        TokenStr$ = " " + TokenStr$
        TokenC% = NumTokens(TokenStr$)
        If TokenC% > MAXTOKENC Then
            ErrTokenC TokenC%
            Else
                FillTokens TokenStr$, Tokens()
        End If

    '- Loop as many times as there are bit codes.
    For Item% = 1 To (Pow(2, TokenC%) - 1)

        Desc$ = ""
        BitsStr$ = Format$(Val(BitsStr$) + 1)
        Make9or0 BitsStr$
        BitsStrL% = Len(BitsStr$)
        
        '- Build the description of the current bit code
        'Item.
        For Pos% = 1 To BitsStrL%
            Bit$ = Mid$(BitsStr$, (BitsStrL% - Pos%) + 1, 1)
            If Bit$ <> "0" Then

                '- Make "Tokens" return in right to left
                'order.
                Desc = Tokens((TokenC% - Pos%) + 1) + " " + TOKENSEP + Desc

            End If
        Next Pos%

        Desc = Format$(Item%) + " " + Left$(Desc, (Len(Desc) - 2))
        CmbA Desc
        
        '- Accomidate this procedure's slowness.
        ret% = DoEvents()
        If AbortCurPros% Then
            Exit Sub
        End If

    Next Item%

End Sub

'- Request that a of possible integer values for the
'System Variable be available through the combo list box.
'
Sub CmbNum ()

    '- Ensure that the Combo Box is activated.
    CmbOn

    AVArg.CmbNum% = True

End Sub

'- Add all legal integer values for the System Variable
'to the combo list box.
'
Sub CmbNumNow ()

    '--Declare.
        Dim ItemN%
    
    '- Ensure that the Combo Box is activated.
    CmbOn

    For ItemN% = RngFrom# To RngTo#
        CmbA (Str$(ItemN%))
    Next ItemN%

End Sub

'- Request that the Combo Box be used to display and edit
'the System Variable's value.
'
Sub CmbOn ()

    AVArg.CmbOn = True

End Sub

'- Use the Combo box for editing the System Variable's
'value.
'
Sub CmbOnNow ()

    If (FrmSysVars.LabOutVal.Visible = False) And (FrmSysVars.CmbVal(CMBID).Visible = True) Then
        Exit Sub
        Else
            FrmSysVars.LabOutVal.Visible = False
            FrmSysVars.CmbVal(CMBID).Visible = True
    End If

End Sub

'- Display the System Variable's value, information
'about the System Variable, and allow the variable
'to be edited if it's not Read Only.
'
Sub Display (VarName$, Text$)
    
    '- GetVal needs to know what return val to expect,
    'thus, this procudure must provide that information
    'befor GetVal is called.
    FillTypeVar

    '- Make the name of the selected System Varible
    'known globally becasue GetVal and PutVal need
    'this information.
    VariableName$ = VarName$

    '- Also make accessable to GetVal and PutVal
    'the System Variable name with a terminating
    'ASCII character zero.
    TermVariableName$ = VarName$ + Chr$(0)

    '- Get value of requested System Variable and save
    'this value see if changes made by the User must
    'be saved.
    LastVal$ = GetVal()

    '- If an error didn't occur during the DDE transferr
    'then continue processing...
    If DDE_STATUS = OK Then

        '- Show information related to the System
        'Variable and initialize the Value Controls.
        InitDisplayInfo VariableName$, LastVal$, Text$

    End If
        
        '- Reset True/False System Variable indicator.
        IsTFValue = False

End Sub

'- Request that the label be used for System Variable
'value output.
'
Sub LabOn ()

    AVArg.LabOn = True

End Sub

'- Use the label for displaying the value of the
'selected System Variable.
'
Sub LabOnNow ()
    
    If (FrmSysVars.CmbVal(CMBID).Visible = False) And (FrmSysVars.LabOutVal.Visible = True) Then
        Exit Sub
        Else
            FrmSysVars.CmbVal(CMBID).Visible = False
            FrmSysVars.LabOutVal.Visible = True
    End If

End Sub

'- Request that the On/Off option buttons be used.
'
Sub OptTFOn ()

    AVArg.OptTFOn% = True

End Sub

'- Use the On/Off option buttons.
'
Sub OptTFOnNow ()

    FrmSysVars.OptValOn.Enabled = True
    FrmSysVars.OptValOff.Enabled = True
    IsTFValue = True

End Sub

'- Request setup for 2-D point return type.
'
Sub Rng2 (RangeFrom$, RangeTo$)

    AVArg.RngType$ = "Rng2"
    AVArg.RangeFrom$ = RangeFrom$
    AVArg.RangeTo$ = RangeTo$

End Sub

'- Setup for 2-D point return type.
'
Sub Rng2Now (RangeFrom$, RangeTo$)
    
    '- Value Type 2D.
    FrmSysVars.LabOutType.Caption = "2-D Point"
    
     If RangeFrom$ = "" Then
        RngFrom# = HIGHRANGE2D * -1
        FrmSysVars.LabOutFrom.Caption = RNGMIN2D$
        Else
            RngFrom# = Val(RangFrom$)
            FrmSysVars.LabOutFrom.Caption = RangeFrom$
     End If

     If RangeTo$ = "" Then
        RngTo# = HIGHRANGE2D
        FrmSysVars.LabOutTo.Caption = RNGMAX2D$
        Else
            RngTo# = Val(RangeTo$)
            FrmSysVars.LabOutTo.Caption = RangeTo$
     End If

End Sub

'- Request setup for 3-D point return type.
'
Sub Rng3 (RangeFrom$, RangeTo$)

    AVArg.RngType$ = "Rng3"
    AVArg.RangeFrom$ = RangeFrom$
    AVArg.RangeTo$ = RangeTo$

End Sub

'- Setup for 3-D point return type.
'
Sub Rng3Now (RangeFrom$, RangeTo$)
    
    '- Value Type 3D.
    FrmSysVars.LabOutType.Caption = "3-D Point"
     
     If RangeFrom$ = "" Then
        RngFrom# = HIGHRANGE3D * -1
        FrmSysVars.LabOutFrom.Caption = RNGMIN3D$
        Else
            RngFrom# = Val(RangFrom$)
            FrmSysVars.LabOutFrom.Caption = RangeFrom$
     End If

     If RangeTo$ = "" Then
        RngTo# = HIGHRANGE3D
        FrmSysVars.LabOutTo.Caption = RNGMAX3D$
        Else
            RngTo# = Val(RangeTo$)
            FrmSysVars.LabOutTo.Caption = RangeTo$
     End If

End Sub

'- Request setup for Integer return type.
'
Sub RngI (RangeFrom$, RangeTo$)

    AVArg.RngType$ = "RngI"
    AVArg.RangeFrom$ = RangeFrom$
    AVArg.RangeTo$ = RangeTo$

End Sub

'- Setup for Integer return type.
'
Sub RngINow (RangeFrom$, RangeTo$)
    
    '- Value Type Integer.
     FrmSysVars.LabOutType.Caption = "Integer Number"
     
     If RangeFrom$ = "" Then
        RngFrom# = LOWRANGEINT
        FrmSysVars.LabOutFrom.Caption = RNGMINI$
        Else
            RngFrom# = Val(RangFrom$)
            FrmSysVars.LabOutFrom.Caption = RangeFrom$
     End If

     If RangeTo$ = "" Then
        RngTo# = HIGHRANGEINT
        FrmSysVars.LabOutTo.Caption = RNGMAXI$
        Else
            RngTo# = Val(RangeTo$)
            FrmSysVars.LabOutTo.Caption = RangeTo$
     End If

End Sub

'- Request setup for Real return type.
'
Sub RngR (RangeFrom$, RangeTo$)

    AVArg.RngType$ = "RngR"
    AVArg.RangeFrom$ = RangeFrom$
    AVArg.RangeTo$ = RangeTo$

End Sub

'- Setup for Real return type.
'
Sub RngRNow (RangeFrom$, RangeTo$)
    
    '- Value Type Real.
     FrmSysVars.LabOutType.Caption = "Real Number"
     
     If RangeFrom$ = "" Then
        RngFrom# = HIGHRANGEREAL * -1
        FrmSysVars.LabOutFrom.Caption = RNGMINR$
        Else
            RngFrom# = Val(RangFrom$)
            FrmSysVars.LabOutFrom.Caption = RangeFrom$
     End If

     If RangeTo$ = "" Then
        RngTo# = HIGHRANGEREAL
        FrmSysVars.LabOutTo.Caption = RNGMAXR$
        Else
            RngTo# = Val(RangeTo$)
            FrmSysVars.LabOutTo.Caption = RangeTo$
     End If
    
End Sub

'- Request setup for String return type.
'
Sub RngS (RangeFrom$, RangeTo$)

    AVArg.RngType$ = "RngS"
    AVArg.RangeFrom$ = RangeFrom$
    AVArg.RangeTo$ = RangeTo$

End Sub

'- Setup for String return type.
'
Sub RngSNow (RangeFrom$, RangeTo$)

    '- Value Type String.
    FrmSysVars.LabOutType.Caption = "Character String"
    
    RngFrom# = 0
    RngTo# = 0
     If RangeFrom$ = "" Then
        FrmSysVars.LabOutFrom.Caption = RNGMINS$
        Else
            FrmSysVars.LabOutFrom.Caption = RangeFrom$
     End If
     If RangeTo$ = "" Then
        FrmSysVars.LabOutTo.Caption = RNGMAXS$
        Else
            FrmSysVars.LabOutTo.Caption = RangeTo$
     End If

End Sub

'- Request that information be displayed which indicates
'that the selected System Variable is saved to the
'AutoCAD Configuragion file.
'
Sub SavedCFG ()

    AVArg.SavedType$ = "SavedCFG"

End Sub

'- Display infromation indicating that the selected System
'Variable is saved to the AutoCAD Configuration file.
'
Sub SavedCFGNow ()

    FrmSysVars.LabOutSaved.Caption = "Config"

End Sub

'- Request that information be displayed which indicates
'that the selected System Variable is saved to the
'AutoCAD drawing file.
'
Sub SavedDWG ()

    AVArg.SavedType$ = "SavedDWG"

End Sub

'- Display infromation indicating that the selected System
'Variable is saved to the AutoCAD drawing file.
'
Sub SavedDWGNow ()

    FrmSysVars.LabOutSaved.Caption = "Drawing"

End Sub

'- Request that information be displayed which indicates
'that the selected System Variable is not saved.
'
Sub SavedNA ()

    AVArg.SavedType$ = "SavedNA"

End Sub

'- Display infromation indicating that the selected System
'Variable is not saved.
'
Sub SavedNANow ()

    FrmSysVars.LabOutSaved.Caption = "N/A"

End Sub

'- Request that the Value Scroll be used and set
'its LargeChange property.
'
Sub ScrlOn (LC%)

    AVArg.ScrlOn% = True
    AVArg.ScrlOnLC% = LC%

End Sub

'- Use the Value Scroll and set its LargeChange property.
'
Sub ScrlOnNow (LC%)

    FrmSysVars.ScrlVal.Enabled = True
    FrmSysVars.ScrlVal.Min = RngFrom#
    FrmSysVars.ScrlVal.Max = RngTo#
    FrmSysVars.ScrlVal.LargeChange = LC%

End Sub

'- Request that infromation be displayed which
'indicates that the selected System Variable is Read Only.
'
Sub StatusRO ()

    AVArg.StatusType$ = "READONLY"

End Sub

'- Indicate that the selected System Variable is Read Only.
'
Sub StatusRONow ()

    FrmSysVars.LabOutStatus.Caption = READONLY  ' "Read Only"
    FrmSysVars.LabOutStatus.ForeColor = READONLYCOLOR
End Sub

'- Indicates that the selected System Variable is Readable and
'Write able.
'
Sub StatusRW ()

    AVArg.StatusType$ = "READANDWRITE"

End Sub

'- Indicates that the selected System Variable is Readable
'and Write able.
'
Sub StatusRWNow ()
    
    FrmSysVars.LabOutStatus.Caption = READANDWRITE  ' "Read and Write"
    FrmSysVars.LabOutStatus.ForeColor = READANDWRITECOLOR

End Sub

