'
' The user of this file should not change any of the definitions between ADS Data Types and User
' Global Data Definition Area.  The definitions are required for the functions that perform the
' formating of ADS data types.
'

'
' ADS Data Types
'

Type ads_name
  H As Long
  L As Long
End Type

Type ads_point
  X As Double
  Y As Double
  Z As Double
End Type

Type ads_binary             ' Binary data chunk structure
    clen As Integer         ' length of chunk in bytes
    buf As String * 255     ' binary data
End Type

Type ads_real
    val As Double
End Type

Type ads_matrix
    a(0 To 3, 0 To 3) As Double
End Type

Type LinkListType
    FirstNode As Long       ' first node of the linked list
    LastNode As Long        ' last
    CurrentNode As Long     ' current
    status As Integer       ' value returned from linked list functions
End Type

Type ResbufType             ' resbuf value that the user works with
    hResbuf As Integer      ' handle returned to the user
    LinkList As LinkListType
End Type

Type ApndLLType
    hLinkList As Integer
    apType As Integer
    apString As String * 255
    apLong As Long
    apName As ads_name
    apPoint As ads_point
    apReal As Double
    apShort As Integer
    apBinary As ads_binary
    retval As Integer
End Type

Type DelNodeType
    hResbuf As Integer
    flag As Integer
    retval As Integer
End Type

Type RewLLType
    hResbuf As Integer
    retval As Integer
End Type

Type GetNodeType
    hResbuf As Integer
    type As Integer
    retval As Integer
End Type

Type NextLLNodeType
    hResbuf As Integer
    anyIndex As Integer
    dxfIndex As Integer
    anyLong As Long
    anyName As ads_name
    anyPoint As ads_point
    anyReal As Double
    anyShort As Integer
    anyBinary As ads_binary
    anyString As String * 255
    retval As Integer
End Type

Type NextShortNode
    hResbuf As Integer
    i As Integer
    retval As Integer
End Type

Type NextLongNode
    hResbuf As Integer
    i As Long
    retval As Integer
End Type

Type NextNameNode
    hResbuf As Integer
    i As ads_name
    retval As Integer
End Type

Type NextPointNode
    hResbuf As Integer
    i As ads_point
    retval As Integer
End Type

Type NextRealNode
    hResbuf As Integer
    i As Double
    retval As Integer
End Type

Type NextStringNode
    hResbuf As Integer
    i As String * 255
    retval As Integer
End Type

'
' ADS Function Types
'

Type ADSABORT
    str As String * 255
    retval As Integer
End Type

Type ADSANGLE
    pt1 As ads_point
    pt2 As ads_point
    retval As Double
End Type

Type ADSANGTOF
    v As Double
    unit As Integer
    str As String * 255
    retval As Integer
End Type

Type ADSANGTOS
    v As Double
    unit As Integer
    prec As Integer
    str As String * 255
    retval As Integer
End Type

Type ADSCMD
    rbp As Integer
    retval As Integer
End Type

Type ADSCVUNIT
    Value As Double
    oldunit As String * 255
    newunit As String * 255
    result As Double
    retval As Integer
End Type

Type ADSDISTANCE
    pt1 As ads_point
    pt2 As ads_point
    retval As Double
End Type

Type ADSDISTOF
    val As Double
    unit As Integer
    str As String * 255
    retval As Integer
End Type

Type ADSENTDEL
    ent As ads_name
    retval As Integer
End Type

Type ADSENTGET
    ent As ads_name
    hResbuf As Integer
    retval As Integer
End Type

Type ADSENTGETX
    ent As ads_name
    hApps As Integer
    hResbuf As Integer
    retval As Long
End Type

Type ADSENTLAST
    result As ads_name
    retval As Integer
End Type

Type ADSENTMAKE
    ent As Integer
    retval As Integer
End Type

Type ADSENTMOD
    ent As Integer
    retval As Integer
End Type

Type ADSENTNEXT
    ent As ads_name
    result As ads_name
    nullflag As Integer
    retval As Integer
End Type

Type ADSENTSEL
    str As String * 255
    entres As ads_name
    ptres As ads_point
    retval As Integer
End Type

Type ADSENTUPD
    ent As ads_name
    retval As Integer
End Type

Type ADSEXIT
    status As Integer
End Type

Type ADSFAIL
    str As String * 255
    retval As Integer
End Type

Type ADSFINDFILE
    fname As String * 255
    result As String * 255
    retval As Integer
End Type

Type ADSGETANGLE
    pt As ads_point
    prompt As String * 255
    result As Double
    nullflag As Integer
    retval As Integer
End Type

Type ADSGETCORNER
    pt As ads_point
    prompt As String * 255
    result As ads_point
    nullflag As Integer
    retval As Integer
End Type

Type ADSGETDIST
    pt As ads_point
    prompt As String * 255
    result As Double
    nullflag As Integer
    retval As Integer
End Type

Type ADSGETFUNCODE
    retval As Integer
End Type

Type ADSGETINPUT
    str As String * 512
    retval As Integer
End Type

Type ADSGETINT
    prompt As String * 255
    result As Integer
    retval As Integer
End Type

Type ADSGETKWORD
    prompt As String * 512
    result As String * 512
    retval As Integer
End Type

Type ADSGETORIENT
    pt As ads_point
    prompt As String * 255
    result As Double
    nullflag As Integer
    retval As Integer
End Type

Type ADSGETPOINT
    pt As ads_point
    prompt As String * 255
    result As ads_point
    nullflag As Integer
    retval As Integer
End Type

Type ADSGETREAL
    prompt As String * 255
    result As Double
    retval As Integer
End Type

Type ADSGETSTRING
    cronly As Integer
    prompt As String * 255
    result As String * 255
    retval As Integer
End Type

Type ADSGETSYM
    sname As String * 255
    hResbuf As Integer
    retval As Integer
End Type

Type ADSGETVAR
    sym As String * 255
    hResbuf As Integer
    retval As Integer
End Type

Type ADSGRAPHSCR
    retval As Integer
End Type

Type ADSGRCLEAR
    retval As Integer
End Type

Type ADSGRDRAW
    From As ads_point
    To As ads_point
    color As Integer
    hl As Integer
    retval As Integer
End Type

Type ADSGRREAD
    track As Integer
    type As Integer
    hResbuf As Integer
    retval As Integer
End Type

Type ADSGRTEXT
    box As Integer
    hl As Integer
    text As String * 255
    retval As Integer
End Type

Type ADSGRVECS
   hVlist As Integer
   mat As ads_matrix
   nullflag As Integer
   retval As Integer
End Type

Type ADSHANDENT
    HANDLE As String * 255
    entres As ads_name
    retval As Integer
End Type

Type ADSINITGET
    val As Integer
    kwl As String * 512
    retval As Integer
End Type

Type ADSINTERS
    from1 As ads_point
    to1 As ads_point
    from2 As ads_point
    to2 As ads_point
    teston As Integer
    result As ads_point
    retval As Integer
End Type

Type ADSINVOKE
    hArgs As Integer
    hResult As Integer
    retval As Integer
End Type

Type ADSLOADED
   hResbuf As Integer
   retval As Integer
End Type

Type ADSMENUCMD
    str As String * 255
    retval As Integer
End Type

Type ADSNENTSELP
    str As String * 255
    entres As ads_name
    ptres As ads_point
    pickflag As Integer
    xformres As ads_matrix
    hRefstkres As Integer
    nullflag As Integer
    retval As Integer
End Type

Type ADSNEWRB
    v As Integer
    hResbuf As Integer
    retval As Long
End Type

Type ADSOSNAP
    pt As ads_point
    mode As String * 255
    result As ads_point
    retval As Integer
End Type

Type ADSPOLAR
    pt As ads_point
    angle As Double
    dist As Double
    ptres As ads_point
    retval As Integer
End Type

Type ADSPRINTF
    str As String * 132
    retval As Integer
End Type

Type ADSPROMPT
    str As String * 132
    retval As Integer
End Type

Type ADSPUTSYM
    sname As String * 255
    hResbuf As Integer
    retval As Integer
End Type

Type ADSREDRAW
    ent As ads_name
    mode As Integer
    nullflag As Integer
    retval As Integer
End Type

Type ADSREGAPP
    appname As String * 132
    retval As Integer
End Type

Type ADSRELRB
    hResbuf As Integer
    retval As Integer
End Type

Type ADSRTOS
    val As Double
    unit As Integer
    prec As Integer
    str As String * 255
    retval As Integer
End Type

Type ADSSETVAR
    sym As String * 255
    val As Integer
    retval As Integer
End Type

Type ADSSSADD
    ename As ads_name
    sname As ads_name
    result As ads_name
    nullflag As Integer
    retval As Integer
End Type

Type ADSSSDEL
    ename As ads_name
    ss As ads_name
    retval As Integer
End Type

Type ADSSSFREE
    sname As ads_name
    retval As Integer
End Type

Type ADSSSGET
    str As String * 255
    pt1 As ads_point
    pt2 As ads_point
    entmask As Integer
    ss As ads_name
    nullflag As Integer
    retval As Integer
End Type

Type ADSSSGETBUF
    str As String * 255
    pt1 As Integer
    pt2 As ads_point
    entmask As Integer
    ss As ads_name
    nullflag As Integer
    retval As Integer
End Type

Type ADSSSLENGTH
    sname As ads_name
    len As Long
    retval As Integer
End Type

Type ADSSSMEMB
    ename As ads_name
    ss As ads_name
    retval As Integer
End Type

Type ADSSSNAME
    ss As ads_name
    i As Long
    entres As ads_name
    retval As Integer
End Type

Type ADSTABLET
   hArgs As Integer
   hResult As Integer
   nullflag As Integer
   retval As Integer
End Type

Type ADSTBLNEXT
    tblname As String * 255
    rewind As Integer
    hResbuf As Integer
    retval As Integer
End Type

Type ADSTBLSEARCH
    tblname As String * 255
    sym As String * 255
    setnext As Integer
    hResbuf As Integer
    retval As Integer
End Type

Type ADSTEXTBOX
   hEnt As Integer
   p1 As ads_point
   p2 As ads_point
   retval As Integer
End Type

Type ADSTEXTPAGE
    retval As Integer
End Type

Type ADSTEXTSCR
    retval As Integer
End Type

Type ADSTRANS
    pt As ads_point
    From As Integer
    To As Integer
    disp As Integer
    result As ads_point
    retval As Integer
End Type

Type ADSUSRBRK
    retval As Integer
End Type

Type ADSVPORTS
   hVports As Integer
   retval As Integer
End Type

Type ADSWCMATCH
    str As String * 255
    pattern As String * 255
    retval As Integer
End Type

Type ADSXDROOM
    ent As ads_name
    result As Long
    retval As Integer
End Type

Type ADSXDSIZE
    xd As Integer
    result As Long
    retval As Integer
End Type

Type ADSXFORMSS
   ssname As ads_name
   genmat As ads_matrix
   retval As Integer
End Type

Type ADSXLOAD
   app As String * 255
   retval As Integer
End Type

Type ADSXUNLOAD
   app As String * 255
   retval As Integer
End Type

Global a_abort As ADSABORT
Global a_angle As ADSANGLE
Global a_angtof As ADSANGTOF
Global a_angtos As ADSANGTOS
Global a_cmd As ADSCMD
Global a_cvunit As ADSCVUNIT
Global a_distance As ADSDISTANCE
Global a_distof As ADSDISTOF
Global a_entdel As ADSENTDEL
Global a_entget As ADSENTGET
Global a_entgetx As ADSENTGETX
Global a_entlast As ADSENTLAST
Global a_entmake As ADSENTMAKE
Global a_entmod As ADSENTMOD
Global a_entnext As ADSENTNEXT
Global a_entsel As ADSENTSEL
Global a_entupd As ADSENTUPD
Global a_exit As ADSEXIT
Global a_fail As ADSFAIL
Global a_findfile As ADSFINDFILE
Global a_getangle As ADSGETANGLE
Global a_getcorner As ADSGETCORNER
Global a_getdist As ADSGETDIST
Global a_getfuncode As ADSGETFUNCODE
Global a_getinput As ADSGETINPUT
Global a_getint As ADSGETINT
Global a_getkword  As ADSGETKWORD
Global a_getorient As ADSGETORIENT
Global a_getpoint As ADSGETPOINT
Global a_getreal As ADSGETREAL
Global a_getstring As ADSGETSTRING
Global a_getvar As ADSGETVAR
Global a_getsym As ADSGETSYM
Global a_graphscr As ADSGRAPHSCR
Global a_grclear As ADSGRCLEAR
Global a_grdraw As ADSGRDRAW
Global a_grread As ADSGRREAD
Global a_grtext As ADSGRTEXT
Global a_grvecs As ADSGRVECS
Global a_handent As ADSHANDENT
Global a_initget As ADSINITGET
Global a_inters As ADSINTERS
Global a_invoke As ADSINVOKE
Global a_loaded As ADSLOADED
Global a_menucmd As ADSMENUCMD
Global a_nentselp As ADSNENTSELP
Global a_newrb As ADSNEWRB
Global a_osnap As ADSOSNAP
Global a_polar As ADSPOLAR
Global a_printf As ADSPRINTF
Global a_prompt As ADSPROMPT
Global a_putsym As ADSPUTSYM
Global a_redraw As ADSREDRAW
Global a_regapp As ADSREGAPP
Global a_relrb As ADSRELRB
Global a_rtos As ADSRTOS
Global a_setvar As ADSSETVAR
Global a_ssadd As ADSSSADD
Global a_ssdel As ADSSSDEL
Global a_ssfree As ADSSSFREE
Global a_ssget As ADSSSGET
Global a_ssgetbuf As ADSSSGETBUF
Global a_sslength As ADSSSLENGTH
Global a_ssmemb As ADSSSMEMB
Global a_ssname As ADSSSNAME
Global a_tablet As ADSTABLET
Global a_tblnext As ADSTBLNEXT
Global a_tblsearch As ADSTBLSEARCH
Global a_textbox As ADSTEXTBOX
Global a_textpage As ADSTEXTPAGE
Global a_textscr As ADSTEXTSCR
Global a_trans As ADSTRANS
Global a_usrbrk As ADSUSRBRK
Global a_vports As ADSVPORTS
Global a_wcmatch As ADSWCMATCH
Global a_xdroom As ADSXDROOM
Global a_xdsize As ADSXDSIZE
Global a_xformss As ADSXFORMSS
Global a_xload As ADSXLOAD
Global a_xunload As ADSXUNLOAD

' link list types
Global l_rewll As RewLLType
Global l_nodetype As GetNodeType
Global l_nextllnode As NextLLNodeType
Global l_nextshortnode As NextShortNode
Global l_nextlongnode As NextLongNode
Global l_nextnamenode As NextNameNode
Global l_nextrealnode As NextRealNode
Global l_nextpointnode As NextPointNode
Global l_nextstringnode As NextStringNode
Global l_apndllnode As ApndLLType
Global l_delnode As DelNodeType

'
' Function definitions
'

Declare Sub AcadActivate Lib "acadvb.dll" (ByVal Wnd%)
Declare Sub CopyCommBuff Lib "acadvb.dll" (ByVal hMem%, ByVal t%, Struct As Any)

Declare Sub TCopyCommBuff Lib "acadvb.dll" (ByVal t%, Struct As Any)
Declare Function TBuildCommBuff% Lib "acadvb.dll" (ByVal t%, Struct As Any)

Declare Function FindAcad% Lib "acadvb.dll" ()
Declare Function FindAcadText% Lib "acadvb.dll" ()
Declare Function BuildCommBuff% Lib "acadvb.dll" (ByVal t%, Struct As Any)
Declare Function MemFree% Lib "acadvb.dll" (ByVal hMem%)
Declare Function GetLinkListInfo% Lib "acadvb.dll" (ByVal hMem%, Struct As LinkListType)

'
' Constant alias's for ADS functions.
' THESE DEFINITIONS MUST NOT BE CHANGED.
'

Global Const ADSCMD_ABORT = 1
Global Const ADSCMD_ANGLE = 2
Global Const ADSCMD_ANGTOF = 3
Global Const ADSCMD_ANGTOS = 4
Global Const ADSCMD_BUILDLIST = 5
Global Const ADSCMD_CMD = 6
Global Const ADSCMD_CVUNIT = 7
Global Const ADSCMD_DISTANCE = 8
Global Const ADSCMD_DISTOF = 9
Global Const ADSCMD_ENTDEL = 10
Global Const ADSCMD_ENTGET = 11
Global Const ADSCMD_ENTGETX = 12
Global Const ADSCMD_ENTLAST = 13
Global Const ADSCMD_ENTMAKE = 14
Global Const ADSCMD_ENTMOD = 15
Global Const ADSCMD_ENTNEXT = 16
Global Const ADSCMD_ENTSEL = 17
Global Const ADSCMD_ENTUPD = 18
Global Const ADSCMD_EXIT = 19
Global Const ADSCMD_FAIL = 20
Global Const ADSCMD_FINDFILE = 21
Global Const ADSCMD_GETANGLE = 22
Global Const ADSCMD_GETARGS = 23
Global Const ADSCMD_GETCORNER = 24
Global Const ADSCMD_GETDIST = 25
Global Const ADSCMD_GETFUNCODE = 26
Global Const ADSCMD_GETINPUT = 27
Global Const ADSCMD_GETINT = 28
Global Const ADSCMD_GETKWORD = 29
Global Const ADSCMD_GETORIENT = 30
Global Const ADSCMD_GETPOINT = 31
Global Const ADSCMD_GETREAL = 32
Global Const ADSCMD_GETSTRING = 33
Global Const ADSCMD_GETVAR = 34
Global Const ADSCMD_GRAPHSCR = 35
Global Const ADSCMD_GRCLEAR = 36
Global Const ADSCMD_GRDRAW = 37
Global Const ADSCMD_GRREAD = 38
Global Const ADSCMD_GRTEXT = 39
Global Const ADSCMD_HANDENT = 40
Global Const ADSCMD_INITGET = 41
Global Const ADSCMD_INTERS = 42
Global Const ADSCMD_INVOKE = 43
Global Const ADSCMD_MENUCMD = 44
Global Const ADSCMD_NENTSELP = 45
Global Const ADSCMD_NEWRB = 46
Global Const ADSCMD_OSNAP = 47
Global Const ADSCMD_POLAR = 48
Global Const ADSCMD_PRINTF = 49
Global Const ADSCMD_PROMPT = 50
Global Const ADSCMD_REDRAW = 51
Global Const ADSCMD_REGAPP = 52
Global Const ADSCMD_RELRB = 53
Global Const ADSCMD_RTOS = 62
Global Const ADSCMD_SETVAR = 63
Global Const ADSCMD_SSADD = 64
Global Const ADSCMD_SSDEL = 65
Global Const ADSCMD_SSFREE = 66
Global Const ADSCMD_SSGET = 67
Global Const ADSCMD_SSLENGTH = 68
Global Const ADSCMD_SSMEMB = 69
Global Const ADSCMD_SSNAME = 70
Global Const ADSCMD_TBLNEXT = 71
Global Const ADSCMD_TBLSEARCH = 72
Global Const ADSCMD_TEXTPAGE = 73
Global Const ADSCMD_TEXTSCR = 74
Global Const ADSCMD_TRANS = 75
Global Const ADSCMD_WCMATCH = 76
Global Const ADSCMD_XDROOM = 77
Global Const ADSCMD_XDSIZE = 78

Global Const ADSCMD_GETSYM = 79
Global Const ADSCMD_PUTSYM = 80
Global Const ADSCMD_TABLET = 81
Global Const ADSCMD_GRVECS = 82
Global Const ADSCMD_VPORTS = 83
Global Const ADSCMD_TEXTBOX = 84
Global Const ADSCMD_XLOAD = 85
Global Const ADSCMD_XUNLOAD = 86
Global Const ADSCMD_LOADED = 87
Global Const ADSCMD_XFORMSS = 88
Global Const ADSCMD_SSGETBUF = 89

Global Const LLCMD_NODETYPE = 200
Global Const LLCMD_NEXTSHORTNODE = 201
Global Const LLCMD_NEXTLONGNODE = 202
Global Const LLCMD_NEXTNAMENODE = 203
Global Const LLCMD_NEXTPOINTNODE = 204
Global Const LLCMD_NEXTREALNODE = 205
Global Const LLCMD_NEXTSTRINGNODE = 206
Global Const LLCMD_NEXTLLNODE = 207
Global Const LLCMD_REWLL = 208
Global Const LLCMD_APNDLLNODE = 209
Global Const LLCMD_DELNODE = 210

'
' DelNode will leave the link list pointing at the before (PRENODE)
' or after (POSTNODE) the deleted node.  If all nodes in list are deleted then
' list->status will be set to NOTINITIALIZED.
'
Global Const PRENODE = 0
Global Const POSTNODE = 1

Global Const GXCHUNK = 1004  ' Binary data type.  Only found in
                             ' extended entity data.

'
' DDE Channel Configuration
'
' DDE_CHANNELOPEN if true then we have established an open channel
' with AutoCAD.
'
' DDE_STATUS contains the result of establishing communication with Acad.
' It gets set by calls to PkgDDE from ADS functions.
'
' DDE_TIMEOUT is the amount of time to wait for a response from a DDE server.  It is in 10ths
' of a second.  Your program should have a <Main> function that sets this to a default value.
' You can then change it as necessary prior to doing ADS function calls.  A default value of
' 0 will wait forever.
'

Global DDE_CHANNELOPEN As Integer
Global DDE_STATUS As Integer           ' this will contain the dde error code
Global DDE_TIMEOUT As Integer          ' amount of time to wait for dde transfer in 10ths

Global Const OK = 0
Global Const NOTOK = -100

'
' DDE_STATUS Return Values
'
' On return from a DDE DDE_STATUS will be 0 if no error.
' If DDE could not be accomplished due to problems not
' related to DDE channel, one of the following values will
' be in DDE_STATUS.  If there is a DDE problem then DDE_STATUS
' will contain the DDE error value returned from Windows.  The
' definition of this value is found the Visual Basic Language
' reference.
'

Global Const ACAD_ERROR = -2000
Global Const MEMORY_ALLOCATION_ERROR = -2001

'
' Linked List Error Returns Values.
'
' These values are returned in the retval field of command structures that
' return result buffer linked lists (ENTGET ect).  They indicate failures
' other than thoese usually returned by AutoCAD.
'

Global Const NO_MEMORY = -3000          ' no memory available to create lists
Global Const LINK_GONE = -3001          ' result buffer list that was created has disappeared.
Global Const BADLLHANDLE = -3002        ' handle to uninitialized (no result buffer) linked list.
Global Const INVALIDNODE = -3003        ' invalid node found in linked list.
Global Const WRONGDATATYPE = -3004      ' wrong data type requested
Global Const INVALIDFLAG = -3005        ' bad flag sent to DelNode

' Node State Values

Global Const INITIALIZED = -1
Global Const NOTINITIALIZED = 0

' Definitions of the AutoCAD function request and result
' codes used by ADS programs.

' AutoCAD to ADS program request type codes

Global Const RQTERM = 0                    ' Force terminate ADS program
Global Const RQSAVE = 14                   ' ACAD is saving the drawing
Global Const RQEND = 15                    ' ACAD is ending the drawing editor
Global Const RQQUIT = 16                   ' ACAD quits

' The following are LISP to Application ONLY request codes.  They form
' the interface for ADS
Global Const RQXLOAD = 100                 ' Load external functions
Global Const RQXUNLD = 101                 ' UN-Load application
Global Const RQSUBR = 102                  ' External subroutine request
 
'  ADS program to AutoCAD result type codes

Global Const RSRSLT = 1                    ' Result returned
Global Const RSERR = 3                     ' Error in evaluation -- no result
 
'  Result value type codes
 
    ' These are used in the resbuf.  These ARE NOT the same
    ' as the group codes used in the entity access routines, and should
    ' not be confused with those.  The same result buffer IS used for
    ' entity records, however, in which case the restype field may take
    ' on many more values than those listed here.
 
Global Const RTNONE = 5000                 ' No result
Global Const RTREAL = 5001                 ' Real number
Global Const RTPOINT = 5002                ' 2D point X and Y only
Global Const RTSHORT = 5003                ' Short integer
Global Const RTANG = 5004                  ' Angle
Global Const RTSTR = 5005                  ' String
Global Const RTENAME = 5006                ' Entity name
Global Const RTPICKS = 5007                ' Pick set
Global Const RTORINT = 5008                ' Orientation
Global Const RT3DPOINT = 5009              ' 3D point - X, Y, and Z
Global Const RTLONG = 5010                 ' Long integer
Global Const RTVOID = 5014                 ' Blank symbol
Global Const RTLB = 5016                   ' list begin
Global Const RTLE = 5017                   ' list end
Global Const RTDOTE = 5018                 ' dotted pair
Global Const RTNIL = 5019                  ' nil
Global Const RTDXF0 = 5020                 ' DXF code 0 for ads_buildlist only
 
' The following RT codes are for the ADS program interface.
' They are used to signal success or failure (error) of the
' ADS library functions.  RTFAIL in particular means that
' the link has failed (most likely because AutoLISP has
' died or exited), and the application should cleanup and exit.
'
 
Global Const RTNORM = 5100                 ' Request succeeded
 
' Various error codes returned to ADS application by library
Global Const RTERROR = -5001               ' Some other error
Global Const RTCAN = -5002                 ' User cancelled request -- Ctl-C
Global Const RTREJ = -5003                 ' AutoCAD rejected request -- invalid
Global Const RTFAIL = -5004                ' Link failure -- Lisp probably died
Global Const RTKWORD = -5005               ' Keyword returned from getxxx() routine
 
'
'============================================================================'
' ****** USER DATA AREA *******
' USER GLOBAL DEFINITIONS CAN GO HERE.  IF YOU WILL BE USING MORE THAN A FEW
' GLOBALS, IT IS BETTER TO PLACE THEM IN A SEPARATE FILE.
'
'============================================================================'
'

'============================================================================='
'                                                                             '
' Visual Basic global constants.  These definitions are suggested by          '
' Microsoft but are not mandatory.                                            '
'                                                                             '
' Some constants are commented out because they have duplicates (for          '
' example, NONE appears in several places).                                   '
'                                                                             '
'============================================================================='

'========='
'         '
' General '
'         '
'========='

'=================='
'                  '
' Event parameters '
'                  '
'=================='

' Button and Shift (KeyDown, KeyUp, MouseDown, MouseMove, MouseUp)
Global Const SHIFT_MASK = 1
Global Const CTRL_MASK = 2
Global Const ALT_MASK = 4
Global Const LEFT_BUTTON = 1
Global Const RIGHT_BUTTON = 2
Global Const MIDDLE_BUTTON = 4

' ErrNum (LinkError)
Global Const WRONG_FORMAT = 1
Global Const REQUEST_WITHOUT_INIT = 2
Global Const DDE_WITHOUT_INIT = 3
Global Const ADVISE_WITHOUT_INIT = 4
Global Const POKE_WITHOUT_INIT = 5
Global Const DDE_SERVER_CLOSED = 6
Global Const TOO_MANY_LINKS = 7
Global Const STRING_TOO_LONG = 8
Global Const INVALID_CONTROL_ARRAY_REFERENCE = 9
Global Const UNEXPECTED_DDE = 10
Global Const OUT_OF_MEMORY = 11
Global Const SERVER_ATTEMPTED_CLIENT_OPERATION = 12

' KeyCode (KeyDown, KeyUp)
Global Const KEY_LBUTTON = &H1
Global Const KEY_RBUTTON = &H2
Global Const KEY_CANCEL = &H3
Global Const KEY_MBUTTON = &H4         ' NOT contiguous with L & RBUTTON
Global Const KEY_BACK = &H8
Global Const KEY_TAB = &H9
Global Const KEY_CLEAR = &HC
Global Const KEY_RETURN = &HD
Global Const KEY_SHIFT = &H10
Global Const KEY_CONTROL = &H11
Global Const KEY_MENU = &H12
Global Const KEY_PAUSE = &H13
Global Const KEY_CAPITAL = &H14
Global Const KEY_ESCAPE = &H1B
Global Const KEY_SPACE = &H20
Global Const KEY_PRIOR = &H21
Global Const KEY_NEXT = &H22
Global Const KEY_END = &H23
Global Const KEY_HOME = &H24
Global Const KEY_LEFT = &H25
Global Const KEY_UP = &H26
Global Const KEY_RIGHT = &H27
Global Const KEY_DOWN = &H28
Global Const KEY_SELECT = &H29
Global Const KEY_PRINT = &H2A
Global Const KEY_EXECUTE = &H2B
Global Const KEY_SNAPSHOT = &H2C
Global Const KEY_INSERT = &H2D
Global Const KEY_DELETE = &H2E
Global Const KEY_HELP = &H2F

' KEY_A thru KEY_Z are the same as their ASCII equivalents: 'A' thru 'Z'
' KEY_0 thru KEY_9 are the same as their ASCII equivalents: '0' thru '9'

Global Const KEY_NUMPAD0 = &H60
Global Const KEY_NUMPAD1 = &H61
Global Const KEY_NUMPAD2 = &H62
Global Const KEY_NUMPAD3 = &H63
Global Const KEY_NUMPAD4 = &H64
Global Const KEY_NUMPAD5 = &H65
Global Const KEY_NUMPAD6 = &H66
Global Const KEY_NUMPAD7 = &H67
Global Const KEY_NUMPAD8 = &H68
Global Const KEY_NUMPAD9 = &H69
Global Const KEY_MULTIPLY = &H6A
Global Const KEY_ADD = &H6B
Global Const KEY_SEPARATOR = &H6C
Global Const KEY_SUBTRACT = &H6D
Global Const KEY_DECIMAL = &H6E
Global Const KEY_DIVIDE = &H6F
Global Const KEY_F1 = &H70
Global Const KEY_F2 = &H71
Global Const KEY_F3 = &H72
Global Const KEY_F4 = &H73
Global Const KEY_F5 = &H74
Global Const KEY_F6 = &H75
Global Const KEY_F7 = &H76
Global Const KEY_F8 = &H77
Global Const KEY_F9 = &H78
Global Const KEY_F10 = &H79
Global Const KEY_F11 = &H7A
Global Const KEY_F12 = &H7B
Global Const KEY_F13 = &H7C
Global Const KEY_F14 = &H7D
Global Const KEY_F15 = &H7E
Global Const KEY_F16 = &H7F
Global Const KEY_NUMLOCK = &H90

' State (DragOver)
Global Const ENTER = 0
Global Const LEAVE = 1
Global Const OVER = 2

'====================='
'                     '
' Function parameters '
'                     '
'====================='

' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed


'==================='
'                   '
' Method parameters '
'                   '
'==================='

' Drag (controls)
Global Const CANCEL = 0
Global Const BEGIN_DRAG = 1
Global Const END_DRAG = 2

' GetData, GetFormat, SetData (Clipboard)
Global Const CF_LINK = &HBF00
Global Const CF_TEXT = 1
Global Const CF_BITMAP = 2
Global Const CF_METAFILE = 3
Global Const CF_DIB = 8

' Show (form)
Global Const MODAL = 1
Global Const MODELESS = 0

'================='
'                 '
' Property values '
'                 '
'================='

' Alignment (label)
Global Const LEFT_JUSTIFY = 0          ' 0 - Left Justify
Global Const RIGHT_JUSTIFY = 1         ' 1 - Right Justify
Global Const CENTER = 2                ' 2 - Center

' BackColor, ForeColor, FillColor (standard RGB colors: form, controls)
Global Const BLACK = &H0&
Global Const RED = &HFF&
Global Const GREEN = &HFF00&
Global Const YELLOW = &HFFFF&
Global Const BLUE = &HFF0000
Global Const MAGENTA = &HFF00FF
Global Const CYAN = &HFFFF00
Global Const WHITE = &HFFFFFF

' BackColor, ForeColor, FillColor (system colors: form, controls)
Global Const SCROLL_BARS = &H80000000           ' Scroll-bars gray area.
Global Const DESKTOP = &H80000001               ' Desktop.
Global Const ACTIVE_TITLE_BAR = &H80000002      ' Active window caption.
Global Const INACTIVE_TITLE_BAR = &H80000003    ' Inactive window caption.
Global Const MENU_BAR = &H80000004              ' Menu background.
Global Const WINDOW_BACKGROUND = &H80000005     ' Window background.
Global Const WINDOW_FRAME = &H80000006          ' Window frame.
Global Const MENU_TEXT = &H80000007             ' Text in menus.
Global Const WINDOW_TEXT = &H80000008           ' Text in windows.
Global Const TITLE_BAR_TEXT = &H80000009        ' Text in caption, size box, scroll-bar arrow box..
Global Const ACTIVE_BORDER = &H8000000A         ' Active window border.
Global Const INACTIVE_BORDER = &H8000000B       ' Inactive window border.
Global Const APPLICATION_WORKSPACE = &H8000000C ' Background color of multiple document interface (MDI) applications.
Global Const HIGHLIGHT = &H8000000D             ' Items selected item in a control.
Global Const HIGHLIGHT_TEXT = &H8000000E        ' Text of item selected in a control.
Global Const BUTTON_FACE = &H8000000F           ' Face shading on command buttons.
Global Const BUTTON_SHADOW = &H80000010         ' Edge shading on command buttons.
Global Const GRAY_TEXT = &H80000011             ' Grayed (disabled) text.  This color is set to 0 if the current display driver does not support a solid gray color.
Global Const BUTTON_TEXT = &H80000012           ' Text on push buttons.

' BorderStyle (form, label, picture box, text box)
Global Const NONE = 0              ' 0 - None
Global Const FIXED_SINGLE = 1          ' 1 - Fixed Single
Global Const SIZABLE = 2           ' 2 - Sizable (Forms only)
Global Const FIXED_DOUBLE = 3          ' 3 - Fixed Double (Forms only)

' DragMode (controls)
Global Const MANUAL = 0                ' 0 - Manual
Global Const AUTOMATIC = 1             ' 1 - Automatic

' DrawMode (form, picture box, Printer)
Global Const BLACKNESS = 1             ' 1 - Blackness
Global Const NOT_MERGE_PEN = 2         ' 2 - Not Merge Pen
Global Const MASK_NOT_PEN = 3          ' 3 - Mask Not Pen
Global Const NOT_COPY_PEN = 4          ' 4 - Not Copy Pen
Global Const MASK_PEN_NOT = 5          ' 5 - Mask Pen Not
Global Const INVERT = 6                ' 6 - Invert
Global Const XOR_PEN = 7               ' 7 - Xor Pen
Global Const NOT_MASK_PEN = 8          ' 8 - Not Mask Pen
Global Const MASK_PEN = 9              ' 9 - Mask Pen
Global Const NOT_XOR_PEN = 10          ' 10 - Not Xor Pen
Global Const NOP = 11                  ' 11 - Nop
Global Const MERGE_NOT_PEN = 12        ' 12 - Merge Not Pen
Global Const COPY_PEN = 13             ' 13 - Copy Pen
Global Const MERGE_PEN_NOT = 14        ' 14 - Merge Pen Not
Global Const MERGE_PEN = 15            ' 15 - Merge Pen
Global Const WHITENESS = 16            ' 16 - Whiteness

' DrawStyle (form, picture box, Printer)
Global Const SOLID = 0                 ' 0 - Solid
Global Const DASH = 1                  ' 1 - Dash
Global Const DOT = 2                   ' 2 - Dot
Global Const DASH_DOT = 3              ' 3 - Dash-Dot
Global Const DASH_DOT_DOT = 4          ' 4 - Dash-Dot-Dot
Global Const INVISIBLE = 5             ' 5 - Invisible
Global Const INSIDE_SOLID = 6          ' 6 - Inside Solid

' FillStyle (form, picture box, Printer)
' Global Const SOLID = 0               ' 0 - Solid
Global Const TRANSPARENT = 1           ' 1 - Transparent
Global Const HORIZONTAL_LINE = 2       ' 2 - Horizontal Line
Global Const VERTICAL_LINE = 3         ' 3 - Vertical Line
Global Const UPWARD_DIAGONAL = 4       ' 4 - Upward Diagonal
Global Const DOWNWARD_DIAGONAL = 5     ' 5 - Downward Diagonal
Global Const CROSS = 6                 ' 6 - Cross
Global Const DIAGONAL_CROSS = 7        ' 7 - Diagonal Cross

' LinkMode (controls)
' Global Const NONE = 0                ' 0 - None
Global Const HOT = 1                   ' 1 - Hot
Global Const COLD = 2                  ' 2 - Cold

' LinkMode (form)
' Global Const NONE = 0                ' 0 - None
Global Const SERVER = 1                ' 1 - Server

' MousePointer (form, controls)
Global Const DEFAULT = 0           ' 0 - Default
Global Const ARROW = 1             ' 1 - Arrow
Global Const CROSSHAIR = 2         ' 2 - Cross
Global Const IBEAM = 3             ' 3 - I-Beam
Global Const ICON_POINTER = 4          ' 4 - Icon
Global Const SIZE_POINTER = 5          ' 5 - Size
Global Const SIZE_NE_SW = 6        ' 6 - Size NE SW
Global Const SIZE_N_S = 7          ' 7 - Size N S
Global Const SIZE_NW_SE = 8        ' 8 - Size NW SE
Global Const SIZE_W_E = 9          ' 9 - Size W E
Global Const UP_ARROW = 10         ' 10 - Up Arrow
Global Const HOURGLASS = 11        ' 11 - Hourglass
Global Const NO_DROP = 12              ' 12 - No drop

' ScaleMode (form, picture box, Printer)
Global Const USER = 0                  ' 0 - User
Global Const TWIPS = 1                 ' 1 - Twip
Global Const POINTS = 2                ' 2 - Point
Global Const PIXELS = 3                ' 3 - Pixel
Global Const CHARACTERS = 4            ' 4 - Character
Global Const INCHES = 5                ' 5 - Inch
Global Const MILLIMETERS = 6           ' 6 - Millimeter
Global Const CENTIMETERS = 7           ' 7 - Centimeter

' ScrollBar (text box)
' Global Const NONE = 0                ' 0 - None
Global Const HORIZONTAL = 1            ' 1 - Horizontal
Global Const VERTICAL = 2              ' 2 - Vertical
Global Const BOTH = 3                  ' 3 - Both

' Value (check box)
Global Const UNCHECKED = 0             ' 0 - Unchecked
Global Const CHECKED = 1               ' 1 - Checked
Global Const GRAYED = 2                ' 2 - Grayed

' WindowState (form)
Global Const NORMAL = 0                ' 0 - Normal
Global Const MINIMIZED = 1             ' 1 - Minimized
Global Const MAXIMIZED = 2             ' 2 - Maximized

